CREATE TABLE IF NOT EXISTS `#__hikaserial_config` (
	`config_namekey` varchar(200) NOT NULL,
	`config_value` text NOT NULL,
	`config_default` text NOT NULL,
 	PRIMARY KEY (`config_namekey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_pack` (
	`pack_id` INT(10) NOT NULL AUTO_INCREMENT,
	`pack_name` VARCHAR(255) NOT NULL,
	`pack_data` VARCHAR(255) NOT NULL DEFAULT 'sql',
	`pack_generator` VARCHAR(255) NOT NULL DEFAULT '',
	`pack_published` INT(4) NOT NULL DEFAULT 0,
	`pack_type` VARCHAR(20) NOT NULL DEFAULT 'serial',
	`pack_group_id` INT(10) NOT NULL DEFAULT 0,
	`pack_vendor_id` INT(10) NOT NULL DEFAULT 0,
	`pack_manage_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	`pack_email_inherit` INT(4) NOT NULL DEFAULT 1,
	`pack_params` TEXT NULL,
	`pack_description` TEXT NULL,
	PRIMARY KEY (`pack_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_serial` (
	`serial_id` INT(10) NOT NULL AUTO_INCREMENT,
	`serial_pack_id` INT(10) NOT NULL,
	`serial_data` TEXT NOT NULL,
	`serial_extradata` TEXT NOT NULL,
	`serial_status` VARCHAR(255) NOT NULL,
	`serial_assign_date` INT(10) NULL,
	`serial_consume_date` INT(10) NULL,
	`serial_order_id` INT(10) NULL,
	`serial_user_id` INT(10) NULL,
	`serial_order_product_id` INT(10) NULL,
	PRIMARY KEY (`serial_id`),
	KEY `serial_pack_id` (`serial_pack_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_subscription` (
	`subscription_id` INT(10) NOT NULL AUTO_INCREMENT,
	`subscription_pack_id` INT(10) NOT NULL,
	`subscription_data` TEXT NOT NULL,
	`subscription_extradata` TEXT NOT NULL,
	`subscription_status` VARCHAR(255) NOT NULL,
	`subscription_created` INT(10) NOT NULL DEFAULT 0,
	`subscription_modified` INT(10) NOT NULL DEFAULT 0,
	`subscription_start_date` INT(10) NOT NULL DEFAULT 0,
	`subscription_end_date` INT(10) NOT NULL DEFAULT 0,
	`subscription_user_id` INT(10) NULL,
	`subscription_auto_renew` INT(4) NOT NULL DEFAULT 0,
	`subscription_payment_renew` TEXT NULL,
	PRIMARY KEY (`subscription_id`),
	KEY `subscription_pack_id` (`subscription_pack_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_order_subscription` (
	`order_subscription_id` INT(10) NOT NULL AUTO_INCREMENT,
	`subscription_id` INT(10) NOT NULL,
	`order_id` INT(10) NOT NULL,
	`order_product_id` INT(10) NULL,
	`order_product_quantity` INT(10) NULL,
	`subscription_validated` INT(10) NULL,
	`subscription_duration` VARCHAR(25) NULL,
	`plan_id` INT(10) NULL,
	`upgrade_id` INT(10) NULL,
	`upgrade_duration` INT(11) NULL,
	PRIMARY KEY (`order_subscription_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_subscription_history` (
	`history_id` INT(10) NOT NULL AUTO_INCREMENT,
	`history_subscription_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`history_created` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`history_ip` VARCHAR(255) NOT NULL DEFAULT '',
	`history_new_status` VARCHAR(255) NOT NULL DEFAULT '',
	`history_type` VARCHAR(255) NOT NULL DEFAULT '',
	`history_data` TEXT NOT NULL DEFAULT '',
	`history_user_id` INT(10) UNSIGNED DEFAULT '0',
	PRIMARY KEY (`history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_product_pack` (
	`product_id` INT(10) NOT NULL,
	`pack_id` INT(10) NOT NULL,
	`quantity` INT(10) NOT NULL DEFAULT 1,
	`relation_type` VARCHAR(20) NULL,
	`relation_duration` VARCHAR(25) NOT NULL DEFAULT 0,
	`relation_upgrade` INT(10) NULL,
	PRIMARY KEY (`pack_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_generator` (
	`generator_id` INT(10) NOT NULL AUTO_INCREMENT,
	`generator_type` VARCHAR(255) NOT NULL,
	`generator_published` INT(4) NOT NULL DEFAULT 0,
	`generator_name` VARCHAR(255) NOT NULL,
	`generator_ordering` INT(10) NOT NULL DEFAULT 0,
	`generator_description` TEXT NOT NULL DEFAULT '',
	`generator_params` TEXT NOT NULL DEFAULT '',
	`generator_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	PRIMARY KEY (`generator_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_consumer` (
	`consumer_id` INT(10) NOT NULL AUTO_INCREMENT,
	`consumer_type` VARCHAR(255) NOT NULL,
	`consumer_published` INT(4) NOT NULL DEFAULT 0,
	`consumer_name` VARCHAR(255) NOT NULL,
	`consumer_ordering` INT(10) NOT NULL DEFAULT 0,
	`consumer_description` TEXT NOT NULL DEFAULT '',
	`consumer_params` TEXT NOT NULL DEFAULT '',
	`consumer_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	PRIMARY KEY (`consumer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_plugin` (
	`plugin_id` INT(10) NOT NULL AUTO_INCREMENT,
	`plugin_type` VARCHAR(255) NOT NULL,
	`plugin_published` INT(4) NOT NULL DEFAULT 0,
	`plugin_name` VARCHAR(255) NOT NULL,
	`plugin_ordering` INT(10) NOT NULL DEFAULT 0,
	`plugin_description` TEXT NOT NULL DEFAULT '',
	`plugin_params` TEXT NOT NULL DEFAULT '',
	`plugin_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	PRIMARY KEY (`plugin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_subscriber` (
	`subscriber_id` INT(10) NOT NULL AUTO_INCREMENT,
	`subscriber_type` VARCHAR(255) NOT NULL,
	`subscriber_published` INT(4) NOT NULL DEFAULT 0,
	`subscriber_name` VARCHAR(255) NOT NULL,
	`subscriber_ordering` INT(10) NOT NULL DEFAULT 0,
	`subscriber_description` TEXT NOT NULL DEFAULT '',
	`subscriber_params` TEXT NOT NULL DEFAULT '',
	`subscriber_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	PRIMARY KEY (`subscriber_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_history` (
	`history_id` INT(10) NOT NULL AUTO_INCREMENT,
	`history_serial_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`history_created` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`history_ip` VARCHAR(255) NOT NULL DEFAULT '',
	`history_new_status` VARCHAR(255) NOT NULL DEFAULT '',
	`history_type` VARCHAR(255) NOT NULL DEFAULT '',
	`history_data` TEXT NOT NULL DEFAULT '',
	`history_user_id` INT(10) UNSIGNED DEFAULT '0',
	PRIMARY KEY (`history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_pack_email` (
	`pack_email_id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	`pack_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
	`pack_email_type` varchar(255) NOT NULL DEFAULT 'renewal',
	`pack_email_days` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`pack_email_template` varchar(255) NOT NULL DEFAULT '',
	`pack_email_params` TEXT NOT NULL DEFAULT '',
 	PRIMARY KEY (`pack_email_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_pack_group` (
	`pack_group_id` INT(10) NOT NULL AUTO_INCREMENT,
	`pack_group_name` VARCHAR(255) NOT NULL,
	`pack_group_published` INT(4) NOT NULL DEFAULT 1,
	`pack_group_vendor_id` INT(10) NOT NULL DEFAULT 0,
	`pack_group_manage_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	`pack_group_exclusive` INT(4) NOT NULL DEFAULT 0,
	`pack_group_description` TEXT NULL,
	`pack_group_access` VARCHAR(255) NOT NULL DEFAULT 'all',
	PRIMARY KEY (`pack_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__hikaserial_queue` (
	`queue_id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	`queue_created` INT(11) NOT NULL DEFAULT 0,
	`queue_lock` INT(11) NOT NULL DEFAULT 0,
	`queue_subscription_id` INT(10) UNSIGNED NOT NULL,
	`queue_email_id` INT(11) NOT NULL DEFAULT '0',
	`queue_type` varchar(255) NOT NULL DEFAULT '',
	`queue_data` varchar(1024) NOT NULL DEFAULT '',
 	PRIMARY KEY (`queue_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
