<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialCheckoutClass extends hikaserialClass {
	public function onCheckoutWorkflowLoad(&$workflow, &$shop_closed, $cart_id, $cart) {
		if($cart->cart_type != 'subscription')
			return;

		foreach($workflow['steps'] as &$step) {
			foreach($step['content'] as &$block) {
				if($block['task'] == 'cart') {
					if(empty($block['params']))
						$block['params'] = array();
					$block['params']['status'] = true;
				}
			}
			unset($block);
		}
		unset($step);
	}

	public function afterCheckoutStep($controllerName, &$go_back, $original_go_back, &$controller) {
		$shopConfig = hikaserial::config(false);
		$legacy_checkout = (int)$shopConfig->get('checkout_legacy', 0);

		if($controllerName == 'plg.serial.coupon') {
			if($legacy_checkout)
				return $this->afterCouponCheckoutStepLegacy($go_back, $original_go_back, $controller);
			return $this->afterCouponCheckoutStep($go_back, $original_go_back, $controller);
		}
		return true;
	}

	private function afterCouponCheckoutStep(&$go_back, $original_go_back, &$controller) {
		$app = JFactory::getApplication();

		$checkout = hikaInput::get()->get('checkout', array(), 'array');
		$coupon = null;
		$qty = 1;

		if(isset($checkout['coupon']) && is_string($checkout['coupon']))
			$coupon = $checkout['coupon'];
		if(isset($checkout['serialcoupon']) && is_string($checkout['serialcoupon']))
			$coupon = $checkout['serialcoupon'];

		if(empty($coupon)) {
			if(isset($checkout['removecoupon']) && is_string($checkout['removecoupon']))
				$coupon = $checkout['removecoupon'];
			if(isset($checkout['removeserialcoupon']) && is_string($checkout['removeserialcoupon']))
				$coupon = $checkout['removeserialcoupon'];
			$qty = 0;
		}
		$coupon = trim($coupon);

		if(empty($coupon))
			return true;

		$go_back = true;

		$config = hikaserial::config();
		$shopConfig = hikaserial::config(false);
		$user_id = hikaserial::loadUser();
		$serialClass = hikaserial::get('class.serial');
		$checkoutHelper = hikashopCheckoutHelper::get();
		$serial = null;
		$serials = null;
		if(is_string($coupon))
			$serials = $serialClass->find($coupon, null, array('serial_user_id DESC', 'serial_id ASC'));

		if(count($serials) == 1) {
			$serial = reset($serials);
		} else if(!empty($serials)) {
			$assigned_status = $config->get('assigned_serial_status', 'assigned');
			foreach($serials as $s) {
				if(($s->serial_user_id == $user_id || $s->serial_user_id ==  0 || $user_id == 0) && ($s->serial_status == $assigned_status)) {
					$serial = $s;
				}
				if($serial != null)
					break;
			}
		}

		if(!empty($serial) && !empty($serial->serial_id)) {
			if(empty($user_id) && $config->get('forbidden_consume_guest', 1)) {
				$checkoutHelper->addMessage('serialcoupon.invalid', array(
					JText::_('CONSUME_NOT_LOGGED'),
					'error'
				));
				return false;
			}

			if($serialClass->consume($serial->serial_id, null, false)) {
				$full_serial = $serialClass->get($serial->serial_id);
				$msg = JText::sprintf('SERIAL_CHECKOUT_X_CONSUMED', $coupon);
				if(!empty($msg)) {
					$checkoutHelper->addMessage('serialcoupon.success', array(
						$msg,
						'success'
					));
				}
				return true;
			}
		}

		$cart = $checkoutHelper->getCart();
		$cartClass = hikaserial::get('shop.class.cart');

		if($qty == 1) {
			$coupon_ret = $cartClass->addCoupon($cart->cart_id, $coupon);
			$msg = 'COUPON_ADDED';
		} else {
			$coupon_ret = $cartClass->removeCoupon($cart->cart_id, $cart->cart_coupon);
			$msg = 'COUPON_REMOVED';
		}
		$cart = $checkoutHelper->getCart(true);

		if(!empty($coupon_ret)) {
			if(@$params['src']['context'] == 'submitstep') {
				$checkoutHelper->addMessage('serialcoupon.success', array(
					JText::_($msg),
					'success'
				));
			}
			return true;
		}

		$error_message = hikaInput::get()->getVar('coupon_error_message', '');
		if(empty($error_message))
			$error_message = JText::_('COUPON_NOT_VALID');

		$checkoutHelper->addMessage('serialcoupon.invalid', array(
			$error_message,
			'error'
		));
		return false;
	}

	private function afterCouponCheckoutStepLegacy(&$go_back, $original_go_back, &$controller) {
		$app = JFactory::getApplication();

		$coupon = hikaInput::get()->getString('hikaserial_coupon', '');
		$qty = 1;

		if(empty($coupon)) {
			$coupon = hikaInput::get()->getInt('removecoupon', 0);
			$qty = 0;
		}

		$coupon = trim($coupon);

		if(empty($coupon))
			return true;

		$go_back = true;

		$config = hikaserial::config();
		$shopConfig = hikaserial::config(false);
		$user_id = hikaserial::loadUser();
		$serialClass = hikaserial::get('class.serial');
		$serial = null;
		$serials = null;
		if(is_string($coupon))
			$serials = $serialClass->find($coupon, null, array('serial_user_id DESC', 'serial_id ASC'));

		if(count($serials) == 1) {
			$serial = reset($serials);
		} else if(!empty($serials)) {
			$assigned_status = $config->get('assigned_serial_status', 'assigned');
			foreach($serials as $s) {
				if(($s->serial_user_id == $user_id || $s->serial_user_id ==  0 || $user_id == 0) && ($s->serial_status == $assigned_status)) {
					$serial = $s;
				}
				if($serial != null)
					break;
			}
		}

		$consume_ret = false;
		if(!empty($serial) && !empty($serial->serial_id)) {
			if(empty($user_id) && $config->get('forbidden_consume_guest', 1)) {
				$app->enqueueMessage(JText::_('CONSUME_NOT_LOGGED'), 'error');
			} else {
				$consume_ret = $serialClass->consume($serial->serial_id, null, false);
				if($consume_ret) {
					$full_serial = $serialClass->get($serial->serial_id);
					$msg = JText::sprintf('SERIAL_CHECKOUT_X_CONSUMED', $coupon);
					if(!empty($msg))
						$app->enqueueMessage($msg, 'success');
				}
			}
		}

		$checkout_workflow = trim($shopConfig->get('checkout','login_address_shipping_payment_coupon_cart_status_confirm,end'));

		$cart = $controller->initCart();
		$coupon_ret = false;
		if(empty($cart->coupon) || ($coupon === 1 && $qty == 0)) {
			$cartClass = hikaserial::get('shop.class.cart');
			if($cartClass->update($coupon, $qty, 0, 'coupon')) {
				if(strpos($checkout_workflow, 'shipping') !==false) {
					$controller->before_shipping(true);
				}
				if(strpos($checkout_workflow, 'payment') !== false) {
					$controller->before_payment(true);
				}
				$controller->initCart(true);
				$controller->cart_update = true;
				$coupon_ret = true;
			}
		}

		if(!$coupon_ret && !$consume_ret) {
			$msg = JText::sprintf('SERIAL_CHECKOUT_UNKNOWN_CODE', $coupon);
			if(!empty($msg))
				$app->enqueueMessage($msg, 'error');
		}

		return false;
	}
}
