<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialDownloadClass extends hikaserialClass {

	protected function getOrderFileSerials(&$file) {
		if(empty($file->order_id) && hikaserial::isAdmin())
			$file->order_id = hikaInput::get()->getInt('order_id', 0);

		if(empty($file->order_id))
			return false;

		$config = hikaserial::config();
		$display_serial_statuses = $config->get('display_serial_statuses','');
		if(empty($display_serial_statuses)) {
			$display_serial_statuses = explode(',', $config->get('used_serial_status','assigned,used'));
		} else {
			$display_serial_statuses = explode(',', $display_serial_statuses);
		}
		$statuses = array();
		foreach($display_serial_statuses as $s) {
			$statuses[] = $this->db->Quote($s);
		}

		$query = 'SELECT s.*, p.*, op.product_id '.
			' FROM ' . hikaserial::table('serial') . ' AS s '.
			' INNER JOIN ' . hikaserial::table('pack') . ' AS p ON s.serial_pack_id = p.pack_id '.
			' LEFT JOIN ' . hikaserial::table('shop.order_product') . ' AS op ON op.order_product_id = s.serial_order_product_id AND op.order_id = s.serial_order_id '.
			' LEFT JOIN ' . hikaserial::table('shop.product') . ' AS product ON product.product_id = op.product_id '.
			' WHERE s.serial_status IN ('.implode(',', $statuses).') AND s.serial_order_id = '. $file->order_id .
				' AND (product.product_id = ' . $file->file_ref_id . ' OR product.product_parent_id = ' . $file->file_ref_id . ' OR op.product_id IS NULL) ' .
			' ORDER BY s.serial_id';
		$this->db->setQuery($query);
		return $this->db->loadObjectList();
	}

	public function beforeDownloadFile(&$filename, &$do, &$file) {
		$f12 = '';
		if(strlen($filename) >= 12)
			$f12 = substr($filename, 0, 12);
		if(!in_array($f12, array('@hikaserial:', '#hikaserial:')))
			return;
		$do = false;

		$serials = $this->getOrderFileSerials($file);
		if( !empty($serials)) {
			JPluginHelper::importPlugin('hikaserial');
			$dispatcher = hikaserial::getDispatcher();
			$dispatcher->trigger('onDisplaySerials', array(&$serials, 'beforeDownloadFile'));
			$dispatcher->trigger('onBeforeSerialDownloadFile', array(&$filename, &$do, &$file, &$serials));
		}
		$subscriptions = $this->getOrderFileSubscriptions($file);
		if( !empty($subscriptions)) {
			JPluginHelper::importPlugin('hikaserial');
			$dispatcher = hikaserial::getDispatcher();
			$dispatcher->trigger('onBeforeSubscriptionDownloadFile', array(&$filename, &$do, &$file, &$subscriptions));
		}

	}
	protected function getOrderFileSubscriptions(&$file) {
		if(empty($file->order_id) && hikaserial::isAdmin())
			$file->order_id = hikaInput::get()->getInt('order_id', 0);

		if(empty($file->order_id))
			return false;

		$query = 'SELECT s.*, p.*, os.*, op.product_id '.
			' FROM ' . hikaserial::table('subscription') . ' AS s '.
			' INNER JOIN ' . hikaserial::table('pack') . ' AS p ON s.subscription_pack_id = p.pack_id '.
			' LEFT JOIN ' . hikaserial::table('order_subscription') . ' AS os ON os.subscription_id = s.subscription_id '.
			' LEFT JOIN ' . hikaserial::table('shop.order_product') . ' AS op ON op.order_product_id = os.order_product_id AND op.order_id = os.order_id '.
			' LEFT JOIN ' . hikaserial::table('shop.product') . ' AS product ON product.product_id = op.product_id '.
			' WHERE s.subscription_status = '.$this->db->Quote('active').' AND os.order_id = '. (int)$file->order_id .
				' AND (product.product_id = ' . $file->file_ref_id . ' OR product.product_parent_id = ' . $file->file_ref_id . ' OR op.product_id IS NULL) '.
			' ORDER BY os.subscription_id';
		$this->db->setQuery($query);
		return $this->db->loadObjectList();
	}

	public function downloadSubscriptionFile($file_id, $subscription) {
		$app = JFactory::getApplication();
		$fileClass = hikaserial::get('shop.class.file');

		$file = $fileClass->get($file_id);
		if(empty($file) || $file->file_type != 'plan') {
			$app->enqueueMessage(JText::_('FILE_NOT_FOUND'), 'error');
			return 'no_file';
		}

		if(!is_object($subscription)) {
			$subscription_id = (int)$subscription;

			$subscriptionClass = hikaserial::get('class.subscription');
			$subscription = $subscriptionClass->get($subscription_id);
		}

		if(empty($subscription) || empty($subscription->subscription_pack_id)) {
			$app->enqueueMessage(JText::_('HIKASERIAL_INVALID_DATA'), 'error');
			return 'invalid_data';
		}

		if(empty($subscription->plan)) {
			$packClass = hikaserial::get('class.pack');
			$subscription->plan = $packClass->get( (int)$subscription->subscription_pack_id );
		}
		if(empty($subscription->plan) || empty($subscription->plan->pack_published)) {
			$app->enqueueMessage(JText::_('HIKASERIAL_INVALID_DATA'), 'error');
			return 'invalid_data';
		}

		$query = 'SELECT * FROM '.hikaserial::table('shop.file').
			' WHERE file_type = '.$this->db->Quote('plan').
				' AND file_ref_id = '.(int)$subscription->subscription_pack_id.
				' AND file_id = '.(int)$file_id;
		$this->db->setQuery($query);
		$file = $this->db->loadObject();
		if(empty($file)) {
			$app->enqueueMessage(JText::_('HIKASERIAL_INVALID_DATA'), 'error');
			return 'invalid_data';
		}

		$hkUser = hikaserial::loadUser(true);
		$now = time();
		$valid_subscription = ($subscription->subscription_status == 'active' && ($subscription->subscription_end_date == 0 || $subscription->subscription_end_date > $now));

		$do = (hikaserial::isAdmin() || (
			$valid_subscription && !empty($subscription->subscription_user_id) && !empty($hkUser) && (int)$subscription->subscription_user_id == (int)$hkUser->user_id
		));

		JPluginHelper::importPlugin('hikaserial');
		$dispatcher = hikaserial::getDispatcher();
		$dispatcher->trigger('onSubscriptionDownloadAuthorizationCheck', array($subscription, $file, $hkUser, &$do));

		if($do !== true) {
			if($do === false)
				$app->enqueueMessage(JText::_('HIKASERIAL_INVALID_DATA'), 'error');
			return $do;
		}

		if(!$valid_subscription) {
			$app->enqueueMessage(JText::_('HIKA_SUBSCRIPTION_EXPIRED_FOR_ACTION'), 'error');
			return 'expired_subscription';
		}

		$path = $fileClass->getPath('file');
		$prefix = substr($file->file_path, 0, 1);
		if(substr($file->file_path, 0, 7) != 'http://' && substr($file->file_path, 0, 8) != 'https://'
		  && !in_array($prefix, array('@','#'))
		  && !file_exists($path . $file->file_path) && !file_exists($file->file_path)
		 ) {
			$app->enqueueMessage(JText::_('FILE_NOT_FOUND'), 'error');
			return 'no_file';
		}

		$fileClass->sendFile($file, true, $path);
		return true;
	}
}
