<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialFileClass extends hikaserialClass {
	protected $tables = array('shop.file');
	protected $pkeys = array('file_id');

	public function saveForm() {
		$app = JFactory::getApplication();
		$shopFileClass = hikaserial::get('shop.class.file');
		$shopConfig = hikaserial::config(false);

		$file = new stdClass();
		$file->file_id = hikaserial::getCID('file_id');

		$formData = hikaInput::get()->get('data', array(), 'array');
		foreach($formData['file'] as $column => $value){
			hikashop_secureField($column);
			$file->$column = strip_tags($value);
		}
		unset($file->file_path);

		$filemode = 'upload';
		if(!empty($formData['filemode']))
			$filemode = $formData['filemode'];
		if(!empty($file->file_id))
			$filemode = null;

		if(!empty($file->file_id))
			$file->old = $this->get($file->file_id);

		hikaInput::get()->set('cid', 0);

		$secure_path = $shopFileClass->getPath('file');

		if($filemode === 'upload') {
			if(is_array($ids) && !empty($ids)) {
				$file->file_id = array_shift($ids);
				if(isset($file->file_path))
					unset($file->file_path);
			} else
				return false;
		} else {
			if(isset($formData['filepath']))
				$file->file_path = trim($formData['filepath']);
			if(isset($formData['file']['file_path']))
				$file->file_path = trim($formData['file']['file_path']);

			$store_locally = $shopConfig->get('store_external_files_locally', 0);
			if(isset($formData['download']))
				$store_locally = (int)$formData['download'];
			if($store_locally && empty($file->file_id) && (substr($file->file_path, 0, 7) == 'http://' || substr($file->file_path, 0, 8) == 'https://')) {
				$file->file_path = $this->downloadExternalFile($file->file_path, $secure_path);
			}
		}

		if(isset($file->file_path)) {
			if(strpos($file->file_path, '..') !== false) {
				$app->enqueueMessage('Invalid data', 'error');
				return false;
			}

			$firstChar = substr($file->file_path, 0, 1);
			$isVirtual = in_array($firstChar, array('#', '@'));
			$isLink = (substr($file->file_path, 0, 7) == 'http://' || substr($file->file_path, 0, 8) == 'https://');

			if(!$isLink && !$isVirtual) {
				if($firstChar == '/' || preg_match('#:[\/\\\]{1}#', $file->file_path)) {
					$clean_filename = JPath::clean($file->file_path);
					if((JPATH_ROOT != '') && strpos($clean_filename, JPath::clean(JPATH_ROOT)) !== 0 && strpos($clean_filename, JPath::clean($secure_path)) !== 0) {
						$app->enqueueMessage('The file path you entered is an absolute path but it is outside of your upload folder: '.JPath::clean($secure_path), 'error');
						return false;
					}

					if(!file_exists($file->file_path)) {
						$app->enqueueMessage('The file path you entered is an absolute path but it doesn\'t exist.', 'error');
						return false;
					}
				} else {
					$clean_filename = JPath::clean($secure_path . '/' . $file->file_path);
					if(!JFile::exists($clean_filename) && (JPATH_ROOT == '' || !JFile::exists(JPATH_ROOT . DS . $clean_filename))) {
						$app->enqueueMessage('File does not exists', 'error');
						return false;
					}
				}
			}
		}

		if(isset($file->file_ref_id) && empty($file->file_ref_id))
			unset($file->file_ref_id);

		if(isset($file->file_limit)) {
			$limit = (int)$file->file_limit;
			if($limit == 0 && $file->file_limit !== 0 && $file->file_limit != '0')
				$file->file_limit = -1;
			else
				$file->file_limit = $limit;
		}

		JPluginHelper::importPlugin('hikashop');
		$dispatcher = hikaserial::getDispatcher();

		$do = true;
		$dispatcher->trigger('onHikaBeforeFileSave', array(&$file, &$do));
		if(!$do)
			return false;

		if(empty($file->file_path) && empty($file->file_id)) {
			return false;
		}

		$status = $this->save($file);
		if(empty($file->file_id)) {
			$file->file_id = $status;
		}
		hikaInput::get()->set('cid', $file->file_id);

		$dispatcher->trigger('onHikaAfterFileSave', array(&$file));

		return $file->file_id;
	}

	private function downloadExternalFile($url, $path) {
		$parts = explode('/', $url);
		$name = array_pop($parts);

		if(!file_exists($path . $name)) {
			$data = @file_get_contents($url);
			if(empty($data)) {
				$app = JFactory::getApplication();
				$app->enqueueMessage('The file could not be retrieved.');
				return false;
			}

			JFile::write($path . $name, $data);
			unset($data);

			return $name;
		}

		$size = $this->getExternalSizeFile($url);
		if($size == filesize($path . $name))
			return $name;

		$name = $size . '_' . $name;
		if(file_exists($path . $name))
			return $name;

		$data = @file_get_contents($url);
		if(empty($data)) {
			$app = JFactory::getApplication();
			$app->enqueueMessage('The file could not be retrieved.');
			return false;
		}
		JFile::write($path . $name, $data);
		unset($data);

		return $name;
	}

	private function getExternalSizeFile($url) {
		if(substr($url, 0, 4) != 'http')
			return @filesize($url);

		static $regex = '/^Content-Length: *+\K\d++$/im';
		if(!$fp = @fopen($url, 'rb'))
			return false;

		if( isset($http_response_header) && preg_match($regex, implode("\n", $http_response_header), $matches))
			return (int)$matches[0];
		return strlen(stream_get_contents($fp));
	}
}
