<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialMenuClass extends hikaserialClass {

	protected $tables = array();
	protected $pkeys = array();
	protected $toggle = array();

	public function processView(&$view) {
		if(empty($view->menus))
			return;

		$currentuser = JFactory::getUser();
		if(!$currentuser->authorise('core.manage', 'com_hikaserial'))
			return;

		$display_serial_features = true;
		if(hikaserial::level(1)) {
			$config = hikaserial::config();
			$display_serial_features = (int)$config->get('serial_features', true);
		}

		$market = array(
			'name' => HIKASERIAL_NAME,
			'check' => 'ctrl=config',
			'acl' => 'config',
			'task' => 'manage',
			'icon' => 'fas fa-key',
			'url' => hikaserial::completeLink('dashboard'),
			'children' => array(
				array(
					'name' => JText::_('HIKA_CONFIGURATION'),
					'check' => 'ctrl=config',
					'acl' => 'config',
					'task' => 'manage',
					'icon' => 'fa fa-wrench',
					'url' => hikaserial::completeLink('config'),
					'display' => $currentuser->authorise('core.admin', 'com_hikaserial')
				),
				array(
					'name' => JText::_('PLUGINS'),
					'check' => 'ctrl=plugins',
					'icon' => 'fa fa-puzzle-piece',
					'url' => hikaserial::completeLink('plugins')
				),
				array(
					'name' => JText::_('VIEWS'),
					'check' => 'ctrl=views',
					'icon' => 'fa fa-file-code',
					'url' => hikaserial::completeLink('shop.view&component='.HIKASERIAL_COMPONENT)
				),
				array('name' => ''),
				array(
					'name' => JText::_('HIKA_SERIAL_PLANS'),
					'check' =>'ctrl=plan',
					'icon' => 'far fa-address-card',
					'url' => hikaserial::completeLink('plan')
				),
				array(
					'name' => JText::_('HIKA_SUBSCRIPTIONS'),
					'check' =>'ctrl=subscription',
					'icon' => 'far fa-clock',
					'url' => hikaserial::completeLink('subscription')
				),
				array('name' => ''),
				array(
					'name' => JText::_('HIKA_PACKS'),
					'check' =>'ctrl=pack&type=serial',
					'icon' => 'fas fa-cube',
					'url' => hikaserial::completeLink('pack&type=serial'),
					'display' => $display_serial_features
				),
				array(
					'name' => JText::_('HIKA_SERIALS'),
					'check' =>'ctrl=serial',
					'icon' => 'fas fa-key',
					'url' => hikaserial::completeLink('serial'),
					'display' => $display_serial_features
				),
				array(
					'name' => JText::_('IMPORT'),
					'check' => 'ctrl=import',
					'icon' => 'fas fa-download',
					'url' => hikaserial::completeLink('import')
				),
				array('name' => ''),
				array(
					'name' => JText::_('DOCUMENTATION'),
					'check' => 'ctrl=documentation',
					'icon' => 'fa fa-life-ring',
					'url' => hikaserial::completeLink('documentation')
				),
				array(
					'name' => JText::_('UPDATE_ABOUT'),
					'check' => 'ctrl=update',
					'icon' => 'fa fa-sync',
					'url' => hikaserial::completeLink('update')
				),
				array(
					'name' => JText::_('FORUM'),
					'check' => 'support/forum.html',
					'icon' => 'fa fa-info',
					'url' => HIKASERIAL_URL.'support/forum.html'
				)
			)
		);

		$newMenus = array(&$market);
		$this->checkActive($newMenus, 0, HIKASERIAL_COMPONENT);

		$last = array_pop($view->menus);
		array_push($view->menus, $market, $last);
	}

	private function checkActive(&$menus, $level = 0, $default_component = HIKASHOP_COMPONENT) {
		if($level >= 2)
			return;
		$currentComponent = hikaInput::get()->getCmd('option', HIKASHOP_COMPONENT);
		foreach($menus as $k => $menu) {
			if(isset($menu['display']) && !$menu['display']) {
				unset($menus[$k]);
				continue;
			}
			if(empty($menu['check']))
				continue;
			if(is_array($menu['check'])) {
				$component = $menu['check'][0];
				$check = $menu['check'][1];
			} else {
				$check = $menu['check'];
				$component = $default_component;
			}
			if($component == $currentComponent && strpos($_SERVER['QUERY_STRING'], $check) !== false) {
				$menus[$k]['active'] = true;
			}
			if(!empty($menu['children'])) {
				$this->checkActive($menus[$k]['children'], $level+1, $default_component);
			}
		}
	}
}
