<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialPack_groupClass extends hikaserialClass {

	protected $tables = array('pack_group');
	protected $pkeys = array('pack_group_id');
	protected $toggle = array('pack_group_published' => 'pack_group_id');

	public function save(&$element) {
		$newGroup = empty($element->pack_group_id);

		if(!$newGroup)
			$element->old = $this->get($element->pack_group_id);

		$do = true;
		$dispatcher = hikaserial::getDispatcher();
		JPluginHelper::importPlugin('hikaserial');
		JPluginHelper::importPlugin('hikashop');
		if($newGroup)
			$dispatcher->trigger('onBeforePackgroupCreate', array(&$element, &$do));
		else
			$dispatcher->trigger('onBeforePackgroupUpdate', array(&$element, &$do));

		if(!$do)
			return false;
		$ret = parent::save($element);
		if(!$ret)
			return $ret;

		$element->pack_group_id = $ret;

		if($newGroup)
			$dispatcher->trigger('onAfterPackgroupCreate', array(&$element, $ret));
		else
			$dispatcher->trigger('onAfterPackgroupUpdate', array(&$element, $ret));
		return $ret;
	}

	public function saveForm() {
		$pack_group = new stdClass();
		$pack_group->pack_group_id = hikaserial::getCID('pack_group_id');
		$formData = hikaInput::get()->get('data', array(), 'array');
		foreach($formData['pack_group'] as $col => $val) {
			hikaserial::secureField($col);
			$pack_group->$col = strip_tags($val);
		}
		$pack_group->pack_group_description = hikaInput::get()->getRaw('pack_group_description', '');

		$status = $this->save($pack_group);

		if($status) {

		}
		return $status;
	}

	public function delete($elements) {
		if(!is_array($elements)) {
			$elements = array($elements);
		}
		hikaserial::toInteger($elements);

		$query = 'SELECT pack_group_id, count(*) as `cpt` FROM '.hikaserial::table('pack').' WHERE pack_group_id IN ( '.implode(',',$elements).');';
		$this->db->setQuery($query);
		$packGroups = $this->db->loadObjectList();
		$exclude = array();
		foreach($packGroups as $packGroup) {
			if($packGroup->cpt > 0) {
				$exclude[] = $packGroup->pack_group_id;
			}
		}
		if(!empty($exclude)) {
			$elements = array_diff($elements, $exclude);
		}
		return parent::delete($elements);
	}

	public function &getNameboxData($typeConfig, &$fullLoad, $mode, $value, $search, $options) {

		$ret = array(
			0 => array(),
			1 => array()
		);

		$db = JFactory::getDBO();
		$app = JFactory::getApplication();

		$start = 0;
		if(!empty($options['start']))
			$start = $options['start'];

		$limit = (int)@$typeConfig['limit'];
		if(!empty($options['limit']))
			$limit = (int)$options['limit'];
		if(empty($limit))
			$limit = 30;

		$filters = array(
			'published' => 'pack_group_published = 1'
		);

		if(!empty($search)) {
			$searchStr = "'%" . ((HIKASHOP_J30) ? $db->escape($search, true) : $db->getEscaped($search, true) ) . "%'";
			$filters['search'] = 'pack_group_name LIKE ' . $searchStr;
		}

		if(!hikaserial::isAdmin() && hikaserial::initMarket()) {
			$vendor = hikamarket::loadVendor(true);
			if($vendor->vendor_id > 1) {
				$acl = array();
				$accesses = explode(',', $vendor->vendor_access);
				foreach($accesses as $ax) {
					if(substr($ax,0,1) != '@')
						continue;
					$ax_id = (int)substr($ax,1);
					if($ax_id > 0)
						$acl[] = $ax_id;
				}

				if(empty($acl)) {
					$filters['vendor'] = '(pack_group_vendor_id = '.(int)$vendor->vendor_id.') OR (pack_group_vendor_id = 0 AND pack_group_manage_access = \'all\')';
				} else {
					$filters['vendor'] = '(pack_group_vendor_id = '.(int)$vendor->vendor_id.') OR (pack_group_vendor_id = 0 AND (pack_group_manage_access = \'all\' OR pack_group_manage_access LIKE \'%,'.implode(',%\' OR pack_manage_access LIKE \'%,', $acl).',%\'))';
				}
			}
		}

		$query = 'SELECT pack_group_id, pack_group_name '.
			' FROM ' . hikaserial::table('pack_group') .
			' WHERE ('.implode(') AND (', $filters).')'.
			' ORDER BY pack_group_name';

		$db->setQuery($query, $start, $limit);
		$packs = $db->loadObjectList('pack_group_id');

		foreach($packs as $pack) {
			$ret[0][$pack->pack_id] = $pack;
		}

		if(count($packs) == $limit)
			$fullLoad = false;

		if(!empty($value)) {
			if(!is_array($value))
				$value = array($value);

			if($fullLoad) {
				foreach($value as $v) {
					if(isset($ret[0][(int)$v]))
						$ret[1][(int)$v] = $ret[0][(int)$v];
				}
			} else {
				$values = array_merge($value);
				hikaserial::toInteger($values);

				$query = 'SELECT pack_group_id, pack_group_name'.
					' FROM ' . hikaserial::table('pack_group') .
					' WHERE pack_id IN ('.implode(',', $values).') '.
					' ORDER BY pack_group_name';
				$db->setQuery($query);
				$ret[1] = $db->loadObjectList('pack_group_id');
			}
		}

		return $ret;
	}
}
