<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialSubscriptionClass extends hikaserialClass {

	protected $tables = array('subscription');
	protected $pkeys = array('subscription_id');

	public function get($element, $full = false) {
		$ret = parent::get($element);

		if(!empty($ret->subscription_extradata)) {
			$ret->subscription_extradata = hikaserial::unserialize($ret->subscription_extradata);
		}
		if(!empty($ret->subscription_payment_renew)) {
			$ret->subscription_payment_renew = hikaserial::unserialize($ret->subscription_payment_renew);
		}

		if(!$full)
			return $ret;

		if(!empty($ret->subscription_pack_id)) {
			$packClass = hikaserial::get('class.pack');
			$ret->plan = $packClass->get($ret->subscription_pack_id);
		}
		if(!empty($ret->subscription_user_id)) {
			$userClass = hikaserial::get('shop.class.user');
			$ret->user = $userClass->get($ret->subscription_user_id);
		}

		$query = 'SELECT order_subscription.*, hk_order.* FROM ' . hikaserial::table('order_subscription') . ' as order_subscription ' .
			' LEFT JOIN ' . hikaserial::table('shop.order') . ' AS hk_order ON order_subscription.order_id = hk_order.order_id ' .
			' WHERE order_subscription.subscription_id = '. (int)$ret->subscription_id .
			' ORDER BY order_subscription.order_subscription_id ASC';
		$this->db->setQuery($query);
		$ret->orders = $this->db->loadObjectList('order_subscription_id');

		$query = 'SELECT * FROM ' . hikaserial::table('subscription_history') .
			' WHERE history_subscription_id = '. (int)$ret->subscription_id .
			' ORDER BY history_created DESC';
		$this->db->setQuery($query);
		$ret->history = $this->db->loadObjectList();

		return $ret;
	}

	public function saveForm() {
		$subscription = new stdClass();
		$subscription->subscription_id = hikaserial::getCID('subscription_id');

		$new = !empty($subscription->subscription_id);

		if(!$new) {
			$subscription->old = $this->get( (int)$subscription->subscription_id );
		}

		$formData = hikaInput::get()->get('data', array(), 'array');
		foreach($formData['subscription'] as $col => $val) {
			hikaserial::secureField($col);
			if(is_array($val) || is_object($val))
				continue;
			$subscription->$col = strip_tags($val);
		}
		if(!empty($formData['subscription']['subscription_extradata'])) {
			$subscription->subscription_extradata = $formData['subscription']['subscription_extradata'];
		} else {
			$isExtraData = hikaInput::get()->getInt('hikaserial_extradata', 0);
			if($isExtraData) {
				$subscription->subscription_extradata = '';
			}
		}

		if(empty($subscription->subscription_id))
			unset($subscription->subscription_id);

		if(!empty($subscription->subscription_start_date))
			$subscription->subscription_start_date = hikaserial::getTime($subscription->subscription_start_date);
		if(!empty($subscription->subscription_end_date))
			$subscription->subscription_end_date = hikaserial::getTime($subscription->subscription_end_date);

		$status = $this->save($subscription);

		if($status) {
		}
		return $status;
	}

	public function save(&$subscription) {
		if(isset($subscription->history) && (empty($subscription->history) || !is_object($subscription->history))) {
			unset($subscription->history);
		}

		$dispatcher = hikaserial::getDispatcher();

		$newSubscription = empty($subscription->subscription_id);
		$do = true;

		if(!$newSubscription)
			$subscription->old = $this->get((int)$subscription->subscription_id, false);

		$plan_id = isset($subscription->subscription_pack_id) ? (int)$subscription->subscription_pack_id : (int)@$subscription->old->subscription_pack_id;

		$packClass = hikaserial::get('class.pack');
		$subscription->plan = $packClass->get($plan_id);
		if(empty($subscription->plan) || $subscription->plan->pack_type != 'subscription') {
			unset($subscription->subscription_pack_id);
			unset($subscription->plan);
			return false;
		}

		if(empty($subscription->subscription_data) && !empty($subscription->plan)) {
			$config = hikaserial::config();
			$fastRandom = (int)$config->get('use_fast_random', 0);

			$plg_dispatcher = hikaserial::getDispatcher(true);
			$generator = new hikaserialPlugin($plg_dispatcher, array('name' => 'subscriptiongenerator', 'type' => 'hikaserial'));

			$serial_size = (!empty($subscription->plan->pack_params->generator_size) && (int)$subscription->plan->pack_params->generator_size > 2) ? (int)$subscription->plan->pack_params->generator_size : 15;

			$generator_format = !empty($subscription->plan->pack_params->generator_format) ? $subscription->plan->pack_params->generator_format : '[a-zA-Z0-9]{size}';

			$randomize = $generator->initRandomize($fastRandom, $serial_size);
			if(empty($generator_format) || !preg_match_all('#\\\[|\\\]|\[[^]]+\]\{.*\}|\[.*\]|.#iU', $generator_format, $matches)) {
				$matches = array(array('[a-zA-Z0-9]{size}'));
			}

			$serial = '';
			foreach($matches[0] as $m) {
				list($format, $repeat) = $generator->generatorExtractRepeater($m, $serial_size);
				if($format === false) { $format = $m; $repeat = 1; }
				$serial .= $generator->getRandomContent($format, $repeat, $randomize, $fastRandom, $serial_size);
			}
			$subscription->subscription_data = $serial;
		}

		if(!empty($subscription->subscription_extradata) && is_string($subscription->subscription_extradata))
			$subscription->subscription_extradata = hikaserial::unserialize($subscription->subscription_extradata);
		if(!empty($subscription->subscription_payment_renew) && is_string($subscription->subscription_payment_renew))
			$subscription->subscription_payment_renew = hikaserial::unserialize($subscription->subscription_payment_renew);

		JPluginHelper::importPlugin('hikaserial');
		JPluginHelper::importPlugin('hikashop');
		JPluginHelper::importPlugin('hikashoppayment');
		if($newSubscription)
			$dispatcher->trigger('onBeforeSubscriptionCreate', array(&$subscription, &$do));
		else
			$dispatcher->trigger('onBeforeSubscriptionUpdate', array(&$subscription, &$do));

		if(!$do)
			return false;

		if(!empty($subscription->subscription_extradata) && !is_string($subscription->subscription_extradata))
			$subscription->subscription_extradata = serialize($subscription->subscription_extradata);
		if(!empty($subscription->subscription_payment_renew) && !is_string($subscription->subscription_payment_renew))
			$subscription->subscription_payment_renew = serialize($subscription->subscription_payment_renew);

		$status = parent::save($subscription);
		if(!$status)
			return $status;

		if(empty($subscription->subscription_id))
			$subscription->subscription_id = (int)$status;

		if($newSubscription)
			$dispatcher->trigger('onAfterSubscriptionCreate', array(&$subscription, $status));
		else
			$dispatcher->trigger('onAfterSubscriptionUpdate', array(&$subscription, $status));

		$subscriptionhistoryClass = hikaserial::get('class.subscription_history');
		$history = $subscriptionhistoryClass->generate($status, $subscription, $newSubscription);
		$subscriptionhistoryClass->save($history);

		$activation = in_array($subscription->subscription_status, array('active'));

		$upgrade = !empty($subscription->old) && !empty($subscription->subscription_pack_id) && ($subscription->old->subscription_pack_id != $subscription->subscription_pack_id);

		if(!empty($subscription->old) && isset($subscription->subscription_status) && $subscription->subscription_status == $subscription->old->subscription_status && !$upgrade)
			return $status;
		if(empty($subscription->old) && !$activation)
			return $status;

		$user_id = !empty($subscription->subscription_user_id) ? (int)$subscription->subscription_user_id : (int)@$subscription->old->subscription_user_id;
		if(!empty($user_id)) {
			$userClass = hikaserial::get('shop.class.user');
			$user = $userClass->get($user_id);

			$query = 'SELECT * FROM '.hikaserial::table('subscription').
				' WHERE subscription_status = '.$this->db->Quote('active').
					' AND subscription_id != '.(int)$status.
					' AND subscription_user_id = '.(int)$user_id;
			$this->db->setQuery($query);
			$user->subscriptions = $this->db->loadObjectList('subscription_id');

			$user->plans = array();
			$plan_ids = array();
			foreach($user->subscriptions as $sub) {
				$plan_ids[ (int)$sub->subscription_pack_id ] = (int)$sub->subscription_pack_id;
			}
			if(!empty($plan_ids)) {
				$query = 'SELECT * FROM '.hikaserial::table('pack').
					' WHERE pack_id IN ('.implode(',', $plan_ids).')';
				$this->db->setQuery($query);
				$user->plans = $this->db->loadObjectList('pack_id');
			}
			unset($plan_ids);
		} else {
			$user = new stdClass();
		}

		if($activation && !$upgrade) {
			$dispatcher->trigger('onSubscriptionActivation', array(&$subscription, $user));
		} else if($upgrade) {
			$subscription->previous_plan = $packClass->get($subscription->old->subscription_pack_id);
			$dispatcher->trigger('onSubscriptionUpgrade', array(&$subscription, $user));
		} else {
			$dispatcher->trigger('onSubscriptionExpiration', array(&$subscription, $user, $subscription->subscription_status));
		}

		return $status;
	}

	public function cancelRenew($subscription) {
		if(empty($subscription))
			return false;
		if(is_numeric($subscription)) {
			$subscription = $this->get($subscription);
			if(empty($subscription))
				return false;
		}

		if(empty($subscription->subscription_auto_renew))
			return false;

		if(!hikaserial::isAdmin()) {
			$user_id = hikaserial::loadUser(false);
			if($subscription->subscription_user_id != $user_id)
				return false;
		}

		if(!empty($subscription->subscription_payment_renew->method)) {
			$plugin = hikaserial::import('hikashoppayment', $subscription->subscription_payment_renew->method);
			if(empty($plugin))
				return false;
			if(method_exists($plugin, 'onSubscriptionRecurringCancel')) {
				if(empty($subscription->orders))
					$subscription = $this->get($subscription->subscription_id, true);
				$ret = $plugin->onSubscriptionRecurringCancel($subscription);
				if(!$ret)
					return $ret;
			}
		}

		$sub = new stdClass();
		$sub->subscription_id = (int)$subscription->subscription_id;
		$sub->subscription_auto_renew = 0;
		return $this->save($sub);
	}

	public function refreshStatuses($filter = null) {
		$config = hikaserial::config();
		$db = JFactory::getDBO();
		$now = time();

		$status_expired = 'expired';
		$status_closed = 'closed';
		$status_active = 'active';

		$sql_filters = array(
			'subscription_end' => 'subscription_end_date > 0',
			'expiration' => '(subscription_end_date < '.(int)$now.' AND subscription_status = '.$db->Quote($status_active).')'
		);

		$renew_after_time = 0;
		if((int)$config->get('subscription_renewal_after_expire', false)) {
			$after_delay = $config->get('subscription_renewal_after_period', 0);
			if((int)$after_delay > 0)
				$renew_after_time = hikaserial::addDurationTime($now, '-'.$after_delay);
		}
		if(!empty($renew_after_time)) {
 			$sql_filters['expiration'] .= ' OR (subscription_end_date > 0 AND subscription_end_date < '.(int)$renew_after_time.' AND subscription_status IN ('.$db->Quote($status_expired).','.$db->Quote($status_active).'))';
		}

		if(!empty($filter) && !empty($filter['user'])) {
			if(is_array($filter['user'])) {
				hikaserial::toInterger($filter['user']);
				$sql_filters['user'] = 'subscription_user_id IN ('.implode(',', $filter['user']).')';
			} else {
				$sql_filters['user'] = 'subscription_user_id = '.(int)$filter['user'];
			}
		}

		$limit = max(5, (int)$config->get('subscription_batch_size', 10));

		$query = 'SELECT subscription.* FROM '.hikaserial::table('subscription').' AS subscription '.
			' WHERE ('.implode(') AND (', $sql_filters).')'.
			' ORDER BY subscription_end_date ASC, subscription_id ASC';
		$db->setQuery($query, 0, $limit);
		$refreshing_subscriptions = $db->loadObjectList('subscription_id');
		if(empty($refreshing_subscriptions))
			return false;

		$expired_subscriptions = array();
		$closed_subscriptions = array();

		$plan_ids = array();
		$user_ids = array();

		foreach($refreshing_subscriptions as $k => &$refreshing_subscription) {
			if($refreshing_subscription->subscription_status == 'expired' || (int)$refreshing_subscription->subscription_end_date < $renew_after_time) {
				$closed_subscriptions[$k] =& $refreshing_subscription;
			} else {
				$expired_subscriptions[$k] =& $refreshing_subscription;
			}

			$plan_ids[ (int)$refreshing_subscription->subscription_pack_id ] = (int)$refreshing_subscription->subscription_pack_id;
			$user_ids[ (int)$refreshing_subscription->subscription_user_id ] = (int)$refreshing_subscription->subscription_user_id;

			if(!empty($refreshing_subscription->subscription_extradata))
				$refreshing_subscription->subscription_extradata = hikaserial::unserialize($refreshing_subscription->subscription_extradata);
			if(!empty($refreshing_subscription->subscription_payment_renew))
				$refreshing_subscription->subscription_payment_renew = hikaserial::unserialize($refreshing_subscription->subscription_payment_renew);
		}
		unset($refreshing_subscription);

		unset($user_ids[0]);

		$users = array();
		if(!empty($user_ids)) {
			$query = 'SELECT * FROM '.hikaserial::table('shop.user'). ' hk_user '.
				' LEFT JOIN '.hikaserial::table('users', false).' AS j_users ON hk_user.user_cms_id = j_users.id '.
				' WHERE hk_user.user_id IN ('.implode(',', $user_ids).')';
			$db->setQuery($query);
			$users = $db->loadObjectList('user_id');

			$query = 'SELECT subscription.* FROM '.hikaserial::table('subscription').' AS subscription '.
				' WHERE subscription_status = '.$this->db->Quote('active').
					' AND subscription_user_id IN ('.implode(',', $user_ids).') '.
					' AND subscription_id NOT IN('.implode(',', array_keys($refreshing_subscriptions)).')';
			$db->setQuery($query);
			$active_subscriptions = $db->loadObjectList('subscription_id');
			foreach($active_subscriptions as $k => $active_subscription) {
				$uid = (int)$active_subscription->subscription_user_id;
				if(empty($users[ $uid ]))
					continue;
				if(empty($users[ $uid ]->subscriptions))
					$users[ $uid ]->subscriptions = array();

				$users[ $uid ]->subscriptions[$k] = $active_subscription;
				$plan_ids[ (int)$active_subscription->subscription_pack_id ] = (int)$active_subscription->subscription_pack_id;
			}
			unset($active_subscriptions);
		}

		$query = 'SELECT * FROM '.hikaserial::table('pack').' WHERE pack_id IN ('.implode(',', $plan_ids).')';
		$db->setQuery($query);
		$plans = $db->loadObjectList('pack_id');
		foreach($plans as &$plan) {
			if(!empty($plan->pack_params))
				$plan->pack_params = hikaserial::unserialize($plan->pack_params);
		}
		unset($plan);

		$dispatcher = hikaserial::getDispatcher();
		JPluginHelper::importPlugin('hikaserial');
		JPluginHelper::importPlugin('hikashop');
		JPluginHelper::importPlugin('hikashoppayment');

		if(!empty($expired_subscriptions))
			$dispatcher->trigger('onBeforeSubscriptionsExpire', array(&$expired_subscriptions, $plans, $users));
		if(!empty($closed_subscriptions))
			$dispatcher->trigger('onBeforeSubscriptionsClose', array(&$closed_subscriptions, $plans, $users));

		if(empty($expired_subscriptions) && empty($closed_subscriptions))
			return false;

		if(!empty($closed_subscriptions)) {
			$subscription_ids = array_keys($closed_subscriptions);
			hikaserial::toInteger($subscription_ids);

			$query = 'UPDATE '.hikaserial::table('subscription').
				' SET subscription_status = '.$db->Quote($status_closed).', subscription_auto_renew = 0 '.
				' WHERE subscription_id IN ('.implode(',', $subscription_ids).') AND subscription_status IN ('.$db->Quote($status_expired).','.$db->Quote($status_active).')';
			$db->setQuery($query);
			$db->execute();

			$query = 'INSERT INTO '.hikaserial::table('subscription_history').' (`history_subscription_id`,`history_created`,`history_type`,`history_new_status`) '.
				' SELECT subscription.subscription_id, '.(int)$now.', '.$db->Quote('closure').', '.$db->Quote($status_closed).
				' FROM '.hikaserial::table('subscription').' AS subscription '.
				' WHERE subscription.subscription_id IN ('.implode(',', $subscription_ids).')';
			$db->setQuery($query);
			$db->execute();

			$dispatcher->trigger('onAfterSubscriptionsClose', array(&$closed_subscriptions, $plans, $users));
		}

		if(!empty($expired_subscriptions)) {
			$subscription_ids = array_keys($expired_subscriptions);
			hikaserial::toInteger($subscription_ids);

			$query = 'UPDATE '.hikaserial::table('subscription').
				' SET subscription_status = '.$db->Quote($status_expired).', subscription_auto_renew = 0 '.
				' WHERE subscription_id IN ('.implode(',', $subscription_ids).') AND subscription_status = '.$db->Quote($status_active);
			$db->setQuery($query);
			$db->execute();

			$query = 'INSERT INTO '.hikaserial::table('subscription_history').' (`history_subscription_id`,`history_created`,`history_type`,`history_new_status`) '.
				' SELECT subscription.subscription_id, '.(int)$now.', '.$db->Quote('expiration').', '.$db->Quote($status_expired).
				' FROM '.hikaserial::table('subscription').' AS subscription '.
				' WHERE subscription.subscription_id IN ('.implode(',', $subscription_ids).')';
			$db->setQuery($query);
			$db->execute();

			$dispatcher->trigger('onAfterSubscriptionsExpire', array(&$expired_subscriptions, $plans, $users));
		}

		return array(
			'expired' => $expired_subscriptions,
			'closed' => $closed_subscriptions
		);
	}

	public function getSubscriptionsRenewals(&$subscription) {
		if(is_array($subscription)) {
			$subscriptions =& $subscription;
		} elseif(is_object($subscription)) {
			$subscriptions = array( $subscription->subscription_id => &$subscription );
		} else {
			return false;
		}

		$config = hikaserial::config();
		$now = time();
		$authorize_renew_before = (int)$config->get('subscription_renewal_before_expire', true);
		$renew_before_time = 0;
		$authorize_renew_after = (int)$config->get('subscription_renewal_after_expire', false);
		$renew_after_time = 0;

		if($authorize_renew_before) {
			$before_delay = $config->get('subscription_renewal_before_period', 0);
			if((int)$before_delay > 0)
				$renew_before_time = hikaserial::addDurationTime($now, $before_delay);
		}
		if($authorize_renew_after) {
			$after_delay = $config->get('subscription_renewal_after_period', 0);
			if((int)$after_delay > 0)
				$renew_after_time = hikaserial::addDurationTime($now, '-'.$after_delay);
		}

		$renews = array();

		foreach($subscriptions as &$sub) {
			$sub->renewals = false;

			if($sub->subscription_status == 'closed')
				continue;

			if(empty($sub->pack_published))
				continue;

			if(in_array($sub->subscription_status, array('active', 'expired')) && empty($sub->subscription_end_date))
				continue;

			if($sub->subscription_status == 'active' && !empty($sub->subscription_auto_renew))
				continue;

			if($sub->subscription_status == 'active' && !empty($sub->subscription_end_date) && (int)$sub->subscription_end_date > 0 && (int)$sub->subscription_end_date < $now) {
				$sub->subscription_status = 'expired';
			}

			if($sub->subscription_status == 'active' && (!$authorize_renew_before || ($renew_before_time > 0 && $sub->subscription_end_date > $renew_before_time)))
				continue;

			if($sub->subscription_status == 'expired' && (!$authorize_renew_after || ($renew_after_time > 0 && $sub->subscription_end_date < $renew_after_time)))
				continue;

			$sub->renewals = array();
			if(!isset($renews[(int)$sub->subscription_pack_id]))
				$renews[(int)$sub->subscription_pack_id] = array();
			$renews[(int)$sub->subscription_pack_id][] = (int)$sub->subscription_id;
		}
		unset($sub);

		if(empty($renews))
			return true;

		$query = 'SELECT product_pack.* FROM '.hikaserial::table('product_pack').' AS product_pack '.
			' WHERE product_pack.pack_id IN ('.implode(',', array_keys($renews)).') '.
				' AND product_pack.quantity = 1 '.
				' AND product_pack.relation_type IN ('.$this->db->Quote('create_renew').','.$this->db->Quote('renew').','.$this->db->Quote('renew_create').')';
		$this->db->setQuery($query);
		$relations = $this->db->loadObjectList();

		$product_ids = array();
		foreach($relations as $r) {
			$product_ids[(int)$r->product_id] = (int)$r->product_id;
		}

		$hk_user_id = hikaserial::loadUser(false);
		$productHelper = hikaserial::get('helper.product');
		$products = $productHelper->loadProducts(array(
			'filter' => array(
				'ids' => $product_ids,
				'user' => $hk_user_id
			),
			'load' => array('price' => true)
		));

		foreach($subscriptions as &$sub) {
			if($sub->renewals === false)
				continue;

			$sub->subscription_pack_id = (int)$sub->subscription_pack_id;

			foreach($relations as $r) {
				if($sub->subscription_pack_id != (int)$r->pack_id)
					continue;

				$pid = (int)$r->product_id;
				if(!isset($products[$pid]))
					continue;

				$sub->renewals[$pid] = array(
					'duration' => $r->relation_duration,
					'product' => &$products[$pid]
				);
			}
			if(empty($sub->renewals))
				$sub->renewals = false;
		}
		unset($sub);

		return true;
	}

	public function listRenewableSubscriptions($pack_id, $user_id = 0) {
		if(is_array($pack_id) && !empty($pack_id)) {
			hikaserial::toInteger($pack_id);
			if(count($pack_id) == 1) {
				$pack_id = reset($pack_id);
				$pack_id = (int)$pack_id;
				if($pack_id <= 0)
					return false;
			}
		} else {
			$pack_id = (int)$pack_id;
			if($pack_id <= 0)
				return false;
		}

		$user_id = (int)$user_id;
		if(empty($user_id))
			$user_id = hikaserial::loadUser(false);
		if(empty($user_id))
			return false;

		$config = hikaserial::config();
		$now = time();
		$authorize_renew_before = (int)$config->get('subscription_renewal_before_expire', true);
		$renew_before_time = 0;
		$authorize_renew_after = (int)$config->get('subscription_renewal_after_expire', false);
		$renew_after_time = 0;

		if(!$authorize_renew_before && !$authorize_renew_after)
			return false;

		if($authorize_renew_before) {
			$before_delay = $config->get('subscription_renewal_before_period', 0);
			if((int)$before_delay > 0)
				$renew_before_time = hikaserial::addDurationTime($now, $before_delay);
		}
		if($authorize_renew_after) {
			$after_delay = $config->get('subscription_renewal_after_period', 0);
			if((int)$after_delay > 0)
				$renew_after_time = hikaserial::addDurationTime($now, '-'.$after_delay);
		}

		$select = array(
			'sub.*'
		);
		$filters = array(
			'pack' => 'sub.subscription_pack_id '.(is_array($pack_id) ? ('IN ('.implode(',', $pack_id).')') : ('= ' . (int)$pack_id)),
			'end_date' => 'sub.subscription_end_date > 0',
			'user' => 'subscription_user_id = '.$user_id,
			'states' => array()
		);

		if($authorize_renew_before) {
			$st = 'sub.subscription_status = ' . $this->db->Quote('active') . ' AND sub.subscription_auto_renew = 0';
			if($renew_before_time > 0)
				$st .= ' AND sub.subscription_end_date < ' . $renew_before_time;
			$filters['states'][] = $st;
		}
		if($authorize_renew_after) {
			$st = 'sub.subscription_status = ' . $this->db->Quote('expired');
			if($renew_after_time > 0)
				$st .= ' AND sub.subscription_end_date > ' . $renew_after_time;
			$filters['states'][] = $st;
		}
		$filters['states'] = '((' . implode(') OR (', $filters['states']) . '))';

		$query = 'SELECT '.implode(',', $select).' FROM '.hikaserial::table('subscription').' AS sub WHERE ('.implode(') AND (', $filters).')';
		$this->db->setQuery($query);
		$subscriptions = $this->db->loadObjectList('subscription_id');

		return $subscriptions;
	}

	public function getSubscriptionsUpgrades(&$subscription) {
		if(is_array($subscription)) {
			$subscriptions =& $subscription;
		} elseif(is_object($subscription)) {
			$subscriptions = array( $subscription->subscription_id => &$subscription );
		} else {
			return false;
		}

		$config = hikaserial::config();
		$now = time();
		$upgrade_merge_time = $config->get('subscription_upgrade_merge_method', '');

		$upgrades = array();

		foreach($subscriptions as &$sub) {
			$sub->upgrades = false;

			if($sub->subscription_status == 'closed') {
				continue;
			}
			if(empty($sub->pack_published)) {
				continue;
			}
			if(in_array($sub->subscription_status, array('active', 'expired')) && empty($sub->subscription_end_date)) {
				continue;
			}
			if($sub->subscription_status == 'active' && !empty($sub->subscription_auto_renew))
				continue;

			if($sub->subscription_status == 'active' && !empty($sub->subscription_end_date) && (int)$sub->subscription_end_date > 0 && (int)$sub->subscription_end_date < $now) {
				$sub->subscription_status = 'expired';
			}
			if($sub->subscription_status == 'expired')
				continue;


			$sub->upgrades = array();
			if(!isset($upgrades[(int)$sub->subscription_pack_id]))
				$upgrades[(int)$sub->subscription_pack_id] = array();
			$upgrades[(int)$sub->subscription_pack_id][] = (int)$sub->subscription_id;
		}
		unset($sub);

		if(empty($upgrades))
			return true;

		$query = 'SELECT product_pack.* FROM '.hikaserial::table('product_pack').' AS product_pack '.
			' WHERE product_pack.relation_upgrade IN ('.implode(',', array_keys($upgrades)).') '.
				' AND product_pack.quantity = 1 '.
				' AND product_pack.relation_type IN ('.$this->db->Quote('upgrade').')';
		$this->db->setQuery($query);
		$relations = $this->db->loadObjectList();

		$product_ids = array();
		$pack_ids = array();
		foreach($relations as $r) {
			$product_ids[(int)$r->product_id] = (int)$r->product_id;
			$pack_ids[(int)$r->pack_id] = (int)$r->pack_id;
		}

		$hk_user_id = hikaserial::loadUser(false);
		$productHelper = hikaserial::get('helper.product');
		$products = $productHelper->loadProducts(array(
			'filter' => array(
				'ids' => $product_ids,
				'user' => $hk_user_id
			),
			'load' => array('price' => true)
		));

		$packs = array();
		if(!empty($pack_ids)) {
			$query = 'SELECT pack.* FROM '.hikaserial::table('pack').' AS pack '.
				' WHERE pack.pack_id IN ('.implode(',', $pack_ids).') '.
					' AND pack.pack_published = 1';
			$this->db->setQuery($query);
			$packs = $this->db->loadObjectList('pack_id');
		}

		foreach($subscriptions as &$sub) {
			if($sub->upgrades === false)
				continue;

			$sub->subscription_pack_id = (int)$sub->subscription_pack_id;

			foreach($relations as $r) {
				if($sub->subscription_pack_id != (int)$r->relation_upgrade)
					continue;

				if(empty($packs[ (int)$r->pack_id ]))
					continue;

				$pid = (int)$r->product_id;
				if(!isset($products[$pid]))
					continue;

				$start_point = max($sub->subscription_end_date, $now);
				$end_time = hikaserial::mergeDurationTime($start_point, $r->relation_duration, $upgrade_merge_time);

				$sub->upgrades[$pid] = array(
					'duration' => $r->relation_duration,
					'end_time' => $end_time,
					'product' => &$products[$pid],
					'pack' => &$packs[ (int)$r->pack_id ],
				);
			}
			if(empty($sub->upgrades))
				$sub->upgrades = false;
		}
		unset($sub);

		return true;
	}

	public function listUpgradableSubscriptions($pack_id, $user_id = 0) {
		if(is_array($pack_id) && !empty($pack_id)) {
			hikaserial::toInteger($pack_id);
			if(count($pack_id) == 1) {
				$pack_id = reset($pack_id);
				$pack_id = (int)$pack_id;
				if($pack_id <= 0)
					return false;
			}
		} else {
			$pack_id = (int)$pack_id;
			if($pack_id <= 0)
				return false;
		}

		$user_id = (int)$user_id;
		if(empty($user_id))
			$user_id = hikaserial::loadUser(false);
		if(empty($user_id))
			return false;

		$config = hikaserial::config();
		$now = time();

		$select = array(
			'sub.*'
		);
		$filters = array(
			'pack' => 'sub.subscription_pack_id '.(is_array($pack_id) ? ('IN ('.implode(',', $pack_id).')') : ('= ' . (int)$pack_id)),
			'end_date' => 'sub.subscription_end_date > 0',
			'user' => 'subscription_user_id = '.$user_id,
			'states' => 'sub.subscription_status = ' . $this->db->Quote('active'),
			'date_active' => 'sub.subscription_end_date > ' . $now,
		);
		$query = 'SELECT '.implode(',', $select).' FROM '.hikaserial::table('subscription').' AS sub WHERE ('.implode(') AND (', $filters).')';
		$this->db->setQuery($query);
		$subscriptions = $this->db->loadObjectList('subscription_id');

		return $subscriptions;
	}
}
