<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialSubscription_historyClass extends hikaserialClass {
	protected $tables = array('subscription_history');
	protected $pkeys = array('subscription_history_id');

	public function save(&$element) {
		if(!is_array($element)) {
			if(!empty($element->history_data) && !is_string($element->history_data))
				$element->history_data = json_encode($element->history_data);
			return parent::save($element);
		}

		$struct = array();
		$first = reset($element);
		$query = 'INSERT IGNORE INTO '.hikaserial::table('subscription_history').' (';
		$sep = '';
		foreach (get_object_vars($first) as $k => $v) {
			if(is_array($v) || is_object($v) || $v === null || $k[0] == '_' ) {
				continue;
			}
			$query .= $sep.$this->db->quoteName($k);
			$struct[] = $k;
			$sep = ',';
		}
		$query .= ') VALUES ';
		$sep = '';
		foreach($element as $el) {
			if($el === false)
				continue;
			if(!empty($el->history_data) && !is_string($el->history_data))
				$el->history_data = json_encode($el->history_data);
			$query .= $sep.'(';
			$sep2 = '';
			foreach($struct as $k) {
				$value = $el->$k;
				$query .= $sep2 . $this->db->Quote($value);
				$sep2 = ',';
			}
			$query .= ')';
			$sep = ',';
		}
		$this->db->setQuery($query);
		$this->db->execute();
		return true;
	}

	public function &generate($id, &$subscription, $newSubscription = false) {
		if(empty($id))
			$id = @$subscription->subscription_id;
		if(empty($id))
			return false;

		$history = new stdClass();
		$history->history_subscription_id = $id;
		$history->history_created = time();
		$history->history_ip = hikaserial::getIP();
		$history->history_user_id = hikaserial::loadUser();
		if($newSubscription === true) {
			$history->history_type = 'creation';
		} else {
			$history->history_type = 'modification';
		}
		if(empty($subscription->subscription_status) && !$newSubscription) {
			$subscriptionClass = hikaserial::get('class.subscription');
			$old = $subscriptionClass->get((int)$id);
			$subscription->subscription_status = $old->order_status;
			unset($old);
		}
		$history->history_new_status = $subscription->subscription_status;
		if(!empty($subscription->history)) {
			foreach(get_object_vars($subscription->history) as $k => $v) {
				$history->$k = $v;
			}
		}
		return $history;
	}

	public function &create($id, $status = '', $type = 'modification', $data = '') {
		$history = new stdClass();
		$history->history_subscription_id = $id;
		$history->history_created = time();
		$history->history_ip = hikaserial::getIP();
		$history->history_user_id = hikaserial::loadUser();
		$history->history_type = $type;
		if(!empty($status)) {
			$history->history_new_status = $status;
		}
		if(!empty($data)) {
			$history->history_data = $data;
		}
		return $history;
	}

}
