<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class groupController extends hikaserialController {

	protected $type = 'pack_group';
	protected $toggle = array('pack_group_published' => 'pack_group_id');
	protected $rights = array(
		'display' => array('display','show','cancel','listing','findList'),
		'add' => array('add'),
		'edit' => array('edit','toggle','publish','unpublish'),
		'modify' => array('save','apply'),
		'delete' => array('remove')
	);

	public function __construct($config = array()) {
		parent::__construct($config);
		$this->registerDefaultTask('listing');
	}

	public function store() {
		return parent::adminStore();
	}

	public function remove() {
		hikaserial::checkToken() || die('Invalid Token');
		$cids = hikaInput::get()->get('cid', array(), 'array');
		$packClass = hikaserial::get('class.pack_group');
		$num = $packClass->delete($cids);
		if($num) {
			$app = JFactory::getApplication();
			$app->enqueueMessage(JText::sprintf('SUCC_DELETE_ELEMENTS', count($cids)), 'message');
		}
		return parent::listing();
	}

	public function select() {
		hikaInput::get()->set('layout', 'select');
		return parent::display();
	}

	public function useselection() {
		hikaInput::get()->set('layout', 'useselection');
		return parent::display();
	}

	public function findlist() {
		$search = hikaInput::get()->getVar('search', '');
		$start = hikaInput::get()->getInt('start', 0);

		$selector = 'plg.hikaserial.pack_group';
		$options = array(
			'start' => $start,
		);
		$nameboxType = hikashop_get('type.namebox');
		$elements = $nameboxType->getValues($search, $selector, $options);
		echo json_encode($elements);
		exit;
	}
}
