<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class importController extends hikaserialController {
	protected $type = 'import';
	public $helper = null;
	protected $rights = array(
		'display' => array('display','show','listing','cancel'),
		'add' => array(),
		'edit' => array(),
		'modify' => array('import'),
		'delete' => array()
	);

	public function __construct($config = array())	{
		parent::__construct($config);
		$this->registerDefaultTask('show');
	}

	public function display($tpl = null, $params = null) {
		hikaInput::get()->set('layout', 'show');
		return parent::display($tpl, $params);
	}

	public function import() {
		hikaserial::checkToken('request') || die('Invalid Token');
		$importFrom = hikaInput::get()->getCmd('importfrom');

		$this->helper = hikaserial::get('helper.import');
		switch($importFrom) {
			case 'csv':
				$this->importCsvFile();
				break;
			case 'textarea':
				$this->importTextarea();
				break;
		}

		hikaInput::get()->set('layout', 'show');
		return parent::display();
	}

	private function importCsvFile() {
		$importFile = hikaInput::get()->files->getVar('csvimport_file', array(), 'array');

		$this->helper->charset = hikaInput::get()->getVar('csvimport_charsetconvert', '');
		$this->helper->pack_id = hikaInput::get()->getInt('csvimport_pack');

		$options = array();
		if(hikaInput::get()->getInt('csvimport_checkduplicates', 0))
			$options['check_duplicates'] = true;

		$ret = $this->helper->importFromFile($importFile, $options);

		$productClass = hikaserial::get('class.product');
		$productClass->refreshQuantities();
		return $ret;
	}

	private function importTextarea() {
		$content = hikaInput::get()->getRaw('textareaimport_content', '');
		$this->helper->pack_id = hikaInput::get()->getInt('textareaimport_pack');
		$productClass = hikaserial::get('class.product');

		$options = array();
		if(hikaInput::get()->getInt('textareaimport_checkduplicates', 0))
			$options['check_duplicates'] = true;

		$importAsCsv = hikaInput::get()->getInt('textareaimport_as_csv', 0);
		if($importAsCsv == 0) {
			if($this->helper->pack_id == 0) {
				return false;
			}
			$ret = $this->helper->handleTextContent($content, $options);
			$productClass->refreshQuantities();
			return $ret;
		}
		$ret = $this->helper->handleCsvContent($content, $options);
		$productClass->refreshQuantities();
		return $ret;
	}
}
