<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class packController extends hikaserialController {

	protected $type = 'pack';
	protected $toggle = array('pack_published' => 'pack_id');
	protected $rights = array(
		'display' => array('display','show','cancel','listing','select','generate','useselection','findList'),
		'add' => array('add'),
		'edit' => array('edit','toggle','publish','unpublish'),
		'modify' => array('save','apply'),
		'delete' => array('remove')
	);

	public function __construct($config = array()) {
		parent::__construct($config);
		$this->registerDefaultTask('listing');
	}

	public function store() {
		return parent::adminStore();
	}

	public function generate() {
		$pack_id = hikaserial::getCID();
		$formData = hikaInput::get()->get('data', array(), 'array');

		if(!empty($formData) && !empty($formData['number_serials']) && (int)$formData['number_serials'] > 0 && !empty($pack_id)) {
			hikaserial::checkToken('request') || die('Invalid Token');

			$app = JFactory::getApplication();

			$packClass = hikaserial::get('class.pack');
			$serials = $packClass->generate($pack_id, $formData);
			$serial_status = $formData['serial_status'];
			if(empty($serial_status) || !is_string($serial_status))
				$serial_status = 'free';

			if(!empty($serials)) {
				$struct = array(
					'serial_pack_id' => (int)$pack_id,
					'serial_status' => $serial_status
				);
				$serialClass = hikaserial::get('class.serial');
				$serialClass->generate($serials, $struct);

				$app->enqueueMessage( JText::sprintf('X_SERIAL_GENERATED', count($serials)) ); // _('X_SERIAL_GENERATED')
			} else {
				$app->enqueueMessage( JText::_('ERROR_GENERATING_SERIALS'), 'error' );
			}
			hikaInput::get()->set('serials', $serials);
		}

		hikaInput::get()->set('hidemainmenu', 1);
		hikaInput::get()->set('layout','generate');
		return $this->display();
	}

	public function remove() {
		hikaserial::checkToken() || die('Invalid Token');
		$cids = hikaInput::get()->get('cid', array(), 'array');
		$packClass = hikaserial::get('class.pack');
		$num = $packClass->delete($cids);
		if($num) {
			$app = JFactory::getApplication();
			$app->enqueueMessage(JText::sprintf('SUCC_DELETE_ELEMENTS', count($cids)), 'message');
		}
		return parent::listing();
	}

	public function select() {
		hikaInput::get()->set('layout', 'select');
		return parent::display();
	}

	public function useselection() {
		hikaInput::get()->set('layout', 'useselection');
		return parent::display();
	}

	public function findlist() {
		$search = hikaInput::get()->getVar('search', '');
		$packType = hikaInput::get()->getCmd('pack_type', '');
		$start = hikaInput::get()->getInt('start', 0);

		$selector = 'plg.hikaserial.pack';
		if($packType == '')
			$selector = 'plg.hikaserial.packs';
		if($packType == 'subscription')
			$selector = 'plg.hikaserial.plan';

		$options = array(
			'start' => $start,
		);
		$nameboxType = hikashop_get('type.namebox');
		$elements = $nameboxType->getValues($search, $selector, $options);
		echo json_encode($elements);
		exit;
	}
}
