<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class subscriptionController extends hikaserialController {

	protected $type = 'subscription';
	protected $rights = array(
		'display' => array('listing','form','cancel','form_history','form_orders'),
		'add' => array('add'),
		'edit' => array('edit'),
		'modify' => array('save','apply'),
		'delete' => array('remove')
	);

	public function __construct($config = array())	{
		parent::__construct($config);
		$this->registerDefaultTask('listing');
	}

	public function store() {
		return parent::adminStore();
	}

	public function remove() {
		hikaserial::checkToken() || die('Invalid Token');
		$cids = hikaInput::get()->get('cid', array(), 'array');
		$subscriptionClass = hikaserial::get('class.subscription');
		$num = $subscriptionClass->delete($cids);
		if($num) {
			$app = JFactory::getApplication();
			$app->enqueueMessage(JText::sprintf('SUCC_DELETE_ELEMENTS', count($cids)), 'message');
		}
		return parent::listing();
	}
	public function form_history() {
		hikaInput::get()->set('layout', 'form_history');
		echo $this->display();
		exit;
	}
	public function form_orders() {
		hikaInput::get()->set('layout', 'form_orders');
		echo $this->display();
		exit;
	}
}
