<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikaserialAcymailingsubscriber extends hikaserialPlugin {
	protected $type = 'subscriber';
	protected $multiple = false;
	protected $name = 'acymailingsubscriber';

	protected $pluginConfig = array();
	protected $subscriptionConfig = array(
		'active_list' => array('HIKA_SERIAL_OPT_ACYLIST_ACTIVE', 'list'),
		'expire_list' => array('HIKA_SERIAL_OPT_ACYLIST_EXPIRE', 'list')
	);

	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	public function onPlanActionsConfiguration(&$plan) {
		$acyHelper = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php';
		$haveConfig = !empty($subscription->plan->pack_params->acymailingsubscriber) && !empty($subscription->plan->pack_params->acymailingsubscriber['lists']);

		if(!file_exists($acyHelper) && !$haveConfig)
			return;

		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__acymailing_list WHERE type = \'list\' AND published = 1 ORDER BY ordering ASC, listid ASC';
		$db->setQuery($query);
		$lists = $db->loadObjectList('listid');
		$acy_lists = array(
			0 => JText::_('HIKA_NONE')
		);
		foreach($lists as $k => $v) {
			$acy_lists[$k] = $v->name;
		}
		unset($lists);
		$this->subscriptionConfig['active_list'][2] = $acy_lists;
		$this->subscriptionConfig['expire_list'][2] = $acy_lists;

		if(empty($plan->actions))
			$plan->actions = array();
		$plan->actions[$this->name] = $this->subscriptionConfig;
	}

	public function onSubscriptionActivation(&$subscription, $user) {
		if(empty($subscription->plan->pack_params->acymailingsubscriber) || empty($subscription->plan->pack_params->acymailingsubscriber['active_list']))
			return;

		$list_id = (int)$subscription->plan->pack_params->acymailingsubscriber['active_list'];
		$user_cms_id = (int)$user->user_cms_id;

		if(empty($user_cms_id))
			return false;

		$acy_id = $this->getSubscriber($user_cms_id);
		if(empty($acy_id))
			return false;

		$user_lists = $this->getSubLists($acy_id);
		$this->registerList($acy_id, $user_lists, $list_id);
	}

	public function onSubscriptionExpiration(&$subscription, $user, $status) {
		if(empty($subscription->plan->pack_params->acymailingsubscriber))
			return;

		$pp = $subscription->plan->pack_params->acymailingsubscriber;

		$active_list_id = !empty($pp['active_list']) ? (int)$subscription->plan->pack_params->acymailingsubscriber['active_list'] : 0;
		$expire_list_id = !empty($pp['expire_list']) ? (int)$subscription->plan->pack_params->acymailingsubscriber['expire_list'] : 0;
		if(empty($active_list_id) && empty($expire_list_id))
			return;

		$user_cms_id = (int)$user->user_cms_id;

		if(empty($user_cms_id))
			return false;

		$acy_id = $this->getSubscriber($user_cms_id);
		if(empty($acy_id))
			return false;

		$plugin_subscriptions = array();
		if(!empty($user->subscriptions)) {
			foreach($user->subscriptions as $sub) {
				if((int)$sub->subscription_id == (int)$subscription->subscription_id)
					continue;

				if(!isset($user->plans[ (int)$sub->subscription_pack_id ]))
					continue;
				$p = $user->plans[ (int)$sub->subscription_pack_id ];

				if(empty($p->pack_params))
					continue;
				if(is_string($p->pack_params))
					$p->pack_params = hikaserial::unserialize($p->pack_params);
				if(empty($p->pack_params->acymailingsubscriber) || empty($p->pack_params->acymailingsubscriber['active_list']))
					continue;

				$plugin_subscriptions[ (int)$p->pack_params->acymailingsubscriber['active_list'] ] = true;
			}
		}

		if(isset($plugin_subscriptions[ $active_list_id ]))
			return true;

		$user_lists = $this->getSubLists($acy_id);

		if(!empty($active_list_id))
			$this->unregisterList($acy_id, $user_lists, $active_list_id);

		if(!empty($expire_list_id))
			$this->registerList($acy_id, $user_lists, $expire_list_id);
	}

	public function onAfterSubscriptionsClose(&$closed_subscriptions, $plans, $users) {
		$this->onAfterSubscriptionsExpire($closed_subscriptions, $plans, $users);
	}

	public function onAfterSubscriptionsExpire(&$expired_subscriptions, $plans, $users) {
		$supported_subscriptions = array();
		$supported_users = array();

		foreach($expired_subscriptions as $key => &$expired_subscription) {
			if(empty($expired_subscription->subscription_user_id))
				continue;

			$user_id = (int)$expired_subscription->subscription_user_id;
			if(empty($users[$user_id]->user_cms_id))
				continue;

			$plan_id = (int)$expired_subscription->subscription_pack_id;
			$plan = $plans[$plan_id];
			if(empty($plan->pack_params->acymailingsubscriber))
				continue;
			if(empty($plan->pack_params->acymailingsubscriber['active_list']) && empty($plan->pack_params->acymailingsubscriber['expire_list']))
				continue;

			$supported_subscriptions[$key] =& $expired_subscription;

			$user_cms_id = (int)$users[$user_id]->user_cms_id;

			if(empty($supported_users[ $user_cms_id ])) {
				$supported_users[ $user_cms_id ] = array(
					'id' => $user_id,
					'cms' => $user_cms_id,
					'active_lists' => array(),
					'expire_lists' => array(),
				);
			}
			if(!empty($plan->pack_params->acymailingsubscriber['active_list']))
				$supported_users[ $user_cms_id ]['active_lists'][ (int)$plan->pack_params->acymailingsubscriber['active_list'] ] = (int)$plan->pack_params->acymailingsubscriber['active_list'];

			if(!empty($plan->pack_params->acymailingsubscriber['expire_list']))
				$supported_users[ $user_cms_id ]['expire_lists'][ (int)$plan->pack_params->acymailingsubscriber['expire_list'] ] = (int)$plan->pack_params->acymailingsubscriber['expire_list'];

		}
		unset($expired_subscription);

		if(empty($supported_subscriptions))
			return;

		$acy_ids = $this->getSubscribers( array_keys($supported_users) );
		$acy_lists = $this->getSubsLists( $acy_ids );

		if( !$this->initAcymailing() )
			return;

		foreach($supported_users as $user_cms_id => &$data) {
			if(empty($data['active_lists']) && empty($data['expire_lists']))
				continue;
			if(empty($acy_ids[ $user_cms_id ]))
				continue;

			$acy_id = $acy_ids[ $user_cms_id ];
			$user_lists = $acy_lists[$acy_id];

			if(!empty($data['active_lists']))
				$this->unregisterLists($acy_id, $user_lists, $data['active_lists']);

			if(!empty($data['expire_lists']))
				$this->registerLists($acy_id, $user_lists, $data['expire_lists']);
		}
		unset($data);
	}

	protected function initAcymailing() {
		if(defined('ACYMAILING_COMPONENT'))
			return true;
		$acyHelper = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php';
		include_once $acyHelper;
		return defined('ACYMAILING_COMPONENT');
	}

	protected function getSubscriber($user_cms_id) {
		if(empty($user_cms_id))
			return null;

		$db = JFactory::getDBO();
		$query = 'SELECT s.subid, s.userid FROM #__acymailing_subscriber AS s WHERE s.userid = '.(int)$user_cms_id;
		$db->setQuery($query);
		$acy_user = $db->loadObject();
		if(empty($acy_user))
			return null;
		return (int)$acy_user->subid;
	}

	protected function getSubscribers($user_cms_ids = array()) {
		if(empty($user_cms_ids) || !is_array($user_cms_id))
			return array();

		hikaserial::toInteger($user_cms_ids);

		$db = JFactory::getDBO();
		$query = 'SELECT s.subid, s.userid FROM #__acymailing_subscriber AS s WHERE s.userid IN ('.implode(',', $user_cms_ids).')';
		$db->setQuery($query);
		$acy_users = $db->loadObjectList('userid');
		if(empty($acy_users))
			return array();
		$ret = array();
		foreach($acy_users as $k => $v) {
			$ret[$k] = (int)$v->subid;
		}
		return $ret;
	}

	protected function getSubLists($acy_id) {
		if(empty($acy_id))
			return array();

		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__acymailing_listsub WHERE subid = '.(int)$acy_id.' ORDER BY listid ASC';
		$db->setQuery($query);
		$lists = $db->loadObjectList('listid');

		return $lists;
	}

	protected function getSubsLists($acy_ids = array()) {
		if(empty($acy_ids) || !is_array($acy_ids))
			return array();

		hikaserial::toInteger($acy_ids);

		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__acymailing_listsub WHERE subid IN ('.implode(',', $acy_ids).') ORDER BY subid ASC, listid ASC';
		$db->setQuery($query);
		$lists = $db->loadObjectList();

		if(empty($lists))
			return array();

		$ret = array();
		foreach($lists as $v) {
			$i = (int)$v->subid;
			$l = (int)$v->listid;
			if(!isset($ret[$i]))
				$ret[$i] = array();
			$ret[$i][$l] = $v;
		}
		return $ret;
	}

	protected function registerList($acy_id, $user_lists, $list_id) {
		if(empty($acy_id) || empty($list_id))
			return;

		$acy_id = (int)$acy_id;
		$list_id = (int)$list_id;

		if(!empty($user_lists[$list_id]) && (int)$user_lists[$list_id]->status == 1)
			return;

		if(empty($this->listsubClass)) {
			$this->initAcymailing();
			$this->listsubClass = acymailing_get('class.listsub');
		}

		if(!empty($user_lists[$list_id]) && (int)$user_lists[$list_id]->status == 0) {
			$this->listsubClass->updateSubscription($acy_id, array(1 => array($list_id)));
		} else {
			$this->listsubClass->addSubscription($acy_id, array(1 => array($list_id)));
		}
	}

	protected function registerLists($acy_id, $user_lists, $list_ids) {
		if(empty($acy_id) || empty($list_id))
			return;

		$acy_id = (int)$acy_id;
		hikaserial::toInteger($list_ids);

		$add_lists = array();
		$update_lists = array();
		foreach($list_ids as $id) {
			if(!empty($user_lists[$id]) && (int)$user_lists[$id]->status == 1)
				continue;

			if(!empty($user_lists[$id]) && (int)$user_lists[$id]->status == 0)
				$update_lists[] = $id;
			else
				$add_lists[] = $id;
		}

		if(empty($add_lists) && empty($update_lists))
			return;

		if(empty($this->listsubClass)) {
			$this->initAcymailing();
			$this->listsubClass = acymailing_get('class.listsub');
		}

		if(!empty($add_lists))
			$this->listsubClass->addSubscription($acy_id, array(1 => $add_lists));
		if(!empty($update_lists))
			$this->listsubClass->updateSubscription($acy_id, array(1 => $update_lists));
	}

	protected function unregisterList($acy_id, $user_lists, $list_id) {
		if(empty($acy_id) || empty($list_id))
			return;

		$acy_id = (int)$acy_id;
		$list_id = (int)$list_id;

		if(empty($user_lists[$list_id]) || (int)$user_lists[$list_id]->status == 0)
			return;

		$list_ids = array($list_id);

		if(empty($this->listsubClass)) {
			$this->initAcymailing();
			$this->listsubClass = acymailing_get('class.listsub');
		}
		$this->listsubClass->updateSubscription($acy_id, array(0 => $list_ids));
	}

	protected function unregisterLists($acy_id, $user_lists, $list_ids) {
		if(empty($acy_id) || empty($list_id))
			return;

		$acy_id = (int)$acy_id;
		hikaserial::toInteger($list_ids);

		$list_ids = array();
		foreach($list_id as $i) {
			if(empty($user_lists[$i]) || (int)$user_lists[$i]->status == 0)
				continue;
			$list_ids[] = $i;
		}
		if(empty($list_ids))
			return;

		if(empty($this->listsubClass)) {
			$this->initAcymailing();
			$this->listsubClass = acymailing_get('class.listsub');
		}
		$this->listsubClass->updateSubscription($acy_id, array(0 => $list_ids));
	}
}
