<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>	<dl class="hika_options large">
		<dt><label for="data[plugin][plugin_params][attach_email]"><?php echo JText::_('ATTACH_IN_EMAILS');?></label></dt>
		<dd><?php
			echo JHTML::_('hikaselect.booleanlist', "data[plugin][plugin_params][attach_email]", '', @$this->element->plugin_params->attach_email);
		?></dd>

		<dt><label for="data[plugin][plugin_params][packs]"><?php echo JText::_('SERIAL_PACKS');?></label></dt>
		<dd><?php
			$packType = hikaserial::get('type.pack');
			echo $packType->displayMultiple('data[plugin][plugin_params][packs]', @$this->element->plugin_params->packs, 'all');
		?></dd>

		<dt><label for="data[plugin][plugin_params][attach_download]"><?php echo JText::_('ATTACH_AS_DOWNLOAD');?></label></dt>
		<dd><?php
			echo JHTML::_('hikaselect.booleanlist', "data[plugin][plugin_params][attach_download]", '', @$this->element->plugin_params->attach_download);
			if(!empty($this->element) && !empty($this->element->plugin_id)) {
				echo '#hikaserial:pdfserial:'.(int)$this->element->plugin_id;
			}
		?></dd>
	</dl>

</div></div>

<div class="hkc-xl-12 hkc-lg-12 hikashop_tile_block"><div>
	<div class="hikashop_tile_title"><?php
		echo JText::_('PDF_GENERATION');
	?></div>

<?php
	$config_data = array(
		'PDF' => array(
			JHTML::_('select.option', 'pdf.newpage', JText::_('PDFSERIAL_NEWPAGE')),
			JHTML::_('select.option', 'pdf.title', JText::_('PDFSERIAL_TITLE')),
			JHTML::_('select.option', 'pdf.subject', JText::_('PDFSERIAL_SUBJECT')),
			JHTML::_('select.option', 'pdf.author', JText::_('PDFSERIAL_AUTHOR')),
			JHTML::_('select.option', 'pdf.keywords', JText::_('PDFSERIAL_KEYWORDS')),
			JHTML::_('select.option', 'pdf.margins', JText::_('PDFSERIAL_MARGINS')),
			JHTML::_('select.option', 'pdf.pagebreak', JText::_('PDFSERIAL_PAGEBREAK')),
			JHTML::_('select.option', 'pdf.line', JText::_('PDFSERIAL_LINE')),
			JHTML::_('select.option', 'pdf.rect', JText::_('PDFSERIAL_RECT')),
		),
		'Data' => array(
			JHTML::_('select.option', 'serial.serial_data', JText::_('SERIAL_DATA')),
			JHTML::_('select.option', 'serial.', JText::_('ATTACHSERIAL_TYPE_SERIAL')),
			JHTML::_('select.option', 'order.', JText::_('ATTACHSERIAL_TYPE_ORDER')),
			JHTML::_('select.option', 'order_product.', JText::_('ATTACHSERIAL_TYPE_ORDER_PRODUCT')),
			JHTML::_('select.option', 'product.', JText::_('ATTACHSERIAL_TYPE_PRODUCT')),
			JHTML::_('select.option', 'product.image', JText::_('ATTACHSERIAL_TYPE_PRODUCT_IMAGE')),
			JHTML::_('select.option', 'customer.', JText::_('ATTACHSERIAL_TYPE_ORDER_CUSTOMER')),
			JHTML::_('select.option', 'shipping.', JText::_('ATTACHSERIAL_TYPE_ORDER_SHIPPING')),
			JHTML::_('select.option', 'billing.', JText::_('ATTACHSERIAL_TYPE_ORDER_BILLING')),
			JHTML::_('select.option', 'entry.', JText::_('ATTACHSERIAL_TYPE_ENTRY')),
			JHTML::_('select.option', 'rawtext.', JText::_('ATTACHSERIAL_TYPE_RAW_TEXT')),
			JHTML::_('select.option', 'dyntext.', JText::_('ATTACHSERIAL_TYPE_DYN_TEXT')),
			JHTML::_('select.option', 'translation.', JText::_('ATTACHSERIAL_TYPE_TRANSLATION')),
			JHTML::_('select.option', 'option_product.', JText::_('ATTACHSERIAL_TYPE_OPTION_PRODUCT')),
			JHTML::_('select.option', 'option_product.image', JText::_('ATTACHSERIAL_TYPE_OPTION_PRODUCT_IMAGE')),
			JHTML::_('select.option', 'option_order.', JText::_('ATTACHSERIAL_TYPE_OPTION_ORDER')),
			JHTML::_('select.option', 'product_price.incvat', JText::_('ATTACHSERIAL_TYPE_PRODUCT_PRICE_INCVAT')),
			JHTML::_('select.option', 'product_price.excvat', JText::_('ATTACHSERIAL_TYPE_PRODUCT_PRICE_EXCVAT')),
			JHTML::_('select.option', 'full_product_price.incvat', JText::_('ATTACHSERIAL_TYPE_FULL_PRODUCT_PRICE_INCVAT')),
			JHTML::_('select.option', 'full_product_price.excvat', JText::_('ATTACHSERIAL_TYPE_FULL_PRODUCT_PRICE_EXCVAT')),
			JHTML::_('select.option', 'category.', JText::_('ATTACHSERIAL_TYPE_CATEGORY')),
			JHTML::_('select.option', 'category.image', JText::_('ATTACHSERIAL_TYPE_CATEGORY_IMAGE')),
			JHTML::_('select.option', 'manufacturer.', JText::_('ATTACHSERIAL_TYPE_MANUFACTURER')),
		)
	);
	$marketHelper = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikamarket'.DS.'helpers'.DS.'helper.php';
	if(file_exists($marketHelper)) {
		$config_data['Data'][] = JHTML::_('select.option', 'vendor_product.', JText::_('ATTACHSERIAL_TYPE_VENDOR'));
		$tables['vendor'] = '#__hikamarket_vendor';
	}

	if(!HIKASHOP_J40) {
		foreach($config_data as $optGroup => $values) {
			$text_types[] = JHTML::_('select.optgroup', $optGroup);
			foreach($values as $v) {
				$text_types[] = $v;
			}
			$text_types[] = JHTML::_('select.optgroup', '');
		}
		array_pop($text_types);
	} else {
		foreach($config_data as $optGroup => $values) {
			$text_types[] = array(
				'text' => $optGroup,
				'items' => $values
			);
		}
	}
	$tables = array(
		'serial' => 'serial',
		'order' => 'shop.order',
		'order_product' => 'shop.order_product',
		'product' => 'shop.product',
		'customer' => 'shop.user',
		'shipping' => 'shop.address',
		'billing' => 'shop.address',
		'option_product' => 'shop.product',
		'option_order' => 'shop.order_product',
		'category' => 'shop.category',
		'manufacturer' => 'shop.category',
	);

	$text_formats = array(
		JHTML::_('select.option', 'raw', JText::_('ATTACHSERIAL_FORMAT_RAW')),
		JHTML::_('select.option', 'strip', JText::_('ATTACHSERIAL_FORMAT_TOTEXT')),
		JHTML::_('select.option', 'html', JText::_('ATTACHSERIAL_FORMAT_HTML')),
		JHTML::_('select.option', 'date.', JText::_('ATTACHSERIAL_FORMAT_DATE')),
		JHTML::_('select.option', 'price', JText::_('ATTACHSERIAL_FORMAT_PRICE')),
		JHTML::_('select.option', 'qrcode.', JText::_('ATTACHSERIAL_FORMAT_QRCODE'), 'value', 'text', false),
		JHTML::_('select.option', 'barcode.', JText::_('ATTACHSERIAL_FORMAT_BARCODE'), 'value', 'text', false),
		JHTML::_('select.option', 'image.', JText::_('ATTACHSERIAL_FORMAT_IMAGE')),
	);

	$fonts = array(
		'arial' => 'arial',
		'courier' => 'courier',
		'helvetica' => 'helvetica',
		'symbol' => 'symbol',
		'times' => 'times',
	);

	$config = hikaserial::config();
	$main_lib = $config->get('main_pdf_lib', 'tcpdf');
	$fontFolder = HIKASERIAL_MEDIA.'fonts'.DS.$main_lib.DS;
	jimport('joomla.filesystem.folder');
	$files = JFolder::files($fontFolder);
	$p = '';
	foreach($files as $f) {
		if(substr($f, -4) != '.php')
			continue;
		if(!empty($p) && (strpos($f, $p.'b') === 0 || strpos($f, $p.'i') === 0))
			continue;
		$p = substr($f, 0, -4);
		$fonts[$p] = $p;
	}

	$new_types = array();
	$new_formats = array();
	JPluginHelper::importPlugin('hikaserial');
	$dispatcher = hikaserial::getDispatcher();
	$dispatcher->trigger('onGetCustomPdfSerialFormats', array(&$new_types, &$new_formats));
	if(!empty($new_types)) {
		foreach($new_types as $t) {
			$text_types[] = $t;
		}
	}
	if(!empty($new_formats)) {
		foreach($new_formats as $f) {
			$text_formats[] = $f;
		}
	}
?>
<dl class="hika_options large">
	<dt><?php echo JText::_('PDFSERIAL_TEMPLATEPDF'); ?></dt>
	<dd>
		<input style="width:98%" type="text" class="form-control" name="data[plugin][plugin_params][pdf_path]" value="<?php echo @$this->element->plugin_params->pdf_path; ?>"/>
<?php
if(!empty($this->element->plugin_params->pdf_path)) {
	$pdfPlugin = hikaserial::import('hikaserial', 'pdfserial');
	$pdf_file_path = $pdfPlugin->getFilePath($this->element->plugin_params->pdf_path);
	if(!empty($pdf_file_path)) {
		echo '<br/><img src="'.HIKASERIAL_IMAGES.'icon-16/publish.png" alt="" style="vertical-align:middle;"/>'.JText::sprintf('ATTACHSERIAL_PDF_EXISTS', $this->element->plugin_params->pdf_path);
	} else {
		echo '<br/><img src="'.HIKASERIAL_IMAGES.'icon-16/unpublish.png" alt="" style="vertical-align:middle;"/>'.JText::sprintf('ATTACHSERIAL_PDF_NOT_EXISTS', $this->element->plugin_params->pdf_path);
	}

}
?>
	</dd>

	<dt><?php echo JText::_('ATTACHSERIAL_FONT');?></dt>
	<dd><?php
		jimport('joomla.filesystem.folder');
		$default_font = @$this->element->plugin_params->default_font;
		if(empty($default_font))
			$default_font = 'arial';
		echo JHTML::_('select.genericlist', $fonts, 'data[plugin][plugin_params][default_font]', 'class="custom-select"', 'value', 'text', $default_font);

		$inheritFont = array(JHTML::_('select.option', '', JText::_('HIKA_INHERIT')));
		$fonts = array_merge($inheritFont, $fonts);
	?></dd>
</dl>

<table class="adminlist pad5 table table-striped table-hover" style="width:100%">
	<thead>
		<tr>
			<th><?php echo JText::_('ATTACHSERIAL_TEXT_TYPE');?></th>
			<th><?php echo JText::_('ATTACHSERIAL_TEXT_FORMAT');?></th>
			<th><?php echo JText::_('SERIAL_TEXT_X_Y');?></th>
			<th><?php echo JText::_('SERIAL_TEXT_W_H');?></th>
			<th><?php echo JText::_('SERIAL_TEXT_SIZE_COLOR');?></th>
			<th><?php echo JText::_('ATTACHSERIAL_FONT');?></th>
			<th><a href="#add" onclick="return window.pdfserial.pdfserialAddText();"><img src="<?php echo HIKASERIAL_IMAGES;?>icon-16/add.png" alt="<?php echo JText::_('HIKA_ADD'); ?></a></th>
		</tr>
	</thead>
	<tbody id="pdfserial_texts">
<?php
	$k = 1;
	$i = 0;
	if(!empty($this->element->plugin_params->texts)) {
		foreach($this->element->plugin_params->texts as $text) {
			$map = 'data[plugin][plugin_params][texts][' . $i . ']';
?>
		<tr class="row<?php echo $k; ?>">
			<td><?php
				if(!HIKASHOP_J40)
					echo JHTML::_('select.genericlist', $text_types, $map.'[type]', 'onchange="window.pdfserial.changeType(this);"', 'value', 'text', $text['type'], 'attserial_type_' . $i);
				else
					echo JHTML::_('select.groupedlist', $text_types, $map.'[type]', array('list.attr' => 'class="custom-select"', 'group.id' => 'id', 'list.select' => array($text['type']), 'id' => 'attserial_type_' . $i) );
			?><br/><input size="30" type="text" style="<?php if(substr(@$text['type'], -1) != '.') echo 'display:none';?>" id="attserial_type_ex_<?php echo $i;?>" name="<?php echo $map.'[type_ex]'; ?>" value="<?php echo $this->escape(@$text['type_ex']); ?>"/></td>
			<td><?php
				echo JHTML::_('select.genericlist', $text_formats, $map.'[format]', 'class="custom-select" onchange="window.pdfserial.changeFormat(this);"', 'value', 'text', $text['format'], 'attserial_format_' . $i);
			?><br/><input type="text" style="<?php if(substr(@$text['format'], -1) != '.') echo 'display:none';?>" id="attserial_format_ex_<?php echo $i;?>" name="<?php echo $map.'[format_ex]'; ?>" value="<?php echo $this->escape(@$text['format_ex']); ?>"/></td>
			<td>
				<?php echo JText::_('SERIAL_TEXT_X');?> <input type="text" class="form-control" size="8" name="<?php echo $map.'[x]'; ?>" value="<?php echo $this->escape(@$text['x']); ?>"/>px<br/>
				<?php echo JText::_('SERIAL_TEXT_Y');?> <input type="text" class="form-control" size="8" name="<?php echo $map.'[y]'; ?>" value="<?php echo $this->escape(@$text['y']); ?>"/>px
			</td>
			<td>
				<?php echo JText::_('SERIAL_TEXT_W');?> <input type="text" class="form-control" size="8" name="<?php echo $map.'[w]'; ?>" value="<?php echo $this->escape(@$text['w']); ?>"/>px<br/>
				<?php echo JText::_('SERIAL_TEXT_H');?> <input type="text" class="form-control" size="8" name="<?php echo $map.'[h]'; ?>" value="<?php echo $this->escape(@$text['h']); ?>"/>px
			</td>
			<td>
				<input type="text" class="form-control" size="8" name="<?php echo $map.'[size]'; ?>" value="<?php echo $this->escape(@$text['size']); ?>"/>px<br/>
				#<input type="text" class="form-control" size="8" name="<?php echo $map.'[color]'; ?>" value="<?php echo $this->escape(@$text['color']); ?>"/>
			</td>
			<td><?php echo JHTML::_('select.genericlist', $fonts, $map.'[font]', 'class="custom-select"', 'value', 'text', @$text['font'], 'attserial_fonts_' . $i); ?></td>
			<td>
				<a href="#delete" onclick="hikaserial.deleteRow(this); return false;"><img src="<?php echo HIKASERIAL_IMAGES; ?>icon-16/delete.png" alt="<?php echo JText::_('HIKA_DELETE');?>"/></a>
			</td>
		</tr>
<?php
			$k = 1 - $k;
			$i++;
		}
	}
?>
		<tr id="pdfserial_tpl_line" class="row<?php echo $k;?>" style="display:none">
			<td><?php
				if(!HIKASHOP_J40)
					echo JHTML::_('select.genericlist', $text_types, '{text_type}', 'class="no-chzn" onchange="window.pdfserial.changeType(this);"', 'value', 'text', '', 'attserial_type_{id}');
				else
					echo JHTML::_('select.groupedlist', $text_types, '{text_type}', array('list.attr' => 'class="custom-select" onchange="window.pdfserial.changeType(this);"', 'group.id' => 'id', 'list.select' => array(''), 'id' => 'attserial_type_{id}') );
			?><br/><input size="30" type="text" style="display:none" id="attserial_type_ex_{id}"  name="{text_type_ex}" value=""/></td>
			<td><?php
				echo JHTML::_('select.genericlist', $text_formats, '{text_format}', 'class="custom-select no-chzn" onchange="window.pdfserial.changeFormat(this);"', 'value', 'text', '', 'attserial_format_{id}');
			?><br/><input type="text" style="display:none" id="attserial_format_ex_{id}" name="{text_format_ex}" value=""/></td>
			<td>
				<?php echo JText::_('SERIAL_TEXT_X');?> <input type="text" class="form-control" size="8" name="{text_x}" value=""/>px<br/>
				<?php echo JText::_('SERIAL_TEXT_Y');?> <input type="text" class="form-control" size="8" name="{text_y}" value=""/>px
			</td>
			<td>
				<?php echo JText::_('SERIAL_TEXT_W');?> <input type="text" class="form-control" size="8" name="{text_w}" value=""/>px<br/>
				<?php echo JText::_('SERIAL_TEXT_H');?> <input type="text" class="form-control" size="8" name="{text_h}" value=""/>px
			</td>
			<td>
				<input type="text" class="form-control" size="8" name="{text_size}" value=""/>px<br/>
				#<input type="text" class="form-control" size="8" name="{text_color}" value=""/>
			</td>
			<td><?php echo JHTML::_('select.genericlist', $fonts, '{text_color}', 'class="custom-select no-chzn"', 'value', 'text', '', 'attserial_fonts_{id}'); ?></td>
			<td>
				<a href="#delete" onclick="hikaserial.deleteRow(this); return false;"><img src="<?php echo HIKASERIAL_IMAGES; ?>icon-16/delete.png" alt="<?php echo JText::_('HIKA_DELETE');?>"/></a>
			</td>
		</tr>
	</tbody>
</table>
<script type="text/javascript">
window.pdfserial = {
	cpt: <?php echo $i; ?>,
	pdfserialAddText: function() {
		var t = this, d = document,
			tbody = d.getElementById('hikaserial_pdfserial_texts'),
			htmlblocks = {
				id:t.cpt,
				text_type: 'data[plugin][plugin_params][texts]['+t.cpt+'][type]',
				text_type_ex: 'data[plugin][plugin_params][texts]['+t.cpt+'][type_ex]',
				text_format: 'data[plugin][plugin_params][texts]['+t.cpt+'][format]',
				text_format_ext: 'data[plugin][plugin_params][texts]['+t.cpt+'][format_ext]',
				text_x: 'data[plugin][plugin_params][texts]['+t.cpt+'][x]',
				text_y: 'data[plugin][plugin_params][texts]['+t.cpt+'][y]',
				text_w: 'data[plugin][plugin_params][texts]['+t.cpt+'][w]',
				text_h: 'data[plugin][plugin_params][texts]['+t.cpt+'][h]',
				text_size: 'data[plugin][plugin_params][texts]['+t.cpt+'][size]',
				text_color: 'data[plugin][plugin_params][texts]['+t.cpt+'][color]',
			};
		hikaserial.dupRow('pdfserial_tpl_line', htmlblocks, 'pdfserial_text_' + t.cpt);
<?php if(HIKASHOP_BACK_RESPONSIVE) { ?>
		try {
			jQuery('#attserial_type_'+t.cpt).removeClass("chzn-done").chosen();
			jQuery('#attserial_format_'+t.cpt).removeClass("chzn-done").chosen();
			jQuery('#attserial_fonts_'+t.cpt).removeClass("chzn-done").chosen();
		}catch(e){}
<?php } ?>
		t.cpt++;
		return false;
	},
	changeType: function(el) { return this.dropdownChange(el, 'attserial_type'); },
	changeFormat: function(el) { return this.dropdownChange(el, 'attserial_format'); },
	dropdownChange: function(el, key) {
		var d = document,
			id = el.id.replace(key+'_', key+'_ex_'),
			dest = d.getElementById(id);
		if(el.value.substring(el.value.length - 1) == '.') {
			dest.style.display = '';
			dest.focus();
		} else {
			dest.style.display = 'none';
		}
	}
}
</script>
<div class="hkc-lg-6 hkc-md-12 hikashop_tile_block"><div>
	<div class="hikashop_tile_title"><?php
		echo JText::_('ATTACHSERIAL_DATABASE_FIELDS');
	?></div>
	<dl class="hika_options large">
<?php
$db = JFactory::getDBO();
foreach($tables as $key => $tbl) {
	if(substr($tbl, 0, 1) != '#')
		$tbl = hikaserial::table($tbl);
	$current = $db->getTableColumns($tbl);
	$fields = array_keys($current);

	$k = 'ATTACHSERIAL_TABLE_'.strtoupper($key);
	if(JText::_($k) == $k)
		$k = $key;
?>
		<dt><?php echo $k; ?></dt>
		<dd><?php
			if(!HIKASHOP_J40)
				echo JHTML::_('select.genericlist', $fields, '', 'class="chzn-done"', 'value', 'text', '', 'attachserial_fields_'.$key);
			else
				echo JHTML::_('select.genericlist', $fields, '', 'class="custom-select"', 'value', 'text', '', 'attachserial_fields_'.$key);
		?></dd>
<?php
}
?>
	</dl>
</div></div>
