<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikaserialRandomgen extends hikaserialPlugin {

	protected $type = 'generator';
	protected $multiple = true;
	protected $populate = true;
	protected $name = 'randomgen';
	protected $doc_form = 'randomgen-';

	protected $serial_default_format = '[a-zA-Z0-9]{size}';

	protected $pluginConfig = array(
		'size' => array('SERIAL_SIZE', 'input'),
		'format' => array('SERIAL_FORMAT', 'input', '[a-zA-Z0-9]{size}'),
		'test' => array('SERIAL_TEST', 'serial_test')
	);


	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	public function generate(&$pack, &$order, $quantity, &$serials) {
		if(!isset($pack->randomgen))
			return;

		parent::pluginParams($pack->randomgen);

		if(empty($this->plugin_params->format) || !preg_match_all('#\\\[|\\\]|\[[^]]+\]\{.*\}|\[.*\]|.#iU', $this->plugin_params->format, $matches)) {
			$matches = array(array('[a-zA-Z0-9]{size}'));
		}

		$config = hikaserial::config();
		$fastRandom = (int)$config->get('use_fast_random', 0);

		if(empty($this->plugin_params->size) || $this->plugin_params->size == 0) {
			$this->plugin_params->size = 15;
		}

		for($q = 0; $q < $quantity; $q++) {
			$serial = '';

			$randomize = $this->initRandomize($fastRandom);

			foreach($matches[0] as $m) {
				if(strlen($m) == 1) {
					$serial .= $m;
					continue;
				}

				list($format, $repeat) = $this->generatorExtractRepeater($m);

				$serial .= $this->getRandomContent($format, $repeat, $randomize, $fastRandom);
			}

			$serials[] = $serial;
		}
		return true;
	}

	public function configurationHead() {
		return array(
			1 => 'format',
			2 => 'size'
		);
	}

	public function configurationLine($id = 0, $conf = null) {
		switch($id) {
			case 1:
				if(empty($conf->generator_params->format))
					return $this->serial_default_format;
				return $conf->generator_params->format;
			case 2:
				if(empty($conf->generator_params->size))
					return 12;
				return $conf->generator_params->size;
		}
		return null;
	}
}
