<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
jimport('joomla.plugin.plugin');

class plgUserHikasubscription extends JPlugin {
	private function initParams() {
		if(isset($this->params))
			return;

		$plugin = JPluginHelper::getPlugin('user', 'hikasubscription');
		if(version_compare(JVERSION, '2.5', '<')) {
			jimport('joomla.html.parameter');
			$this->params = new JParameter($plugin->params);
		} else {
			$this->params = new JRegistry($plugin->params);
		}
	}

	private function init() {
		static $init = null;
		if($init !== null)
			return $init;

		$init = defined('HIKASERIAL_COMPONENT');
		if(!$init) {
			if(!defined('DS'))
				define('DS', DIRECTORY_SEPARATOR);
			$filename = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php';
			if(file_exists($filename)) {
				include_once($filename);
				$init = defined('HIKASERIAL_COMPONENT');
			}
		}
		return $init;
	}

	public function onUserLogin($user, $options) {
		return $this->onLoginUser($user, $options);
	}

	protected function _isAdmin() {
		static $isAdmin = null;
		if($isAdmin !== null)
			return $isAdmin;
		$app = JFactory::getApplication();
		$isAdmin = version_compare(JVERSION,'4.0','<') ? $app->isAdmin() : $app->isClient('administrator');
		return $isAdmin;
	}

	public function onLoginUser($user, $options) {
		if($this->_isAdmin())
			return true;

		if(empty($user['id']) && empty($user['username']))
			return;

		$user_id = 0;
		if(!empty($user['id'])) {
			$user_id = (int)$user['id'];
		} else {
			jimport('joomla.user.helper');
			$instance = new JUser();
			if($id = intval(JUserHelper::getUserId($user['username'])))  {
				$instance->load($id);
			}
			if($instance->get('block') == 0) {
				$user_id = (int)$instance->id;
			}
		}
		if(empty($user_id))
			return;

		if(!$this->init())
			return;

		$subscriptionClass = hikaserial::get('class.subscription');
		if(empty($subscriptionClass))
			return;

		$hk_user_id = hikaserial::loadUser(false);
		$subscriptionClass->refreshStatuses(array('user' => $hk_user_id));
	}
}
