<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialCronHelper {

	public function process(&$messages) {
		if(!hikaserial::level(1))
			return false;

		$config = hikaserial::config();
		$now = time();

		$last_cron = (int)$config->get('cron_last_subscriptions', 0);
		$period = (int)$config->get('cron_period_subscriptions', 1200); // 20min
		if( empty($last_cron) || $last_cron + $period < $now ) {
			$subscriptionClass = hikaserial::get('class.subscription');
			if(!empty($subscriptionClass)) {
				$subscriptionClass->refreshStatuses(null);
				$messages[] = 'Subscription checked';
			}
			$cfg = array('cron_last_subscriptions' => $now);
			$config->save($cfg);
		}

		$last_cron = (int)$config->get('cron_last_queue', 0);
		$period = (int)$config->get('cron_period_queue', 36000); // 10h
		if( empty($last_cron) || $last_cron + $period < $now ) {
			$queueClass = hikaserial::get('class.queue');
			if(!empty($queueClass)) {
				$ret = $queueClass->generateQueue($last_cron, $now, false);

				if($ret)
					$messages[] = 'Queue generated';
			}

			$cfg = array('cron_last_queue' => $now);
			$config->save($cfg);
		}

		$last_cron = (int)$config->get('cron_last_emails', 0);
		$period = (int)$config->get('cron_period_emails', 900); // 15min
		if( empty($last_cron) || $last_cron + $period < $now ) {
			$queueClass = hikaserial::get('class.queue');
			if(!empty($queueClass)) {
				$ret = $queueClass->processQueue(null);

				if($ret)
					$messages[] = 'Queue processed';
			}

			$cfg = array('cron_last_emails' => $now);
			$config->save($cfg);
		}
	}
}
