<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialUpdateHelper {

	private $db;

	public function __construct() {
		$this->db = JFactory::getDBO();
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		$this->update = hikaInput::get()->getBool('update');
	}

	public function addDefaultModules() {
	}

	public function installExtensions() {
		$path = HIKASERIAL_BACK.'extensions';
		$dirs = JFolder::folders($path);

		$query = 'SELECT CONCAT(`folder`,`element`) FROM `#__extensions` WHERE `folder` IN '.
				"( 'hikashop','hikaserial' ) ".
				"OR `element` LIKE '%hikaserial%' ".
				"OR `element` LIKE '%hikasubscription%' ".
				"OR `element` LIKE '%paypal_recurring%' ".
				"OR `element` LIKE '%serialprivatecontent%' ";
		$this->db->setQuery($query);
		$existingExtensions = $this->db->loadColumn();

		$success = array();
		$plugins = array();
		$modules = array();

		$exts = array(
			'plg_hikashop_serial' => array('HikaShop HikaSerial bridge plugin', 0, 1),
			'plg_hikaserial_attachserial' => array('AttachSerial - HikaSerial plugin', 5, 0),
			'plg_hikaserial_coupongen' => array('Coupon - HikaSerial Generator plugin', 2, 1),
			'plg_hikaserial_eangen' => array('EAN - HikaSerial Generator plugin', 7, 1),
			'plg_hikaserial_groupconsumer' => array('GroupAssociation - HikaSerial Consumer plugin', 10, 0),
			'plg_hikaserial_groupfilterconsumer' => array('Group filter consumer', 11, 0),
			'plg_hikaserial_groupsubscriber' => array('GroupSubscriber - HikaSerial Subscriber plugin', 9, 1),
			'plg_hikaserial_mailtocustomfield' => array('MailToCustomField - HikaSerial plugin', 11, 0),
			'plg_hikaserial_pdfserial' => array('PDFSerial - HikaSerial plugin', 12, 0),
			'plg_hikaserial_pdfsecure' => array('PDFSecure - HikaSerial plugin', 15, 0),
			'plg_hikaserial_pointsconsumer' => array('User Points - HikaSerial Consumer plugin', 13, 0),
			'plg_hikaserial_pointsgen' => array('User Points - HikaSerial Generator plugin', 14, 0),
			'plg_hikaserial_productaddconsumer' => array('Product-add consumer', 10, 0),
			'plg_hikaserial_randomgen' => array('Random - HikaSerial Generator plugin', 1, 1),
			'plg_hikaserial_serialperorder' => array('Serial Per Order - HikaSerial plugin', 14, 0),
			'plg_hikaserial_seriesgen' => array('Series - HikaSerial Generator plugin', 3, 0),
			'plg_hikaserial_timelimitedgen' => array('Time limited - HikaSerial Generator plugin', 14, 0),
			'plg_hikashop_productaddcheck' => array('HikaShop serial product-add check', 10, 0),
			'plg_hikashoppayment_paypal_recurring' => array('Hikashop Paypal Recurring Payment Plugin', 10, 1),
			'plg_user_hikasubscription' => array('HikaSubscription - User Integration plugin', 10, 1),
			'mod_hikaserial_consume' => array('HikaSerial consume module', 10, 1),
			'plg_acymailing_hikaserial' => array('AcyMailing Tag : HikaSerial content', 20, 1),
			'plg_content_serialprivatecontent' => array('Serial Private Content - HikaSerial', 20, 1),
			'plg_editors-xtd_serialprivatecontent' => array('Serial Private Content editor button - HikaSerial', 20, 1),
		);

		$listTables = $this->db->getTableList();
		$this->errors = array();
		foreach($dirs as $dir) {
			$arguments = explode('_', $dir, 3);
			$report = true;
			if(!empty($exts[$dir][3])) {
				$report = false;
			}
			$prefix = array_shift($arguments);

			if($prefix != 'plg' && $prefix != 'mod') {
				hikaserial::display('Could not handle : '.$dir, 'error');
				continue;
			}

			$newExt = new stdClass();
			$newExt->enabled = 1;
			$newExt->params = '{}';
			$newExt->name = isset($exts[$dir][0])?$exts[$dir][0]:$dir;
			$newExt->ordering = isset($exts[$dir][1])?$exts[$dir][1]:0;

			if(!isset($exts[$dir])) {
				$xmlFile = $path.DS.$dir.DS.$arguments[1].'.xml';
				$xml = simplexml_load_file($xmlFile);
				if (!empty($xml) && ($xml->getName() == 'install' || $xml->getName() == 'extension')) {
					$newExt->name = (string)$xml->name;
					if(!empty($xml->hikainstall)){
						$attribs = $xml->hikainstall->attributes();
						$newExt->ordering = (int)$attribs->ordering;
						$newExt->enabled = (int)$attribs->enable;
						$report = (int)$attribs->report;
					}
				}
				unset($xml);
			}

			if($prefix == 'plg') {

				$newExt->type = 'plugin';
				$newExt->folder = array_shift($arguments);
				$newExt->element = implode('_', $arguments);

				if(isset($exts[$dir][2]) && is_numeric($exts[$dir][2])) {
					$newExt->enabled = (int)$exts[$dir][2];
				}

				if(!hikaserial::createDir(HIKASERIAL_ROOT.'plugins'.DS.$newExt->folder, $report))
					continue;

				$destinationFolder = HIKASERIAL_ROOT.'plugins'.DS.$newExt->folder.DS.$newExt->element;
				if(!hikaserial::createDir($destinationFolder))
					continue;

				if(!$this->copyFolder($path.DS.$dir, $destinationFolder))
					continue;

				if(in_array($newExt->folder.$newExt->element, $existingExtensions))
					continue;

				$plugins[] = $newExt;

			} else {

				$newExt->type = 'module';
				$newExt->folder = '';
				$newExt->element = $dir;

				$destinationFolder = HIKASERIAL_ROOT.'modules'.DS.$dir;

				if(!hikaserial::createDir($destinationFolder))
					continue;

				if(!$this->copyFolder($path.DS.$dir, $destinationFolder))
					continue;

				if(in_array($newExt->element, $existingExtensions))
					continue;

				$modules[] = $newExt;
			}
		}

		if(!empty($this->errors))
			hikaserial::display($this->errors, 'error');

		if( empty($plugins) && empty($modules) ) {
			return;
		}

		$extensions = array_merge($plugins, $modules);

		$success = array();
		if(!empty($extensions)) {
			$query = 'INSERT INTO `#__extensions` (`name`,`element`,`folder`,`enabled`,`ordering`,`type`,`access`) VALUES ';

			$sep = '';
			foreach($extensions as $oneExt) {
				$query .= $sep.'('.$this->db->Quote($oneExt->name).','.$this->db->Quote($oneExt->element).','.$this->db->Quote($oneExt->folder).','.$oneExt->enabled.','.$oneExt->ordering;
				$query .= ','.$this->db->Quote($oneExt->type).',1';

				$query .= ')';
				if($oneExt->type!='module') {
					$success[] = JText::sprintf('PLUG_INSTALLED', $oneExt->name);
				}
				$sep = ',';
			}

			$this->db->setQuery($query);
			$this->db->execute();
		}

		if(!empty($modules)) {
			foreach($modules as $oneModule) {
				$query = 'INSERT INTO `#__modules` (`title`,`position`,`published`,`module`,`access`,`language`) VALUES '.
					'('.$this->db->Quote($oneModule->name).",'position-7',0,".$this->db->Quote($oneModule->element).",1,'*')";
				$this->db->setQuery($query);
				$this->db->execute();
				$moduleId = $this->db->insertid();

				$this->db->setQuery('INSERT IGNORE INTO `#__modules_menu` (`moduleid`,`menuid`) VALUES ('.$moduleId.',0)');
				$this->db->execute();

				$success[] = JText::sprintf('MODULE_INSTALLED', $oneModule->name);
			}
		}

		if(!empty($success)) {
			hikaserial::display('<ul><li>'.implode('</li><li>', $success).'</li></ul>', 'success');
		}
	}

	public function copyFolder($from, $to) {
		$ret = true;

		$allFiles = JFolder::files($from);
		foreach($allFiles as $oneFile) {
			if(file_exists($to.DS.'index.html') && $oneFile == 'index.html')
				continue;
			if(JFile::copy($from.DS.$oneFile,$to.DS.$oneFile) !== true) {
				$this->errors[] = 'Could not copy the file from '.$from.DS.$oneFile.' to '.$to.DS.$oneFile;
				$ret = false;
			}
		}
		$allFolders = JFolder::folders($from);
		if(!empty($allFolders)) {
			foreach($allFolders as $oneFolder) {
				if(!hikaserial::createDir($to.DS.$oneFolder))
					continue;
				if(!$this->copyFolder($from.DS.$oneFolder,$to.DS.$oneFolder))
					$ret = false;
			}
		}
		return $ret;
	}

	public function installMenu($code = '') {
		if(empty($code)) {
			$lang = JFactory::getLanguage();
			$code = $lang->getTag();
		}
		$path = hikashop_getLanguagePath(JPATH_ROOT).DS.$code.DS.$code.'.'.HIKASERIAL_COMPONENT.'.ini';
		if(!file_exists($path))
			return;
		$content = file_get_contents($path);
		if(empty($content))
			return;

		$menuFileContent = strtoupper(HIKASERIAL_COMPONENT).'="'.HIKASERIAL_NAME.'"'."\r\n".strtoupper(HIKASERIAL_NAME).'="'.HIKASERIAL_NAME.'"'."\r\n";
		$menuStrings = array('SERIALS','PACKS','PLUGINS','HELP','UPDATE_ABOUT');
		foreach($menuStrings as $s) {
			preg_match('#(\n|\r)(HIKA_)?'.$s.'="(.*)"#i',$content,$matches);
			if(empty($matches[3]))
				continue;
			$menuFileContent .= $s.'="'.$matches[3].'"'."\r\n";
		}

		preg_match_all('#(\n|\r)('.strtoupper(HIKASERIAL_COMPONENT).'.*)="(.*)"#iU', $content, $matches);
		if(!empty($matches)) {
			$menuFileContent .= implode('',$matches[0]);
		}
		$menuFileContent.="\r\n".'COM_HIKASERIAL_CONFIGURATION="HikaSerial"';

		$menuPath = HIKASERIAL_ROOT.'administrator'.DS.'language'.DS.$code.DS.$code.'.'.HIKASERIAL_COMPONENT.'.sys.ini';
		if(!JFile::write($menuPath, $menuFileContent)) {
			hikaserial::display(JText::sprintf('FAIL_SAVE',$menuPath),'error');
		}
	}

	private function installOne($folder) {
		if(empty($folder))
			return false;
		unset($GLOBALS['_JREQUEST']['installtype']);
		unset($GLOBALS['_JREQUEST']['install_directory']);
		hikaInput::get()->set('installtype', 'folder');
		hikaInput::get()->set('install_directory', $folder);
		$_REQUEST['installtype'] = 'folder';
		$_REQUEST['install_directory'] = $folder;
		$controller = new hikaserialBridgeController(array(
			'base_path'=> HIKASERIAL_ROOT.'administrator'.DS.'components'.DS.'com_installer',
			'name'=>'Installer',
			'default_task' => 'installform'
		));
		$model = $controller->getModel('Install');
		return $model->install();
	}

	public function addUpdateSite() {
		$config = hikaserial::config();
		$newconfig = new stdClass();
		$newconfig->website = HIKASHOP_LIVE;
		$config->save($newconfig);

		$query = 'SELECT update_site_id FROM `#__update_sites` '.
			' WHERE (location LIKE \'%hikaserial%\' OR location LIKE \'%hikasubscription%\') AND type = \'extension\' ' .
			' ORDER BY update_site_id ASC';
		$this->db->setQuery($query);
		$update_site_id = $this->db->loadColumn();

		if(count($update_site_id) > 1) {
			$keep_update_site_id = array_shift($update_site_id);
			$query = 'DELETE FROM `#__update_sites` WHERE update_site_id IN ('.implode(',',$update_site_id).')';
			$this->db->setQuery($query);
			$this->db->execute();
			$update_site_id = $keep_update_site_id;
		} else if(!empty($update_site_id))
			$update_site_id = reset($update_site_id);

		$object = new stdClass();
		$object->name = 'HikaSerial';
		$object->type = 'extension';
		$object->enabled = 1;
		$object->location = 'https://www.hikashop.com/component/updateme/updatexml/component-hikaserial/version-'.$config->get('version').'/level-'.$config->get('level').'/li-'.urlencode(base64_encode(HIKASHOP_LIVE)).'/file-extension.xml';

		if(empty($update_site_id)) {
			$this->db->insertObject('#__update_sites', $object);
			$update_site_id = $this->db->insertid();
		} else {
			$object->update_site_id = $update_site_id;
			$this->db->updateObject('#__update_sites', $object, 'update_site_id');
		}

		$query = 'SELECT extension_id FROM #__extensions WHERE `element` = \'com_hikaserial\' AND type = \'component\'';
		$this->db->setQuery($query);
		$extension_id = $this->db->loadResult();
		if(empty($update_site_id) || empty($extension_id))
			return false;

		$query = 'INSERT IGNORE INTO #__update_sites_extensions (update_site_id, extension_id) VALUES ('.$update_site_id.','.$extension_id.')';
		$this->db->setQuery($query);
		$this->db->execute();

		return true;
	}

	public function getUrl() {
		$urls = parse_url(HIKASERIAL_LIVE);
		$lurl = preg_replace('#^www2?\.#Ui', '', $urls['host'], 1);
		if(!empty($urls['path']))
			$lurl .= $urls['path'];
		return strtolower(rtrim($lurl, '/'));
	}

	public function addJoomfishElements() {
		$dstFolder = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS;
		if(!JFolder::exists($dstFolder))
			return true;
		$srcFolder = HIKASERIAL_BACK.'translations'.DS;
		$files = JFolder::files($srcFolder);
		if(empty($files))
			return true;
		foreach($files as $file) {
			JFile::copy($srcFolder.$file,$dstFolder.$file);
		}
		return true;
	}

	public function addDefaultData() {
		$query = 'SELECT * FROM `#__menu` WHERE `title` IN (\'com_hikaserial\',\'hikaserial\',\'HikaSerial\') AND `client_id`=1 AND `parent_id`=1 AND menutype IN (\'main\',\'mainmenu\',\'menu\')';
		$this->db->setQuery($query);
		$parentData = $this->db->loadObject();
		$parent = $parentData->id;

		$query = 'SELECT id FROM `#__menu` WHERE `parent_id`='.$parent;
		$this->db->setQuery($query);
		$submenu = $this->db->loadColumn();
		$old = count($submenu);

		$query = 'DELETE FROM `#__menu` WHERE `parent_id`='.$parent;
		$this->db->setQuery($query);
		$this->db->execute();

		$query = 'UPDATE `#__menu` SET `rgt`=`rgt`-'.($old*2).' WHERE `rgt`>='.$parentData->rgt;
		$this->db->setQuery($query);
		$this->db->execute();

		$query = 'UPDATE `#__menu` SET `rgt`=`rgt`+12 WHERE `rgt`>='.$parentData->rgt;
		$this->db->setQuery($query);
		$this->db->execute();

		$query = 'UPDATE `#__menu` SET `lft`=`lft`+12 WHERE `lft`>'.$parentData->lft;
		$this->db->setQuery($query);
		$this->db->execute();

		$left = $parentData->lft;
		$cid = $parentData->component_id;

		$elems = array(
			array('subscription', 'icon-16-article.png', 'Subscriptions', 'Subscriptions'),
			array('plan', 'icon-16-category.png', 'Plans', 'HIKA_SERIAL_PLANS'),
			array('serial', 'icon-16-article.png', 'Serials', 'Serials'),
			array('pack', 'icon-16-category.png', 'Packs', 'Packs'),
			array('plugins', 'icon-16-plugin.png', 'Plugins', 'Plugins'),
			array('config', 'icon-16-config.png', 'Configuration', 'Configuration'),
		);
		$query  = 'INSERT IGNORE INTO `#__menu` (`type`,`link`,`menutype`,`img`,`alias`,`title`,`client_id`,`parent_id`,`level`,`language`,`lft`,`rgt`,`component_id`) VALUES ';
		$l = $left;
		foreach($elems as $k => $elem) {
			if($k > 0)
				$query .= ',';
			$query .= "('component','index.php?option=com_hikaserial&ctrl=".$elem[0]."','".$parentData->menutype."','./templates/bluestork/images/menu/".$elem[1]."','".$elem[2]."','".$elem[3]."',1,".$parent.",2,'*',".($l+1).",".($l+2).",".$cid.")";
			$l += 2;
		}
		$this->db->setQuery($query);
		$this->db->execute();
	}
}
