<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
if(!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR);
include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php');

$taskGroup = hikaInput::get()->getCmd('ctrl', 'dashboard');
$hikaSerialConfig = hikaserial::config();
if(HIKASHOP_J40)
	JHtml::_('bootstrap.tooltip', '.hasTooltip', array('placement' => 'left'));
else
	JHTML::_('behavior.tooltip');
$bar = JToolBar::getInstance('toolbar');
$bar->addButtonPath(HIKASERIAL_BUTTON);

if($taskGroup != 'update' && !$hikaSerialConfig->get('installcomplete')) {
	$url = hikaserial::completeLink('update&task=install', false, true);
	echo '<script>document.location.href="'.$url.'";</script>'."\r\n".
		'Install not finished... You will be redirected to the second part of the install screen<br/>'.
		'<a href="'.$url.'">Please click here if you are not automatically redirected within 3 seconds</a>';
	return;
}

$currentuser = JFactory::getUser();
if($taskGroup != 'update' && !$currentuser->authorise('core.manage', 'com_hikaserial')) {
	throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
	return false;
}
if($taskGroup == 'config' && !$currentuser->authorise('core.admin', 'com_hikaserial')) {
	throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
	return false;
}

if(!include(HIKASERIAL_CONTROLLER.$taskGroup.'.php')) {
	echo 'controller '.$taskGroup.' not found';
	return;
}
ob_start();
$className = ucfirst($taskGroup).'Controller';
$classGroup = new $className();
hikaInput::get()->set('view', $classGroup->getName());
$classGroup->execute( hikaInput::get()->getCmd('task', 'listing'));
$classGroup->redirect();
if(hikaInput::get()->getString('tmpl') !== 'component') {
	echo hikaserial::footer();
}
echo '<div id="hikaserial_main_content" class="hikaserial_main_content hikas_j'.(int)HIKASHOP_JVERSION.'">'.ob_get_clean().'</div>';
