<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
?><?php
defined('_JEXEC') or die('Restricted access');

class hikaserialStreamInc
{
	private $varname;
	private $position;
	static $cache = array();

	public function stream_open($path, $mode, $options, &$opened_path) {
		$url = parse_url($path);
		$this->varname = $url['host'];
		if(!isset(hikaserialStreamInc::$cache[$this->varname])) {
			trigger_error('Cache '.$this->varname.' does not exist', E_USER_WARNING);
			return false;
		}
		$this->position = 0;
		return true;
	}

    public function stream_write($data) {
        $left = substr(hikaserialStreamInc::$cache[$this->varname], 0, $this->position);
        $right = substr(hikaserialStreamInc::$cache[$this->varname], $this->position + strlen($data));
        hikaserialStreamInc::$cache[$this->varname] = $left . $data . $right;
        $this->position += strlen($data);
        return strlen($data);
    }

	public function stream_read($count) {
		$ret = substr(hikaserialStreamInc::$cache[$this->varname], $this->position, $count);
		$this->position += strlen($ret);
		return $ret;
	}

	public function stream_eof() {
		return $this->position >= strlen(hikaserialStreamInc::$cache[$this->varname]);
	}

	public function stream_tell() {
		return $this->position;
	}

	public function stream_seek($offset, $whence) {
		if($whence==SEEK_SET) {
			$this->position = $offset;
			return true;
		}
		return false;
	}

	public function stream_stat() {
		return array();
	}
}

stream_wrapper_register('serialMem', 'hikaserialStreamInc');
