<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialDelayType {
	protected $values = array();
	protected $num;

	public function display($map, $value, $options = array()) {
		$this->values = array(
			JHTML::_('select.option', 'd', JText::_('DAYS')),
			JHTML::_('select.option', 'w', JText::_('WEEKS')),
			JHTML::_('select.option', 'm', JText::_('MONTHS')),
			JHTML::_('select.option', 'y', JText::_('YEARS')),
		);

		$map = str_replace('"','',$map);

		$input_value_map = !empty($map) ? $map.'[value]' : '';
		$input_type_map = !empty($map) ? $map.'[type]' : '';

		$input_type_options = 'class="custom-select" size="1"';

		if(!empty($options['id'])) {
			$input_value_map .= '" id="'.$options['id'].'_value';
			$input_type_options .= ' id="'.$options['id'].'_type"';
		}

		$return = $this->get($value);
		return '<span class="hikaserial_delay_type input-group">'.
			'<input type="text" name="'.$input_value_map.'" class="form-control" size="10" value="'.$return->value.'"/>'.
			JHTML::_('select.genericlist', $this->values, $input_type_map, $input_type_options, 'value', 'text', $return->type).
			'</span>';
	}

	public function get($value) {
		$ret = new stdClass();
		$ret->value = (int)$value;
		$ret->type = 'd';

		$t = substr($value, -1);
		if(in_array($t, array('d','w','m','y')))
			$ret->type = $t;
		return $ret;
	}

	public function show($value) {
		if(empty($value))
			return 0;

		$type = substr($value, -1);
		if(!in_array($type, array('d','w','m','y')))
			$type = 'd';

		$value = (int)$value;
		$translations = array(
			'd' => 'DAYS',
			'w' => 'WEEKS',
			'm' => 'MONTHS',
			'y' => 'YEARS',
		);
		return $value.' '.JText::_( $translations[$type] );
	}


	public function displayDelay($value) {
		return $this->show($value);
	}
}
