<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class hikaserialPackType {

	protected $values = array();

	public function __construct() {
		$this->app = JFactory::getApplication();
	}

	public function load($addEmpty = false, $filter = null) {
		if(empty($filter) || !in_array($filter, array('serial', 'subscription')))
			$filter = 'all';

		if(!isset($this->values[$filter])) {
			$db = JFactory::getDBO();

			$sql_where = '';
			if($filter == 'subscription') {
				$sql_where = ' WHERE pack_type = '.$db->quote($filter);
			} elseif($filter == 'serial') {
				$sql_where = ' WHERE pack_type IN (NULL,\'\','.$db->quote($filter).')';
			}

			$query = 'SELECT pack_id, pack_name FROM ' . hikaserial::table('pack').$sql_where.' ORDER BY pack_name ASC';
			$db->setQuery($query);
			$packs = $db->loadObjectList('pack_id');

			$this->values[$filter] = $packs;
		} else {
			$packs = $this->values[$filter];
		}

		$values = array();
		if($addEmpty) {
			$values[0] = JHTML::_('select.option', '', JText::_('PACKS_ALL'));
			if($filter == 'subscription')
				$values[0] = JHTML::_('select.option', '', JText::_('HIKA_PLANS_ALL'));
		}
		foreach($packs as $pack) {
			$values[(int)$pack->pack_id] = JHTML::_('select.option', (int)$pack->pack_id, $pack->pack_name);
		}
		return $values;
	}

	public function display($map, $value, $autoSubmit = false, $addEmpty = false, $options = array()) {
		$filter = null;
		if(!empty($options) && !empty($options['type']))
			$filter = $options['type'];

		$values = $this->load($addEmpty, $filter);

		$extra = 'class="custom-select" size="1"';
		if($autoSubmit)
			$extra .= ' onchange="document.adminForm.submit();"';
		return JHTML::_('select.genericlist', $values, $map, $extra, 'value', 'text', $value);
	}

	public function displaySingle($map, $value, $delete = false) {
		if(empty($this->nameboxType))
			$this->nameboxType = hikaserial::get('shop.type.namebox');

		return $this->nameboxType->display(
			$map,
			$value,
			hikashopNameboxType::NAMEBOX_SINGLE,
			'plg.hikaserial.pack',
			array(
				'delete' => $delete,
				'default_text' => '<em>'.JText::_('HIKA_NONE').'</em>'
			)
		);
	}

	public function displayMultiple($map, $values, $filter = 'serial') {
		if(empty($values))
			$values = array();
		else if(is_string($values))
			$values = explode(',', $values);

		if(empty($this->nameboxType))
			$this->nameboxType = hikaserial::get('shop.type.namebox');

		if(empty($filter) || $filter == 'all' || !in_array($filter, array('serial', 'subscription')))
			$selector = 'plg.hikaserial.packs';

		if($filter == 'serial')
			$selector = 'plg.hikaserial.pack';
		if($filter == 'subscription')
			$selector = 'plg.hikaserial.plan';

		return $this->nameboxType->display(
			$map,
			$values,
			hikashopNameboxType::NAMEBOX_MULTIPLE,
			$selector,
			array(
				'delete' => true,
				'default_text' => '<em>'.JText::_('HIKA_NONE').'</em>'
			)
		);
	}
}
