<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div class="hk-container-fluid">
	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('MAIN');
		?></div>
		<dl class="hika_options large">

	<dt><?php echo JText::_('AUTHORIZE_RENEW_BEFORE_EXPIRATION'); ?></dt>
	<dd><?php
		echo JHTML::_('hikaselect.booleanlist', 'config[subscription_renewal_before_expire]', '', $this->config->get('subscription_renewal_before_expire', true));
	?></dd>

	<dt><?php echo JText::_('AUTHORIZE_RENEW_BEFORE_EXPIRATION_PERIOD'); ?></dt>
	<dd><?php
		echo $this->delayType->display('config[subscription_renewal_before_period]', $this->config->get('subscription_renewal_before_period', 0));
	?></dd>

	<dt><?php echo JText::_('AUTHORIZE_RENEW_AFTER_EXPIRATION'); ?></dt>
	<dd><?php
		echo JHTML::_('hikaselect.booleanlist', 'config[subscription_renewal_after_expire]', '', $this->config->get('subscription_renewal_after_expire', false));
	?></dd>

	<dt><?php echo JText::_('AUTHORIZE_RENEW_AFTER_EXPIRATION_PERIOD'); ?></dt>
	<dd><?php
		echo $this->delayType->display('config[subscription_renewal_after_period]', $this->config->get('subscription_renewal_after_period', 0));
	?></dd>

		</dl>
	</div></div>

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('HIKA_ADVANCED_SETTINGS');
		?></div>
		<dl class="hika_options large">

	<dt><?php echo JText::_('SUBSCRIPTION_RECURRING_OPTIONAL'); ?></dt>
	<dd><?php
		echo JHTML::_('hikaselect.booleanlist', 'config[recurring_optional]', '', $this->config->get('recurring_optional', true));
	?></dd>

	<dt><?php echo JText::_('SUBSCRIPTION_UPGRADE_MODE'); ?></dt>
	<dd><?php
		$subscription_upgrade_modes = array(
			'diff' => 'SUBSCRIPTION_UPGRADE_MODE_DIFF',
			'extend' => 'SUBSCRIPTION_UPGRADE_MODE_EXTEND',
		);
		echo JHTML::_('select.genericlist', $subscription_upgrade_modes, 'config[subscription_upgrade_mode]', 'class="custom-select"', 'value', 'text', $this->config->get('subscription_upgrade_mode', 'diff'));
	?></dd>

	<dt><?php echo JText::_('SUBSCRIPTION_CRON_BATCH_SIZE'); ?></dt>
	<dd><input type="text" name="config[subscription_batch_size]" class="form-control" value="<?php echo $this->config->get('subscription_batch_size', 10);?>"/></dd>

	<dt><?php echo JText::_('EMAIL_CRON_BATCH_SIZE'); ?></dt>
	<dd><input type="text" name="config[email_batch_size]" class="form-control" value="<?php echo $this->config->get('email_batch_size', 10);?>"/></dd>

		</dl>
	</div></div>

	<div class="hkc-xl-12 hkc-lg-12 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('SERIAL_RENEWAL_EMAILS');
		?></div>
		<table class="adminlist table table-striped table-bordered" style="width:100%">
			<thead>
				<tr>
					<th><?php echo JText::_('HIKA_DAYS_BEFORE'); ?></th>
					<th><?php echo JText::_('HIKA_EMAIL_TEMPLATE'); ?></th>
					<th style="width:1%">
						<button class="hikabtn hikabtn-primary hikabtn-mini" onclick="window.hikaserial.dupRow('hikasbuscription_pack_emails_renewal_template'); return false;"><i class="fa fa-plus"></i> <?php echo JText::_('HIKA_NEW'); ?></button>
					</th>
				</tr>
			</thead>
			<tbody>
<?php
if(!empty($this->plan->emails) && !empty($this->plan->emails['renewal'])) {
	foreach($this->plan->emails['renewal'] as $k => $email) {
?>
				<tr>
					<td>
						<input type="hidden" name="data[emails][renewal][id][]" value="<?php echo (int)$k; ?>"/>
						<input type="text" class="form-control" name="data[emails][renewal][days][]" value="<?php echo (int)$email->pack_email_days; ?>"/>
					</td>
					<td><?php
						echo JHTML::_('select.genericlist', $this->email_templates, 'data[emails][renewal][template][]', 'class="custom-select"', 'value', 'text', $email->pack_email_template);
					?></td>
					<td>
						<a href="#delete" class="hikabtn" onclick="window.hikaserial.deleteRow(this);"><i class="far fa-trash-alt"></i></a>
					</td>
				</tr>
<?php
	}
}
?>
				<tr id="hikasbuscription_pack_emails_renewal_template" style="display:none;">
					<td>
						<input type="hidden" name="data[emails][renewal][id][]" value="0"/>
						<input type="text" class="form-control" name="data[emails][renewal][days][]" value=""/>
					</td>
					<td><?php echo JHTML::_('select.genericlist', $this->email_templates, 'data[emails][renewal][template][]', 'class="chzn-done no-chzn custom-select"', 'value', 'text', '', 'hikaserial_emails_renewal_template_dropdown'); ?></td>
					<td><a href="#delete" class="hikabtn" onclick="window.hikaserial.deleteRow(this);"><i class="far fa-trash-alt"></i></a></td>
				</tr>
			</tbody>
		</table>
	</div></div>

</div>
