<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class dashboardViewDashboard extends hikaserialView {

	const ctrl = 'dashboard';
	const name = HIKASERIAL_NAME;
	const icon = 'key';

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$fct = $this->getLayout();
		if(method_exists($this, $fct))
			$this->$fct($params);
		parent::display($tpl);
	}

	public function listing() {
		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl);

		$statisticsClass = hikaserial::get('class.statistics');
		$statistics = $statisticsClass->getDashboard();

		$statistics_slots = array();
		foreach($statistics as $key => &$stat) {
			$slot = (int)@$stat['slot'];
			$stat['slot'] = $slot;
			$stat['key'] = $key;
			$statistics_slots[ $slot ] = $slot;
		}
		unset($stat);
		asort($statistics_slots);

		$this->assignRef('statisticsClass', $statisticsClass);
		$this->assignRef('statistics', $statistics);
		$this->assignRef('statistics_slots', $statistics_slots);

		$buttons = array(
			array(
				'name' => JText::_('HIKA_SERIALS'),
				'url' => hikaserial::completeLink('serial'),
				'icon' => 'fas fa-key'
			),
			array(
				'name' => JText::_('HIKA_PACKS'),
				'url' => hikaserial::completeLink('pack'),
				'icon' => 'fas fa-cube'
			),
			array(
				'name' => JText::_('HIKA_SUBSCRIPTIONS'),
				'url' => hikaserial::completeLink('subscription&task=listing'),
				'icon' => 'fas fa-user-clock'
			),
			array(
				'name' => JText::_('HIKA_SERIAL_PLANS'),
				'url' => hikaserial::completeLink('plan&task=listing'),
				'icon' => 'far fa-address-card'
			),
			array(
				'name' => JText::_('PLUGINS'),
				'url' => hikaserial::completeLink('plugins'),
				'icon' => 'fa fa-puzzle-piece'
			),
			array(
				'name' => JText::_('HIKA_CONFIGURATION'),
				'url' => hikaserial::completeLink('config'),
				'icon' => 'fa fa-wrench'
			),
			array(
				'name' => JText::_('IMPORT'),
				'url' => hikaserial::completeLink('import'),
				'icon' => 'fa fa-download'
			),
			array(
				'name' => JText::_('UPDATE_ABOUT'),
				'url' => hikaserial::completeLink('update'),
				'icon' => 'fa fa-sync'
			),
			array(
				'name' => JText::_('HIKA_HELP'),
				'url' => hikaserial::completeLink('documentation'),
				'icon' => 'fa fa-life-ring'
			)
		);
		$this->assignRef('buttons', $buttons);

		if(hikaserial::level(1)) {
			$now = time();
			$config = hikaserial::config();

			$last_cron = (int)$config->get('cron_last_subscriptions', 0);
			$period = (int)$config->get('cron_period_subscriptions', 1200);
			if( empty($last_cron) || $last_cron + ($period*2) > $now ) {
			}

			$last_cron = (int)$config->get('cron_last_queue', 0);
			$period = (int)$config->get('cron_period_queue', 36000);
			if( empty($last_cron) || $last_cron + ($period*2) > $now ) {
			}

			$last_cron = (int)$config->get('cron_last_emails', 0);
			$period = (int)$config->get('cron_period_emails', 900);
			if( empty($last_cron) || $last_cron + ($period*2) > $now ) {
			}
		}

		if(JFactory::getUser()->authorise('core.admin', 'com_hikaserial')) {
			$this->toolbar[] = array('name' => 'preferences', 'component' => 'com_hikaserial');
		}
		$this->toolbar[] = array('name' => 'pophelp', 'target' => 'welcome');

		$toggleClass = hikaserial::get('helper.toggle');
		$this->assignRef('toggleClass', $toggleClass);
	}
}
