<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class groupViewGroup extends hikaserialView {

	const ctrl = 'group';
	const name = 'HIKASERIAL_PACK_GROUPS';
	const icon = 'folder';

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$function = $this->getLayout();
		$this->params =& $params;

		if(method_exists($this,$function))
			$this->$function();
		parent::display($tpl);
	}

	public function listing() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);

		$this->loadRef(array(
			'toggleClass' => 'helper.toggle',
			'searchType' => 'shop.type.search',
		));

		$pageInfo = $this->getPageInfo('pack_group.pack_group_id');

		$from = ' FROM '.hikaserial::table('pack_group').' AS pack_group ';
		$joins = '';

		$select = array(
			'pack_group.*',
		);
		$filters = array(
		);
		$order = '';
		$searchMap = array(
			'pack_group.pack_group_id'
		);
		$orderingAccept = array(
			'pack_group.'
		);

		$this->processFilters($filters, $order, $searchMap, $orderingAccept);
		$this->getPageInfoTotal($from . $filters . $order, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . $from . $joins . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);
		$pack_groups = $db->loadObjectList();

		$this->assignRef('pack_groups', $pack_groups);

		$this->getPagination();
		$this->getOrdering('pack_group.pack_group_id', true);

		$query = 'SELECT pack_group_id, COUNT(pack_id) AS counter FROM ' . hikaserial::table('pack') . ' WHERE pack_group_id > 0 GROUP BY pack_group_id';
		$db->setQuery($query);
		$counters = $db->loadObjectList('pack_group_id');
		$this->assignRef('counters', $counters);

		$manage = true;
		$this->assignRef('manage', $manage);

		$this->toolbar = array(
			array('name' => '|', 'display' => $manage),
			array('name' => 'publishList', 'display' => $manage),
			array('name' => 'unpublishList', 'display' => $manage),
			array('name' => 'addNew', 'display' => $manage),
			array('name' => 'editList', 'display' => $manage),
			array('name' => '|', 'display' => $manage),
			array('name' => 'deleteList', 'display' => $manage),
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl),
			'dashboard'
		);
	}

	public function form() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$doc = JFactory::getDocument();

		hikaserial::loadJslib('tooltip');
		$ctrl = '';
		$cid = '';

		$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('group')));
		$this->assignRef('cancelUrl', $cancelUrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);

		$shopConfig = hikaserial::config(false);

		$doc->addScriptDeclaration('window.hikashop.ready(function(){ window.hikaserial.noChzn(); });');

		$pack_group = new stdClass();
		$pack_group_id = hikaserial::getCID();
		if( !empty($pack_group_id)) {
			$packgroupClass = hikaserial::get('class.pack_group');
			$pack_group = $packgroupClass->get($pack_group_id);

			$task = 'edit';
			$cid = '&cid[]='.$pack_group_id;
			$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('group&task=edit&cid[]='.$pack_group_id)));
		} else {
			$task = 'add';
		}

		$ctrl .= '&task='.$task.$cid;
		$this->assignRef('task', $task);
		$this->assignRef('pack_group', $pack_group);

		$editor = hikaserial::get('shop.helper.editor');
		$editor->name = 'pack_group_description';
		$editor->content = @$pack_group->pack_group_description;
		$editor->height = 200;
		$this->assignRef('editor', $editor);
		$hikamarket = hikaserial::initMarket();
		$this->assignRef('hikamarket', $hikamarket);
		if(!empty($hikamarket)) {
			$nameboxMarketType = hikamarket::get('type.namebox');
			$this->assignRef('nameboxMarketType', $nameboxMarketType);
			$joomlaAclMarketType = hikamarket::get('type.joomla_acl');
			$this->assignRef('joomlaAclMarketType', $joomlaAclMarketType);
		}

		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl.$ctrl);
		$this->toolbar = array(
			'save',
			'apply',
			'hikacancel',
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl.'-form')
		);
	}
}
