<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div class="iframedoc" id="iframedoc"></div>
<script type="text/javascript">
if(!window.localPage) window.localPage = {};
window.localPage.changePlanEmailInherit = function(el) {
	var d = document, lnk = d.getElementById('hikaserial_plan_edition_tab_3_link'),
		value = (typeof(el) == "object") ? parseInt(el.value) : el;
	if(lnk) lnk.style.display = value ? 'none' : '';
};
window.hikashop.ready(function(){
	window.hikashop.dlTitle('adminForm');
	window.localPage.changePlanEmailInherit(<?php echo (int)@$this->plan->pack_email_inherit; ?>);
});
</script>
<form action="<?php echo hikaserial::completeLink('plan'); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">

<div id="hikaserial_plan_edition_header">
	<ul class="hika_tabs" rel="tabs:hikaserial_plan_edition_tab_">
		<li class="active"><a href="#main" rel="tab:1" onclick="return window.hikashop.switchTab(this);"><?php echo JText::_('HIKA_PLAN_SETTINGS'); ?></a></li>
		<li><a href="#actions" rel="tab:2" onclick="return window.hikashop.switchTab(this);"><?php echo JText::_('HIKA_PLAN_ACTIONS'); ?></a></li>
		<li id="hikaserial_plan_edition_tab_3_link"><a href="#emails" rel="tab:3" onclick="return window.hikashop.switchTab(this);"><?php echo JText::_('HIKA_PLAN_EMAILS'); ?></a></li>
	</ul>
</div>

<div id="hikashop_backend_tile_edition">
 <div id="hikaserial_plan_edition_tab_1"><div class="hk-container-fluid">

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('MAIN_INFORMATION');
		?></div>
		<dl class="hika_options">
			<dt class="hikaserial_pack_name"><label for="data[pack][pack_name]"><?php echo JText::_('HIKA_NAME'); ?></label></dt>
			<dd class="hikaserial_pack_name input_large">
				<input type="text" class="form-control" name="data[pack][pack_name]" value="<?php echo $this->escape(@$this->plan->pack_name); ?>" />
			</dd>

			<dt class="hikaserial_pack_published"><label for="data[pack][pack_published]"><?php echo JText::_('HIKA_PUBLISHED'); ?></label></dt>
			<dd class="hikaserial_pack_published"><?php
				echo JHTML::_('hikaselect.booleanlist', 'data[pack][pack_published]', '', @$this->plan->pack_published);
			?></dd>

			<dt class="hikaserial_pack_group"><label for="data[pack][pack_group_id]"><?php echo JText::_('HIKASERIAL_PACK_GROUP'); ?></label></dt>
			<dd class="hikaserial_pack_group"><?php
				echo $this->packgroupType->display('data[pack][pack_group_id]', @$this->plan->pack_group_id);
			?></dd>

<?php if(!empty($this->hikamarket)) { ?>
			<dt class="hikaserial_pack_vendor"><label for="data[pack][pack_vendor_id]"><?php echo JText::_('HIKA_VENDOR'); ?></label></dt>
			<dd class="hikaserial_pack_vendor"><?php
				echo $this->nameboxMarketType->display(
					'data[pack][pack_vendor_id]',
					(int)@$this->plan->pack_vendor_id,
					hikamarketNameboxType::NAMEBOX_SINGLE,
					'vendor',
					array(
						'delete' => true,
						'default_text' => '<em>'.JText::_('HIKA_NONE').'</em>'
					)
				);
			?></dd>
			<dt class="hikaserial_pack_manageaccess"><label for="data[pack][pack_manage_access]"><?php echo JText::_('ACCESS_LEVEL'); ?></label></dt>
			<dd class="hikaserial_pack_manageaccess"><?php
				if(empty($this->plan->pack_manage_access))
					$this->plan->pack_manage_access = 'all';
				echo $this->joomlaAclMarketType->display('data[pack][pack_manage_access]', $this->plan->pack_manage_access, true, true);
			?></dd>
<?php } ?>

			<dt class="hikaserial_pack_published"><label for="data[pack][pack_published]"><?php echo JText::_('HIKA_PLAN_EMAIL_INHERIT'); ?></label></dt>
			<dd class="hikaserial_pack_published"><?php
				echo JHTML::_('hikaselect.booleanlist', 'data[pack][pack_email_inherit]', 'onchange="window.localPage.changePlanEmailInherit(this);"', @$this->plan->pack_email_inherit);
			?></dd>

		</dl>
	</div></div>

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('ADDITIONAL_INFORMATION');
		?></div>
		<dl class="hika_options">
			<dt class="hikaserial_pack_params_generator_format"><label for="data[pack_params][generator_format]"><?php echo JText::_('SERIAL_FORMAT'); ?></label></dt>
			<dd class="hikaserial_pack_params_generator_format">
				<input type="text" class="form-control" name="data[pack_params][generator_format]" placeholder="[a-zA-Z0-9]{size}" value="<?php echo @$this->plan->pack_params->generator_format; ?>"/>
			</dd>
			<dt class="hikaserial_pack_params_generator_size"><label for="data[pack_params][generator_size]"><?php echo JText::_('SERIAL_SIZE'); ?></label></dt>
			<dd class="hikaserial_pack_params_generator_size">
				<input type="text" class="form-control" name="data[pack_params][generator_size]" placeholder="15" value="<?php echo @$this->plan->pack_params->generator_size; ?>"/>
			</dd>
		</dl>
	</div></div>

	<div class="hkc-lg-clear"></div>

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('HIKA_STATISTICS');
		?></div>
<?php if(!empty($this->plan->pack_id)) { ?>
		<dl class="hika_options">
<?php
$statuses = $this->serialStatusType->getValues('subscription');
foreach($statuses as $key => $value) { ?>
			<dt class="hikaserial_stat_<?php echo $key; ?>"><?php
				if(isset($this->counters[$key])) {
					echo '<a href="' . hikaserial::completeLink('subscription&filter_pack=' . @$this->plan->pack_id . '&filter_status=' . $key).'">'.$value.'</a>';
				} else {
					echo $value;
				}
			?></dt>
			<dd class="hikaserial_stat_<?php echo $key; ?>"><?php
				if(isset($this->counters[$key])) {
					echo $this->counters[$key];
				} else {
					echo '0';
				}
			?></dd>
<?php } ?>
			<dt class="hikaserial_stat_total">
				<a href="<?php echo hikaserial::completeLink('subscription&filter_pack=' . @$this->plan->pack_id . '&filter_status=');?>"><?php echo JText::_('TOTAL_SUBSCRIPTIONS'); ?></a>
			</dt>
			<dd class="hikaserial_stat_total"><?php
				if(isset($this->counters['total'])) {
					echo $this->counters['total'];
				} else {
					echo '0';
				}
			?></td>

<?php foreach($this->counters as $name => $value) {
	if($name == 'total' || isset($statuses[$name]))
		continue;
?>
			<dt><label><?php echo ucfirst($name); ?></label></dt>
			<dd><?php echo $value;?></dd>
<?php } ?>
		</dl>
<?php } else { ?>
		<p>
			<em><?php echo JText::_('PLEASE_SAVE_PLAN_FIRST');?></em>
		</p>
<?php } ?>
	</div></div>

	<div class="hkc-xl-clear"></div>

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('PRODUCTS');
		?></div>
		<table class="adminlist table table-striped" style="width:100%">
			<thead>
				<tr>
					<th><?php echo JText::_('HIKA_NAME');?></th>
					<th><?php echo JText::_('HIKA_PLAN_RELATION_TYPE');?></th>
				</tr>
			</thead>
			<tbody>
<?php
if(!empty($this->products)) {
	foreach($this->products as $key => $product) {
?>
				<tr>
					<td>
						<a href="<?php echo hikaserial::completeLink('shop.product&task=edit&cid[]='.$product->product_id); ?>"><?php echo $product->product_name; ?></a><br/>
						<?php echo $product->product_code; ?>
					</td>
					<td>
						<?php echo JText::_('HIKA_PLAN_RELATION_TYPE_'.strtoupper($product->relation_type)); ?><br/>
						<?php echo $this->delayType->show($product->relation_duration); ?>
					</td>
				<tr>
<?php
	}
} else {
?>
				<tr>
					<td colspan="4">
						<em><?php echo JText::_('PLAN_NOT_LINKED_WITH_PRODUCT');?></em>
					</td>
				<tr>
<?php
}
?>
			</tbody>
		</table>
	</div></div>

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('HIKASERIAL_PLAN_FILES');
		?></div>
<?php
if(!empty($this->plan->pack_id)) {
	$options = array(
		'upload' => true,
		'gallery' => false,
		'toolbar' => array(
			$this->popupHelper->display(
				'<span class="hika_add_btn"></span>',
				JText::_('ADD_FILE'),
				hikaserial::completeLink('plan&task=file_select&cid=0&pid='.@$this->plan->pack_id, true),
				'hikashop_file_add',
				750, 460, 'onclick="return window.planMgr.editFile(this,'.(int)@$this->plan->pack_id.');"', '', 'link'
			)
		),
		'upload_base_url' => 'index.php?option=com_hikaserial&ctrl=upload',
		'text' => JText::_('HIKA_PLAN_EMPTY_UPLOAD'),
		'uploader' => array('plan', 'plan_file'),
		'vars' => array('pack_id' => (int)$this->plan->pack_id)
	);

	$content = array();
	if(!empty($this->plan->files)) {
		foreach($this->plan->files as $k => $file) {
			$file->pack_id = $this->plan->pack_id;
			$file->uploader_id = 'hikaserial_plan_files';
			$file->delete = true;
			$file->extra_fields = array(
				'data[pack_file][]' => $file->file_id
			);

			$this->params = $file;
			$this->setLayout('file_entry');
			$content[] = $this->loadTemplate();
		}
	}

	echo $this->uploaderType->displayFileMultiple('hikaserial_plan_files', $content, $options);
?>
		<input type="hidden" name="data[pack_files]" value="1"/>
<script type="text/javascript">
if(!window.planMgr) window.planMgr = {};
window.planMgr.editFile = function(el, id, pid) {
	var t = window.hikashop, href = null, n = el;
	t.submitFct = function(data) {
		var o = window.Oby, c = el;
		while(c && !o.hasClass(c, 'hikashop_upload_file'))
			c = c.parentNode;
		if(!c || !data.cid)
			return;
		var url = '<?php echo hikaserial::completeLink('plan&task=file_entry', true, false, true); ?>',
			params = {mode:'POST', data: o.encodeFormData({'cid':data.cid,'pid':pid})};
		o.xRequest(url, params, function(x,p) {
			var newEl = document.createElement('div');
			newEl.innerHTML = x.responseText;
			c.parentNode.replaceChild(newEl, c);
		});
	};
	if(el.getAttribute('rel') == null) {
		href = el.href;
		n = 'hikaserial_plan_files_edit';
	}
	t.openBox(n,href);
	return false;
};
</script>
<?php
} else
	echo '<em>'.JText::_('HIKA_SAVE_PLAN_FIRST').'</em>';

?>
		<div style="clear:both"></div>
	</div></div>

	<div class="hkc-xl-4 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('PACK_DESCRIPTION');
		?></div>
<?php
		$this->editor->content = @$this->plan->pack_description;
		$this->editor->name = 'pack_description';
		$ret = $this->editor->display();
		if($this->editor->editor == 'codemirror')
			echo str_replace(array('(function() {'."\n",'})()'."\n"),array('window.hikashop.ready(function(){', '});'), $ret);
		else
			echo $ret;
?>
		<div style="clear:both"></div>
	</div></div>

 </div></div>

 <div id="hikaserial_plan_edition_tab_2" style="display:none"><div class="hk-container-fluid">
<?php
if(!empty($this->plan->actions)) {
	foreach($this->plan->actions as $name => $action) {
		$tile_size = 'hkc-xl-4 hkc-lg-6';
		if(!empty($this->plan->action_tiles[$name]['size']))
			$tile_size = $this->plan->action_tiles[$name]['size'];
?>
	<div class="<?php echo $tile_size; ?> hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			$key = 'HIKA_SUBSCRIPTION_ACTION_'.strtoupper($name);
			if(JText::_($key) != $key)
				echo JText::_($key);
			else
				echo $name;
		?></div>
<?php
		if(is_array($action)) {
			echo $this->loadSubscriberTemplate($name, $action);
		} else if(is_string($action)) {
			echo $action;
		}
?>
	</div></div>
<?php
	}
} else {
	echo '<p>'.JText::_('HIKA_SUBSCRIPTION_NO_ACTION').'</p>';
}
?>
 </div></div>

 <div id="hikaserial_plan_edition_tab_3" style="display:none"><div class="hk-container-fluid">

	<div class="hkc-xl-12 hkc-lg-12 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('SERIAL_RENEWAL_EMAILS');
		?></div>
		<table class="adminlist table table-striped table-bordered" style="width:100%">
			<thead>
				<tr>
					<th><?php echo JText::_('HIKA_DAYS_BEFORE'); ?></th>
					<th><?php echo JText::_('HIKA_EMAIL_TEMPLATE'); ?></th>
					<th style="width:1%">
						<a href="#newRenewalEmail" onclick="return window.hikaserial.dupRow('hikasbuscription_pack_emails_renewal_template');"><img src="<?php echo HIKASERIAL_IMAGES; ?>icon-16/add.png" alt="<?php echo JText::_('HIKA_NEW'); ?>"/></a>
					</th>
				</tr>
			</thead>
			<tbody>
<?php
if(!empty($this->plan->emails) && !empty($this->plan->emails['renewal'])) {
	foreach($this->plan->emails['renewal'] as $k => $email) {
?>
				<tr>
					<td>
						<input type="hidden" name="data[emails][renewal][id][]" value="<?php echo (int)$k; ?>"/>
						<input type="text" name="data[emails][renewal][days][]" value="<?php echo (int)$email->pack_email_days; ?>"/>
					</td>
					<td><?php
						echo JHTML::_('select.genericlist', $this->email_templates, 'data[emails][renewal][template][]', '', 'value', 'text', $email->pack_email_template);
					?></td>
					<td>
						<a href="#delete" onclick="window.hikaserial.deleteRow(this);"><img src="<?php echo HIKASERIAL_IMAGES; ?>icon-16/delete.png" alt="<?php echo JText::_('HIKA_DELETE'); ?>"/></a>
					</td>
				</tr>
<?php
	}
}
?>
				<tr id="hikasbuscription_pack_emails_renewal_template" style="display:none;">
					<td>
						<input type="hidden" name="data[emails][renewal][id][]" value="0"/>
						<input type="text" name="data[emails][renewal][days][]" value=""/>
					</td>
					<td><?php echo JHTML::_('select.genericlist', $this->email_templates, 'data[emails][renewal][template][]', 'class="chzn-done no-chzn"', 'value', 'text', '', 'hikaserial_emails_renewal_template_dropdown'); ?></td>
					<td><a href="#delete" onclick="window.hikaserial.deleteRow(this);"><img src="<?php echo HIKASERIAL_IMAGES; ?>icon-16/delete.png" alt="<?php echo JText::_('HIKA_DELETE'); ?>"/></a></td>
				</tr>
			</tbody>
		</table>
	</div></div>

 </div></div>
</div>

	<div class="clr"></div>
	<input type="hidden" name="data[pack][pack_type]" value="subscription" />
	<input type="hidden" name="cid" value="<?php echo (int)@$this->plan->pack_id; ?>" />
	<input type="hidden" name="option" value="<?php echo HIKASERIAL_COMPONENT; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<?php echo JHTML::_('form.token'); ?>
</form>
