<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div class="iframedoc" id="iframedoc"></div>
<form action="<?php echo hikaserial::completeLink('plan'); ?>" method="post" name="adminForm" id="adminForm">

<div class="hk-container-fluid">
	<div class="hkc-md-5"><?php
		echo $this->loadHkLayout('search', array(
			'id' => 'adminForm'
		));
	?></div>
	<div class="hkc-md-7 hikas_filters">
		<!-- Filters -->
	</div>
</div>

	<table class="adminlist table table-striped">
		<thead>
			<tr>
				<th class="hikaserial_pack_num_title title titlenum"><?php
					echo JText::_('HIKA_NUM');
				?></th>
				<th class="hikaserial_pack_select_title title titlebox">
					<input type="checkbox" name="toggle" value="" onclick="hikashop.checkAll(this);" />
				</th>
				<th class="hikaserial_pack_name_title title"><?php
					echo JHTML::_('grid.sort', JText::_('HIKA_NAME'), 'pack.pack_name', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_pack_group_title title"><?php
					echo JText::_('HIKASERIAL_PACK_GROUP');
				?></th>
				<th class="hikaserial_pack_stats_title title"><?php
					echo JText::_('STATISTICS');
				?></th>
				<th class="title titletoggle"><?php
					echo JHTML::_('grid.sort', JText::_('HIKA_PUBLISHED'), 'pack.pack_published', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_pack_id_title title"><?php
					echo JHTML::_('grid.sort', JText::_('ID'), 'pack.pack_id', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="7">
					<?php echo $this->pagination->getListFooter(); ?>
					<?php echo $this->pagination->getResultsCounter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody>
<?php
$k = 0;
foreach($this->plans as $i => &$row) {
?>
			<tr class="row<?php echo $k;?>">
				<td style="align:center"><?php
					echo $this->pagination->getRowOffset($i);
				?></td>
				<td style="align:center"><?php
					echo JHTML::_('grid.id', $i, $row->pack_id);
				?></td>
				<td><?php
					if($this->manage) {
						?><a href="<?php echo hikaserial::completeLink('plan&task=edit&cid[]='.$row->pack_id); ?>"><?php
					}

					echo $row->pack_name;

					if($this->manage) {
						?></a><?php
					}
				?></td>
				<td><?php
					if(!empty($row->pack_group))
						echo $row->pack_group->pack_group_name;
				?></td>
				<td><?php
					$counters = array();
					if(!empty($this->counters[$row->pack_id])) {
						foreach($this->counters[$row->pack_id] as $status => $counter) {
							$counters[] = '<span class="hikaserial_packlist_status">'. $this->serialStatusType->get($status) . '</span><span class="hikaserial_packlist_value">' . $counter . '</span>';
						}
					}
					if(!empty($counters)) {
						echo implode('<br/>', $counters);
					} else {
						echo '<em>'.JText::_('EMPTY_PACK').'</em>';
					}
				?></td>
				<td style="align:center"><?php
					if($this->manage) {
						?><span id="pack_published-<?php echo $row->pack_id; ?>" class="spanloading"><?php
							echo $this->toggleClass->toggle('pack_published-'.$row->pack_id, (int)$row->pack_published, 'pack');
						?></span><?php
					} else {
						echo $this->toggleClass->display('activate', $row->pack_published);
					}
				?></td>
				<td style="align:center;width:1%"><?php
					echo $row->pack_id;
				?></td>
			</tr>
<?php
	$k = 1 - $k;
}
unset($row);
?>
		</tbody>
	</table>
	<input type="hidden" name="option" value="<?php echo HIKASERIAL_COMPONENT; ?>" />
	<input type="hidden" name="task" value="<?php echo @$this->task; ?>" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="filter_order" value="<?php echo $this->pageInfo->filter->order->value; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->pageInfo->filter->order->dir; ?>" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>
