<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class planViewPlan extends hikaserialView {

	const ctrl = 'plan';
	const name = 'HIKA_SERIAL_PLANS';
	const icon = 'address-card';

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$function = $this->getLayout();
		$this->params =& $params;

		if(method_exists($this,$function))
			$this->$function();
		parent::display($tpl);
	}

	public function listing() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);

		$this->loadRef(array(
			'toggleClass' => 'helper.toggle',
			'serialStatusType' => 'type.serial_status',
			'searchType' => 'shop.type.search',
		));

		$pageInfo = $this->getPageInfo('pack.pack_id');

		$from = ' FROM '.hikaserial::table('pack').' AS pack ';
		$joins = '';

		$select = array(
			'pack.*',
		);
		$filters = array(
			'pack.pack_type = ' . $db->Quote('subscription')
		);
		$order = '';
		$searchMap = array(
			'pack.pack_id'
		);
		$orderingAccept = array(
			'pack.'
		);

		$this->processFilters($filters, $order, $searchMap, $orderingAccept);
		$this->getPageInfoTotal($from . $filters . $order, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . $from . $joins . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);
		$plans = $db->loadObjectList();

		$this->assignRef('plans', $plans);

		$this->getPagination();
		$this->getOrdering('pack.pack_id', true);

		$query = 'SELECT subscription_pack_id, subscription_status, COUNT(subscription_id) AS counter FROM ' . hikaserial::table('subscription') . ' GROUP BY subscription_pack_id, subscription_status ORDER BY subscription_pack_id, subscription_status';
		$db->setQuery($query);
		$dbcounters = $db->loadObjectList();
		$counters = array();
		foreach($dbcounters as $counter) {
			if(!isset($counters[$counter->subscription_pack_id])) {
				$counters[$counter->subscription_pack_id] = array();
			}
			$counters[$counter->subscription_pack_id][$counter->subscription_status] = $counter->counter;
		}
		unset($dbcounters);
		$this->assignRef('counters', $counters);

		$plan_groups = array();
		foreach($plans as $plan) {
			if(empty($plan->pack_group_id))
				continue;
			$plan_groups[(int)$plan->pack_group_id] = (int)$plan->pack_group_id;
		}
		if(!empty($plan_groups)) {
			$query = 'SELECT * FROM '.hikaserial::table('pack_group').' WHERE pack_group_id IN ('.implode(',', $plan_groups).')';
			$db->setQuery($query);
			$plan_groups = $db->loadObjectList('pack_group_id');

			foreach($plans as &$plan) {
				if(empty($plan->pack_group_id))
					continue;
				if(!isset($plan_groups[(int)$plan->pack_group_id]))
					continue;
				$plan->pack_group = &$plan_groups[(int)$plan->pack_group_id];
			}
			unset($plan);
		}

		$manage = true;
		$this->assignRef('manage', $manage);

		$this->toolbar = array(
			array('name' => 'link', 'icon' => 'folder', 'alt' => JText::_('HIKASERIAL_PACK_GROUPS'), 'url' => hikaserial::completeLink('group&task=listing'), 'display' => $manage),
			array('name' => '|', 'display' => $manage),
			array('name' => 'publishList', 'display' => $manage),
			array('name' => 'unpublishList', 'display' => $manage),
			array('name' => 'addNew', 'display' => $manage),
			array('name' => 'editList', 'display' => $manage),
			array('name' => '|', 'display' => $manage),
			array('name' => 'deleteList', 'display' => $manage),
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl),
			'dashboard'
		);
	}

	public function form() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$doc = JFactory::getDocument();

		hikaserial::loadJslib('tooltip');
		$ctrl = '';
		$cid = '';

		$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('plan')));
		$this->assignRef('cancelUrl', $cancelUrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);

		$shopConfig = hikaserial::config(false);

		$doc->addScriptDeclaration('window.hikashop.ready(function(){ window.hikaserial.noChzn(); });');

		$plan = new stdClass();
		$plan_id = hikaserial::getCID();
		if( !empty($plan_id)) {
			$packClass = hikaserial::get('class.pack');
			$plan = $packClass->get($plan_id);

			if(empty($plan) || $plan->pack_type != 'subscription') {
				$app->enqueueMessage(JText::_('INVALID_PLAN'));
				$app->redirect(hikaserial::completeLink('plan', false, true));
			}

			$task = 'edit';
			$cid = '&cid[]='.$plan_id;
			$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('plan&task=edit&cid[]='.$plan_id)));
		} else {
			$task = 'add';
		}

		if(empty($plan->pack_params))
			$plan->pack_params = new stdClass();

		$ctrl .= '&task='.$task.$cid;
		$this->assignRef('task', $task);
		$this->assignRef('plan', $plan);

		$editor = hikaserial::get('shop.helper.editor');
		$editor->name = 'plan_description';
		$editor->content = @$plan->pack_description;
		$editor->height = 200;
		$this->assignRef('editor', $editor);

		$this->loadRef(array(
			'packGeneratorType' => 'type.pack_generator',
			'packDataType' => 'type.pack_data',
			'serialStatusType' => 'type.serial_status',
			'delayType' => 'type.delay',
			'uploaderType' => 'shop.type.uploader',
			'popupHelper' => 'shop.helper.popup',
			'packgroupType' => 'type.pack_group',
		));

		$products = array();
		if(!empty($plan_id)) {
			$query = 'SELECT a.*, b.* FROM ' . hikaserial::table('product_pack') . ' AS a INNER JOIN ' . hikaserial::table('shop.product') . ' AS b ON a.product_id = b.product_id WHERE a.pack_id = ' . (int)$plan_id;
			$db->setQuery($query);
			$products = $db->loadObjectList();
		}
		$this->assignRef('products', $products);
		$plan->products = $products;


		$files = array();
		if(!empty($plan_id)) {
			$query = 'SELECT f.* FROM ' . hikaserial::table('shop.file') . ' AS f WHERE f.file_type = '.$db->Quote('plan').' AND f.file_ref_id = ' . (int)$plan_id;
			$db->setQuery($query);
			$files = $db->loadObjectList();

			$upload_dir = $shopConfig->get('uploadsecurefolder');
			$upload_dir = rtrim(JPath::clean(html_entity_decode($upload_dir)), DS.' ').DS;
			if(!preg_match('#^([A-Z]:)?/.*#',$upload_dir) && (substr($upload_dir, 0, 1) != '/' || !is_dir($upload_dir))) {
				$upload_dir = JPath::clean(HIKASHOP_ROOT.DS.trim($upload_dir, DS.' ').DS);
			}
			foreach($files as &$file) {
				$file->file_size = @filesize($upload_dir . $file->file_path);
			}
		}
		$this->assignRef('files', $files);
		$plan->files = $files;

		if(!empty($plan_id) && empty($plan->pack_email_inherit)) {
			$plan->emails = array();

			$query = 'SELECT * FROM ' . hikaserial::table('pack_email') . ' WHERE pack_id = ' . (int)$plan_id . ' ORDER BY pack_email_days DESC';
			$db->setQuery($query);
			$emails = $db->loadObjectList();

			foreach($emails as $email) {
				if(empty($plan->emails[$email->pack_email_type]))
					$plan->emails[$email->pack_email_type] = array();

				$plan->emails[$email->pack_email_type][ $email->pack_email_id ] = $email;
			}
			unset($emails);
		}

		$counters = array('total' => 0);
		if(!empty($plan_id)) {
			$query = 'SELECT subscription_status, COUNT(subscription_id) AS counter FROM ' . hikaserial::table('subscription') . ' WHERE subscription_pack_id = ' . (int)$plan_id . ' GROUP BY subscription_status ORDER BY subscription_status';
			$db->setQuery($query);
			$dbcounters = $db->loadObjectList();
			foreach($dbcounters as $counter) {
				$counters['total'] += $counter->counter;
				$counters[$counter->subscription_status] = $counter->counter;
			}
			unset($dbcounters);
		}
		$this->assignRef('counters', $counters);
		$plan->counters = $counters;

		if(!isset($plan->pack_email_inherit))
			$plan->pack_email_inherit = 1;

		$hikamarket = hikaserial::initMarket();
		$this->assignRef('hikamarket', $hikamarket);
		if(!empty($hikamarket)) {
			$nameboxMarketType = hikamarket::get('type.namebox');
			$this->assignRef('nameboxMarketType', $nameboxMarketType);
			$joomlaAclMarketType = hikamarket::get('type.joomla_acl');
			$this->assignRef('joomlaAclMarketType', $joomlaAclMarketType);
		}

		$plan->actions = array();

		$email_templates = array(
			'subscription_expiration_notice' => JHTML::_('select.option', 'subscription_expiration_notice', JText::_('SERIAL_SUBSCRIPTION_EXPIRATION_NOTICE'))
		);

		JPluginHelper::importPlugin('hikaserial');
		$dispatcher = hikaserial::getDispatcher();
		$dispatcher->trigger('onPlanActionsConfiguration', array(&$plan));

		$this->assignRef('email_templates', $email_templates);

		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl.$ctrl);
		$this->toolbar = array(
			'save',
			'apply',
			'hikacancel',
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl.'-form')
		);
	}

	protected function loadSubscriberTemplate($name, $config) {
		if(empty($this->plan))
			$this->plan = new stdClass();
		if(empty($this->plan->pack_params))
			$this->plan->pack_params = new stdClass();

		$section = $name;
		$subscriberPlugin = null;

		$html = '<dl class="hika_options">';
		$closeTag = true;
		foreach($config as $key => $value) {
			if(is_array($value[0])) {
				$a = array_shift($value[0]);
				$label = vsprintf(JText::_($a), $value[0]);
			} else {
				$label = JText::_($value[0]);
			}

			if($closeTag)
				$html .= '<dt><label for="data[pack_params]['.$section.']['.$key.']">'.$label.'</label></dt><dd>';
			$closeTag = true;

			switch ($value[1]) {
				case 'input':
				case 'int':
				case 'float':
					$v = @$this->plan->pack_params->{$section}[$key];
					if(empty($v) && !empty($value[2]))
						$v = $value[2];
					if($value[1] == 'int') $v = (int)$v;
					if($value[1] == 'float') $v = (float)hikaserial::toFloat($v);

					$html .= '<input type="text" name="data[pack_params]['.$section.']['.$key.']" value="'.$this->escape($v).'"/>';

					if(!empty($value[3]))
						$html .= $value[3];
					break;

				case 'textarea':
					$html .= '<textarea name="data[pack_params]['.$section.']['.$key.']" rows="3">'.@$this->plan->pack_params->{$section}[$key].'</textarea>';
					break;

				case 'big-textarea':
					$html .= '<textarea name="data[pack_params]['.$section.']['.$key.']" rows="9" width="100%" style="width:100%;">'.@$this->plan->pack_params->{$section}[$key].'</textarea>';
					break;

				case 'boolean':
					if(!isset($this->plan->pack_params->{$section}[$key]) && isset($value[2]))
						$this->plan->pack_params->{$section}[$key] = $value[2];
					if(!isset($this->plan->pack_params->{$section}[$key]))
						$this->plan->pack_params->{$section}[$key] = 0;
					$html .= JHTML::_('hikaselect.booleanlist', 'data[pack_params]['.$section.']['.$key.']' , '', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'checkbox':
					$i = 0;
					foreach($value[2] as $listKey => $listData) {
						$checked = '';
						if(!empty($this->plan->pack_params->{$section}[$key])) {
							if(in_array($listKey, $this->plan->pack_params->{$section}[$key]))
								$checked = 'checked="checked"';
						}
						$html .= '<input id="data_'.$type.'_'.$paramsType.'_'.$key.'_'.$i.'" name="data[pack_params]['.$section.']['.$key.'][]" type="checkbox" value="'.$listKey.'" '.$checked.' /><label for="data_'.$type.'_'.$paramsType.'_'.$key.'_'.$i.'">'.$listData.'</label><br/>';
						$i++;
					}
					break;

				case 'list':
					$values = array();
					foreach($value[2] as $listKey => $listData) {
						$values[] = JHTML::_('select.option', $listKey, JText::_($listData));
					}
					$html .= JHTML::_('select.genericlist', $values, 'data[pack_params]['.$section.']['.$key.']' , 'class="custom-select" size="1"', 'value', 'text', @$this->plan->pack_params->{$section}[$key] );
					break;

				case 'group':
				case 'groups':
					$aclType = hikaserial::get('type.acl');
					$html .= $aclType->display('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'pack':
					$packType = hikaserial::get('type.pack');
					$html .= $packType->displaySingle('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'packs':
					$packType = hikaserial::get('type.pack');
					$html .= $packType->displayMultiple('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'product':
					$productDisplayType = hikaserial::get('shop.type.productdisplay');
					$html .= $productDisplayType->displaySingle('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'discount':
					$discountType = hikaserial::get('shop.type.discount');
					$html .= $discountType->displaySelector('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key], false, 'coupon');
					break;

				case 'period-value':
					$closeTag = false;
					$v = @$this->plan->pack_params->{$section}[$key];
					if(empty($v))
						$v = '0';
					$html .= '<input type="text" name="data[pack_params]['.$section.']['.$key.']" value="'.$v.'"/>';
					break;

				case 'period-type':
					$values = array(
						JHTML::_('select.option', 'day', JText::_('DAYS')),
						JHTML::_('select.option', 'month', JText::_('MONTHS')),
						JHTML::_('select.option', 'year', JText::_('YEARS'))
					);
					$html .= JHTML::_('select.genericlist', $values, 'data[pack_params]['.$section.']['.$key.']', 'class="custom-select" size="1"', 'value', 'text', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'currency':
					$currenciesType = hikaserial::get('shop.type.currency');
					$html .= $currenciesType->display('data[pack_params]['.$section.']['.$key.']', @$this->plan->pack_params->{$section}[$key]);
					break;

				case 'html':
					$html .= $value[2];
					break;

				default:
					if(empty($subscriberPlugin))
						$subscriberPlugin = hikashop_import('hikaserial', $name);
					if(!empty($subscriberPlugin) && method_exists($subscriberPlugin, 'subscriberPluginConfigDisplay')) {
						$args = array_merge($value, array());
						$type = array_shift($args);
						$html .= $subscriberPlugin->subscriberPluginConfigDisplay($type, $args, $section, $key, $this->plan);
					}
					break;
			}

			if($closeTag)
				$html .= '</dd>';
		}
		if(!$closeTag)
			$html .= '</dd>';
		$html .= '</dl>';

		return $html;
	}

	public function file_entry() {
		$file_id = (int)hikaserial::getCID('file_id');
		$this->assignRef('cid', $file_id);

		$pack_id = hikaInput::get()->getInt('pid', 0);
		$this->assignRef('pack_id', $pack_id);

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		if(empty($this->popupHelper)) {
			$popupHelper = hikaserial::get('shop.helper.popup');
			$this->assignRef('popupHelper', $popupHelper);
		}

		if(!empty($this->params->file_id))
			return;

		$element = new stdClass();
		if(!empty($file_id)){
			$fileClass = hikaserial::get('class.file');
			$element = $fileClass->get($file_id);
		}
		$element->pack_id = $pack_id;

		$element->uploader_id = 'hikaserial_plan_files';
		$element->delete = true;
		$element->extra_fields = array(
			'data[pack_file][]' => $element->file_id
		);

		$upload_dir = $shopConfig->get('uploadsecurefolder');
		$upload_dir = rtrim(JPath::clean(html_entity_decode($upload_dir)), DS.' ').DS;
		if(!preg_match('#^([A-Z]:)?/.*#',$upload_dir) && (substr($upload_dir, 0, 1) != '/' || !is_dir($upload_dir))) {
			$upload_dir = JPath::clean(HIKASHOP_ROOT.DS.trim($upload_dir, DS.' ').DS);
		}
		$element->file_size = @filesize($upload_dir . $element->file_path);

		$this->assignRef('params', $element);
	}

	public function file_select() {
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$element = new stdClass();
		$id = (int)hikaserial::getCID('file_id');
		if(!empty($id)) {
			$fileClass = hikaserial::get('shop.class.file');
			$element = $fileClass->get($id);
		}
		$this->assignRef('element', $element);
	}
}
