<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class serialViewSerial extends hikaserialView {

	const ctrl = 'serial';
	const name = 'HIKA_SERIALS';
	const icon = 'key';

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$fct = $this->getLayout();
		if(method_exists($this, $fct)) {
			if($this->$fct($params) === false)
				return false;
		}
		parent::display($tpl);
	}

	public function listing($tpl = null) {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl);

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$this->loadRef(array(
			'searchType' => 'shop.type.search',
			'serialStatusType' => 'type.serial_status',
			'packType' => 'type.pack',
		));
		$filterType = $app->getUserStateFromRequest($this->paramBase.'.filter_type', 'filter_type', 0, 'int');

		$singleSelection = hikaInput::get()->getVar('single', false);
		$this->assignRef('singleSelection', $singleSelection);
		$confirm = hikaInput::get()->getVar('confirm', true);
		$this->assignRef('confirm', $confirm);

		$elemStruct = array(
			'serial_data',
			'serial_id',
			'serial_pack_id',
			'serial_status',
			'pack_name'
		);
		$this->assignRef('elemStruct', $elemStruct);

		$cfg = array(
			'table' => 'serial',
			'main_key' => 'serial_id',
			'order_sql_value' => 'serial.serial_id'
		);

		$manage = true; // TODO
		$this->assignRef('manage', $manage);
		$manage_shop_order = hikaserial::isAllowed($shopConfig->get('acl_order_manage', 'all'));
		$this->assignRef('manage_shop_order', $manage_shop_order);
		$manage_shop_user = hikaserial::isAllowed($shopConfig->get('acl_user_manage', 'all'));
		$this->assignRef('manage_shop_user', $manage_shop_user);

		$page_filters = array(
			'pack' => 0,
			'status' => '',
		);

		$pageInfo = $this->getPageInfo('serial.serial_id', 'asc', $page_filters);

		$filters = array();
		$searchMap = array(
			'serial.serial_id',
			'serial.serial_data',
			'serial.serial_status',
		);
		$order = '';
		$orderingAccept = array(
			'serial.',
		);

		if(!empty($pageInfo->filter->status))
			$filters['serial_status'] = 'serial.serial_status = ' . $db->quote($pageInfo->filter->status);
		if(!empty($pageInfo->filter->pack))
			$filters['serial_pack'] = 'serial.serial_pack_id = ' . (int)$pageInfo->filter->pack;

		$select = array(
			'serial.*'
		);
		$from = ' FROM ' . hikaserial::table($cfg['table']) . ' AS serial ';
		$joins = '';

		$this->processFilters($filters, $order, $searchMap, $orderingAccept);
		$this->getPageInfoTotal($from . $filters, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . $from . $joins . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);

		$rows = $db->loadObjectList('serial_id');

		if(!empty($pageInfo->search)) {
			$rows = hikaserial::search($pageInfo->search, $rows, $cfg['main_key']);
		}
		JPluginHelper::importPlugin('hikaserial');
		$dispatcher = hikaserial::getDispatcher();
		$dispatcher->trigger('onDisplaySerials', array(&$rows, 'back-serial-listing'));

		$this->assignRef('rows', $rows);

		$load_pack = array();
		$load_user = array();
		$load_order = array();
		foreach($rows as $row) {
			if(!empty($row->serial_pack_id))
				$load_pack[ (int)$row->serial_pack_id ] = (int)$row->serial_pack_id;
			if(!empty($row->serial_user_id))
				$load_user[ (int)$row->serial_user_id ] = (int)$row->serial_user_id;
			if(!empty($row->serial_order_id))
				$load_order[ (int)$row->serial_order_id ] = (int)$row->serial_order_id;
		}

		if(!empty($load_pack)) {
			$query = 'SELECT pack.* FROM ' . hikaserial::table('pack') . ' AS pack WHERE pack_id IN ('.implode(',', $load_pack).')';
			$db->setQuery($query);
			$data = $db->loadObjectList('pack_id');
			foreach($rows as &$row) {
				if(empty($row->serial_pack_id) || !isset($data[(int)$row->serial_pack_id]))
					continue;
				$row->pack = $data[(int)$row->serial_pack_id];
			}
			unset($row);
			unset($data);
			unset($load_pack);
		}
		if(!empty($load_user)) {
			$query = 'SELECT * FROM ' . hikaserial::table('shop.user') . ' AS hk_user '.
				' LEFT JOIN ' . hikaserial::table('users', false) . ' AS j_user ON hk_user.user_cms_id = j_user.id '.
				' WHERE hk_user.user_id IN ('.implode(',', $load_user).')';
			$db->setQuery($query);
			$data = $db->loadObjectList('user_id');
			foreach($rows as &$row) {
				if(empty($row->serial_user_id) || !isset($data[(int)$row->serial_user_id]))
					continue;
				$row->user = $data[(int)$row->serial_user_id];
			}
			unset($row);
			unset($data);
			unset($load_user);
		}
		if(!empty($load_order)) {
			$query = 'SELECT hk_order.* FROM ' . hikaserial::table('shop.order') . ' AS hk_order '.
				'WHERE hk_order.order_id IN ('.implode(',', $load_order).')';
			$db->setQuery($query);
			$data = $db->loadObjectList('order_id');
			foreach($rows as &$row) {
				if(empty($row->serial_order_id) || !isset($data[(int)$row->serial_order_id]))
					continue;
				$row->order = $data[(int)$row->serial_order_id];
			}
			unset($row);
			unset($data);
			unset($load_order);
		}

		$this->toolbar = array(
			array(
				'name' => 'popup',
				'alt' => 'HIKA_EXPORT',
				'icon' => 'export',
				'url' => hikaserial::completeLink('serial&task=exportconf', true, true),
				'title' => 'HIKA_EXPORT',
				'width' => 500, 'height' => 380
			),
			'|',
			'addNew',
			'editList',
			array('name' => 'deleteList'),
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl),
			'dashboard'
		);

		$this->getPagination();

		$this->getOrdering('serial.serial_id', true);
	}

	public function select() {
		$this->listing();
	}

	public function useselection() {
		$serials = hikaInput::get()->get('cid', array(), 'array');
		$rows = array();
		$data = '';
		$confirm = hikaInput::get()->getVar('confirm', true);
		$singleSelection = hikaInput::get()->getVar('single', false);

		$elemStruct = array(
			'serial_data',
			'pack_id',
			'pack_name',
			'pack_data',
			'pack_generator'
		);

		if(!empty($serials)) {
			hikaserial::toInteger($users);
			$db = JFactory::getDBO();
			$query = 'SELECT a.* FROM '.hikaserial::table('serial').' AS a INNER JOIN '.hikaserial::table('pack').' AS b ON a.serial_pack_id = b.pack_id WHERE a.serial_id IN ('.implode(',',$serials).')';
			$db->setQuery($query);
			$rows = $db->loadObjectList();

			if(!empty($rows)) {
				$data = array();
				foreach($rows as $v) {
					$d = '{id:'.$v->pack_id;
					foreach($elemStruct as $s) {
						if($s == 'id')
							continue;
						$d .= ','.$s.':\''. str_replace('"','\'',$v->$s).'\'';
					}
					$data[] = $d.'}';
				}
				if(!$singleSelection)
					$data = '['.implode(',',$data).']';
				else {
					$data = $data[0];
					$rows = $rows[0];
				}
			}
		}
		$this->assignRef('rows', $rows);
		$this->assignRef('data', $data);
		$this->assignRef('confirm', $confirm);
		$this->assignRef('singleSelection', $singleSelection);

		if($confirm == true) {
			$js = 'window.hikashop.ready(function(){window.top.hikaserial.submitBox('.$data.');});';
			$doc = JFactory::getDocument();
			$doc->addScriptDeclaration($js);
		}
	}

	public function applyexportconf() {
		$data = '';
		$formData = hikaInput::get()->get('data', array(), 'array');
		if(!empty($formData['export'])) {
			$data = array();
			foreach($formData['export'] as $key => $value) {
				$data[] = $key . '=' . $value;
			}
			$data = implode(';', $data);
		}

		$js = 'window.hikashop.ready(function(){'.
			' var el = window.top.document.getElementById("hikaserial_export_data");'.
			' if(el) { el.value = "'.$data.'"; }'.
			' el.form["task"].value = "export";'.
			' el.form.submit();'.
			' window.top.hikashop.closeBox();'.
			' el.form["task"].value = "";'.
			'});';
		$doc = JFactory::getDocument();
		$doc->addScriptDeclaration($js);
		return false;
	}

	public function export() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$ids = hikaInput::get()->get('cid', array(), 'array');

		$export_params = array();
		$export_data = hikaInput::get()->getString('export_data', '');
		if(!empty($export_data)) {
			$export_datas = explode(';', $export_data);
			foreach($export_datas as $d) {
				if(strpos($d, '=') !== false) {
					list($k, $v) = explode('=', $d, 2);
					$export_params[$k] = $v;
				}
			}
		}
		$this->assignRef('export_params', $export_params);

		$filters = array();

		if(empty($ids)) {
			$pageInfo = new stdClass();

			$pageInfo->filter = new stdClass();
			$pageInfo->filter->serial_status = $app->getUserStateFromRequest($this->paramBase.'.filter_status', 'filter_status', '', 'string');
			$pageInfo->filter->pack = $app->getUserStateFromRequest($this->paramBase.'.filter_pack', 'filter_pack', '', 'string');

			$pageInfo->search = HikaStringHelper::strtolower($app->getUserStateFromRequest($this->paramBase.'.search', 'search', '', 'string'));

			$searchMap = array(
				'serial.serial_id',
				'serial.serial_data',
				'serial.serial_status',
				'pack.pack_name',
				'user.username'
			);

			if(!empty($pageInfo->search)) {
				$searchVal = '\'%' . $db->getEscaped(HikaStringHelper::strtolower($pageInfo->search), true) . '%\'';
				$filters[] = '('.implode(' LIKE '.$searchVal.' OR ', $searchMap).' LIKE '.$searchVal.')';
			}
			if(!empty($pageInfo->filter->serial_status)) {
				$filters[] = ' serial.serial_status = ' . $db->quote($pageInfo->filter->serial_status);
			}
			if(!empty($pageInfo->filter->pack)) {
				if((int)$pageInfo->filter->pack > 0) {
					$filters[] = ' pack.pack_id = ' . (int)$pageInfo->filter->pack;
				} else {
					$filters[] = ' pack.pack_name = ' . $db->quote($pageInfo->filter->pack);
				}
			}
		} else {
			hikaserial::toInteger($ids, 0);
			$filters[] = 'serial.serial_id IN ('.implode(',',$ids).')';
		}

		if(!empty($filters)) {
			$filters = ' WHERE '. implode(' AND ', $filters);
		} else {
			$filters = '';
		}

		$tables = array();

		$query = 'FROM ' . hikaserial::table('serial') . ' AS serial '.
			' INNER JOIN ' . hikaserial::table('pack') . ' AS pack ON serial.serial_pack_id = pack.pack_id '.
			' LEFT JOIN ' . hikaserial::table('shop.user') . ' AS user ON serial.serial_user_id = user.user_id '.
			' LEFT JOIN ' . hikaserial::table('users', false) . ' AS users ON user.user_cms_id = users.id '.
			' LEFT JOIN ' . hikaserial::table('shop.order') . ' AS shop_order ON serial.serial_order_id = shop_order.order_id '.
			$filters;

		$db->setQuery('SELECT * '.$query);
		$rows = $db->loadObjectList();
		$this->assignRef('rows',$rows);
	}

	public function form() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$ctrl = '';
		$cid = '';

		$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('serial')));
		$this->assignRef('cancelUrl', $cancelUrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$popup = hikaserial::get('shop.helper.popup');
		$this->assignRef('popup', $popup);

		$manage = true; // TODO
		$this->assignRef('manage', $manage);
		$manage_shop_order = hikaserial::isAllowed($shopConfig->get('acl_order_manage', 'all'));
		$this->assignRef('manage_shop_order', $manage_shop_order);
		$manage_shop_user = hikaserial::isAllowed($shopConfig->get('acl_user_manage', 'all'));
		$this->assignRef('manage_shop_user', $manage_shop_user);

		$serial = null;
		$serial_id = hikaserial::getCID();
		if( !empty($serial_id)) {
			$serialClass = hikaserial::get('class.serial');
			$serial = $serialClass->get($serial_id, true);
			$task = 'edit';
			$cid = '&cid[]='.$serial_id;
			$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('serial&task=edit&cid[]='.$serial_id)));
		} else {
			$task = 'add';
		}
		$ctrl .= '&task='.$task.$cid;
		$this->assignRef('task', $task);
		$this->assignRef('serial', $serial);

		JPluginHelper::importPlugin('hikaserial');
		$dispatcher = hikaserial::getDispatcher();
		$serials = array(&$serial);
		$dispatcher->trigger('onDisplaySerials', array(&$serials, 'back-serial-form'));

		$packType = hikaserial::get('type.pack');
		$this->assignRef('packType', $packType);

		$serialStatusType = hikaserial::get('type.serial_status');
		$this->assignRef('serialStatusType', $serialStatusType);

		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl.$ctrl);
		$this->toolbar = array(
			'|',
			'save',
			'apply',
			'hikacancel',
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl.'-form')
		);
	}
}
