<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div class="iframedoc" id="iframedoc"></div>
<script type="text/javascript">
	window.hikashop.ready(function(){window.hikashop.dlTitle('adminForm');});
</script>
<form action="<?php echo hikaserial::completeLink('subscription'); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">
<div id="hikashop_backend_tile_edition">
	<div class="hk-container-fluid">

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('MAIN_INFORMATION');
		?></div>
		<dl class="hika_options">
			<dt class="hikaserial_subscription_data"><label for="data_subscription__serial_data"><?php echo JText::_('HIKA_SUBSCRIPTION_DATA'); ?></label></dt>
			<dd class="hikaserial_subscription_data input_large">
<?php
	if(!isset($this->subscription->custom_display) || $this->subscription->custom_display === false ) {
?>
				<textarea rows="2" style="width:100%" id="data_serial__serial_data" class="form-control" name="data[subscription][subscription_data]" placeholder="<?php echo JText::_('HIKASERIAL_SUBSCRIPTION_DATA_EMPTY_MSG', true); ?>"><?php echo @$this->subscription->subscription_data; ?></textarea>
<?php
	} else if($this->subscription->custom_display === true) {
		$dispatcher = hikaserial::getDispatcher();
		$dispatcher->trigger('onDisplaySubscriptionForm', array(&$this->subscription));
	} else {
		echo $this->subscription->custom_display;
	}
?>
			</dd>

			<dt class="hikaserial_subscription_pack"><label><?php echo JText::_('HIKA_SERIAL_PLAN'); ?></label></dt>
			<dd class="hikaserial_subscription_pack"><?php
				echo $this->packType->display(
					'data[subscription][subscription_pack_id]',
					@$this->subscription->subscription_pack_id,
					false,
					false,
					array('type' => 'subscription')
				);
			?></dd>

			<dt class="hikaserial_subscription_status"><label for="data[subscription][subscription_status]"><?php echo JText::_('SERIAL_STATUS'); ?></label></dt>
			<dd class="hikaserial_subscription_status"><?php
				echo $this->serialStatusType->display(
					'data[subscription][subscription_status]',
					@$this->subscription->subscription_status,
					false,
					false,
					array('type' => 'subscription')
				);
			?></dd>

			<dt class="hikaserial_subscription_user"><label><?php echo JText::_('CUSTOMER'); ?></label></dt>
			<dd class="hikaserial_subscription_user"><?php
				echo $this->nameboxType->display(
					'data[subscription][subscription_user_id]',
					(int)@$this->subscription->subscription_user_id,
					hikashopNameboxType::NAMEBOX_SINGLE,
					'user',
					array(
						'default_text' => JText::_('HIKA_NONE'),
						'displayFormat' => '{name} - {user_email}',
					)
				);
			?></dd>
		</dl>
	</div></div>

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('SERIAL_SUBSCRIPTION_EXTRA_DATA');
		?></div>
		<table class="admintable table" style="width:100%">
			<tr>
				<td class="key">
					<label for="hikaserial_extra_data_new_name"><?php echo JText::_('ADD'); ?></label>
				</td>
				<td>
					<input type="hidden" value="1" name="hikaserial_extradata"/>
					<input type="text" id="hikaserial_extra_data_new_name" value="" class="form-control" onkeypress="return hikaserial_handleinput(this, event);"/>
					<a href="#add" onclick="return hikaserial_createExtraData();"><img style="vertical-align:middle;" src="<?php echo HIKASERIAL_IMAGES;?>icon-16/add.png" alt="<?php echo JText::_('ADD'); ?>"/></a>
				</td>
				<td style="width:2%"></td>
			</tr>
<?php
	$extradata = @$this->subscription->subscription_extradata;
	if(!empty($extradata)) {
		if(is_string($extradata)) $extradata = hikaserial::unserialize($extradata);
		if(empty($extradata)) $extradata = array();
		foreach($extradata as $data_key => $data_value) {
?>			<tr>
				<td class="key"><label for="data[subscription][subscription_extradata][<?php echo $data_key; ?>]"><?php echo $data_key; ?></label></td>
				<td>
					<textarea rows="3" style="width:98%" id="data[subscription][subscription_extradata][<?php echo $data_key; ?>]" class="form-control" name="data[subscription][subscription_extradata][<?php echo $data_key; ?>]"><?php
						echo $data_value;
					?></textarea>
				</td>
				<td>
					<a href="#remove" onclick="return hikaserial_delete_extradata(this);"><img src="<?php echo HIKASERIAL_IMAGES;?>icon-16/delete.png" alt="<?php echo JText::_('DELETE'); ?>"/></a>
				</td>
			</tr>
<?php
		}
	}
?>			<tr id="hikaserial_extra_data_tpl" style="display:none;">
				<td class="key"><label for="{key}">{name}</label></td>
				<td><textarea rows="3" class="form-control" style="width:98%" id="{key}" name="{key}"></textarea></td>
				<td><a href="#remove" onclick="return hikaserial_delete_extradata(this);"><img src="<?php echo HIKASERIAL_IMAGES;?>icon-16/delete.png" alt="<?php echo JText::_('DELETE'); ?>"/></a></td>
			</tr>
		</table>
<script type="text/javascript">
function hikaserial_createExtraData() {
	var d = document,
		extd_name = d.getElementById('hikaserial_extra_data_new_name');
	if(extd_name.value != '') {
		keyName = extd_name.value;
		extd_name.value = '';
		var exists = d.getElementById('data[subscription][subscription_extradata]['+keyName+']');
		if(!exists) {
			var htmlblocks = {name: keyName, key: 'data[subscription][subscription_extradata]['+keyName+']'};
			hikaserial.dupRow('hikaserial_extra_data_tpl', htmlblocks);
		}
	}
	return false;
}
function hikaserial_delete_extradata(el) {
	hikaserial.deleteRow(el);
	return false;
}
function hikaserial_handleinput(field, event) {
	var keyCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
	if (keyCode == 13)
		return hikaserial_createExtraData();
	return true;
}
</script>
	</div></div>

	<div class="hkc-xl-clear"></div>

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('ADDITIONAL_INFORMATION');
		?></div>
		<dl class="hika_options">
			<dt><label for="subscription_start_date"><?php echo JText::_('HIKA_SUBSCRIPTION_START'); ?></label></dt>
			<dd><?php
				echo JHTML::_('calendar',
					hikaserial::getDate( (!empty($this->subscription->subscription_start_date) ? $this->subscription->subscription_start_date : ''), '%Y-%m-%d %H:%M'),
					'data[subscription][subscription_start_date]',
					'subscription_start_date',
					'%Y-%m-%d %H:%M'
				);
			?></dd>

			<dt><label for="subscription_end_date"><?php echo JText::_('HIKA_SUBSCRIPTION_END'); ?></label></dt>
			<dd><?php
				echo JHTML::_('calendar',
					hikaserial::getDate( (!empty($this->subscription->subscription_end_date) ? $this->subscription->subscription_end_date : ''), '%Y-%m-%d %H:%M'),
					'data[subscription][subscription_end_date]',
					'subscription_end_date',
					'%Y-%m-%d %H:%M'
				);
			?></dd>
<?php if(!empty($this->subscription->subscription_auto_renew)) { ?>
			<dt><label for="subscription_auto_renew"><?php echo JText::_('HIKA_SUBSCRIPTION_AUTO_RENEW'); ?></label></dt>
			<dd><?php
				if(!empty($this->subscription->subscription_payment_renew->method))
					echo $this->subscription->subscription_payment_renew->method;
				else
					echo JText::_('HIKA_SUBSCRIPTION_AUTO_RENEW_WITHOUT_METHOD');
			?></dd>
<?php } ?>
		</dl>
	</div></div>

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('ORDERS');
		?></div>
		<table class="adminlist table table-striped table-bordered" cellpadding="1">
			<thead>
			<tr>
				<th class="title"><?php
					echo JText::_('ORDER_NUMBER');
				?></th>
				<th class="title"><?php
					echo JText::_('ORDER_STATUS');
				?></th>
				<th class="title"><?php
					echo JText::_('DATE');
				?></th>
				<th class="title"><?php
					echo JText::_('PRODUCT');
				?></th>
				<th class="title"><?php
					echo JText::_('SUBSCRIPTION_DURATION');
				?></th>
			</tr>
			</thead>
			<tbody><?php
				echo $this->loadTemplate('orders');
			?></tbody>
		</table>
	</div></div>

	<div class="hkc-xl-6 hkc-lg-6 hikashop_tile_block"><div>
		<div class="hikashop_tile_title"><?php
			echo JText::_('HISTORY');
		?></div>
		<table class="adminlist table table-striped table-bordered" cellpadding="1">
			<thead>
			<tr>
				<th class="title"><?php
					echo JText::_('HIKA_TYPE');
				?></th>
				<th class="title"><?php
					echo JText::_('SUBSCRIPTION_STATUS');
				?></th>
				<th class="title"><?php
					echo JText::_('HIKA_USER').' / '.JText::_('IP');
				?></th>
				<th class="title"><?php
					echo JText::_('DATE');
				?></th>
				<th class="title"><?php
					echo JText::_('INFORMATION');
				?></th>
			</tr>
			</thead>
			<tbody><?php
				echo $this->loadTemplate('history');
			?></tbody>
		</table>
	</div></div>

	</div>
</div>
	<div class="clr"></div>

	<input type="hidden" name="cid" value="<?php echo @$this->subscription->subscription_id; ?>" />
	<input type="hidden" name="option" value="<?php echo HIKASERIAL_COMPONENT; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<?php echo JHTML::_('form.token'); ?>
</form>
