<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div class="iframedoc" id="iframedoc"></div>
<form action="<?php echo hikaserial::completeLink('subscription'); ?>" method="post" name="adminForm" id="adminForm">

<div class="hk-container-fluid">
	<div class="hkc-md-5"><?php
		echo $this->loadHkLayout('search', array(
			'id' => 'adminForm'
		));
	?></div>
	<div class="hkc-md-7 hikas_filters" id="hikaserial_subscription_filters">
		<!-- Filters -->
		<?php echo $this->packType->display('filter_pack', @$this->pageInfo->filter->pack, true, true, array('type' => 'subscription')); ?>
		<?php echo $this->serialStatusType->display('filter_status', @$this->pageInfo->filter->status, true, true, array('type' => 'subscription')); ?>
	</div>
</div>

	<table class="adminlist table table-striped ">
		<thead>
			<tr>
				<th class="hikaserial_serial_num_title title titlenum"><?php
					echo JText::_('HIKA_NUM');
				?></th>
				<th class="hikaserial_serial_select_title title titlebox">
					<input type="checkbox" name="toggle" value="" onclick="hikashop.checkAll(this);" />
				</th>
				<th class="hikaserial_serial_data_title title"><?php
					echo JHTML::_('grid.sort', JText::_('SUBSCRIPTION_DATA'), 'subscription.subscription_data', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_serial_pack_title title"><?php
					echo JHTML::_('grid.sort', JText::_('SUBSCRIPTION_PLAN'), 'subscription.subscription_pack_id', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_serial_pack_title title"><?php
					echo JHTML::_('grid.sort', JText::_('SUBSCRIPTION_START'), 'subscription.subscription_start_date', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_serial_pack_title title"><?php
					echo JHTML::_('grid.sort', JText::_('SUBSCRIPTION_END'), 'subscription.subscription_end_date', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_serial_pack_title title"><?php
					echo JText::_('SUBSCRIPTION_STATUS');
				?></th>
				<th class="hikaserial_serial_pack_title title"><?php
					echo JHTML::_('grid.sort', JText::_('HIKA_USER'), 'subscription.subscription_user_id', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
				<th class="hikaserial_serial_id_title title"><?php
					echo JHTML::_('grid.sort', JText::_('ID'), 'subscription.subscription_id', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value);
				?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="9">
					<?php echo $this->pagination->getListFooter(); ?>
					<?php echo $this->pagination->getResultsCounter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody>
<?php
$k = 0;
foreach($this->subscriptions as $i => &$row) {
?>
			<tr class="row<?php echo $k;?>">
				<td align="center"><?php
					echo $this->pagination->getRowOffset($i);
				?></td>
				<td align="center"><?php
					echo JHTML::_('grid.id', $i, $row->subscription_id);
				?></td>
				<td><?php
	if($this->manage) {
		?><a href="<?php echo hikaserial::completeLink('subscription&task=edit&cid='.$row->subscription_id); ?>"><?php
	}
	if(!isset($row->subscription_text_data)) {
		$row->subscription_text_data = $row->subscription_data;
		$row->subscription_data = str_replace(array("\r\n","\r","\n"), '<br/>', $row->subscription_data);
	}
	if(strpos($row->subscription_data, '<span ') !== false) {
		echo $row->subscription_data;
	} else {
		$sizelimit = $this->config->get('serial_display_size', 30);
		if($sizelimit > 0 && strlen($row->subscription_text_data) > $sizelimit && (!isset($row->trucante) || $row->trucante !== false)) {
			echo str_replace( array("\r\n","\r","\n"), '<br/>', substr($row->subscription_text_data, 0, $sizelimit)) . JText::_('SERIAL_TRUNCATED');
		} else {
			echo $row->subscription_data;
		}
	}
	if($this->manage) {
		?></a><?php
	}
				?></td>
				<td><?php
	if($this->manage) {
		?><a href="<?php echo hikaserial::completeLink('plan&task=edit&cid='.(int)$row->subscription_pack_id); ?>"><?php
	}
	echo @$row->pack_name;
	if($this->manage) {
		?></a><?php
	}
				?></td>
				<td><?php
					echo hikaserial::getDate((int)$row->subscription_start_date);
				?></td>
				<td><?php
					echo hikaserial::getDate((int)$row->subscription_end_date);

					if(!empty($row->subscription_auto_renew) && $row->subscription_status == 'active')
						echo ' <i data-toggle="hk-tooltip" data-title="'.JText::_('HIKA_SUBSCRIPTION_AUTO_RENEW', true).'" class="fas fa-sync-alt"></i>';
				?></td>
				<td><?php
					echo $this->serialStatusType->getLabel($row->subscription_status, 'subscription');
				?></td>
				<td><?php
	if((int)$row->subscription_user_id > 0) {
		if($this->manage_shop_user) {
			?><a href="<?php echo hikaserial::completeLink('shop.user&task=edit&cid='.$row->subscription_user_id); ?>"><?php
		}
		if(!empty($row->username))
			echo $row->username;
		else
			echo '<em>' . $row->subscription_user_id . '</em>';
		if($this->manage_shop_user) {
			?></a><?php
		}
	} else {
		echo '';
	}
				?></td>
				<td align="center"><?php
					echo (int)$row->subscription_id;
				?></td>
			</tr>
<?php
	$k = 1 - $k;
}
unset($row);
?>
		</tbody>
	</table>

	<input type="hidden" name="option" value="<?php echo HIKASERIAL_COMPONENT; ?>" />
	<input type="hidden" name="task" value="<?php echo @$this->task; ?>" />
	<input type="hidden" name="ctrl" value="subscription" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="export_data" id="hikaserial_export_data" value="" />
	<input type="hidden" name="filter_order" value="<?php echo $this->pageInfo->filter->order->value; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->pageInfo->filter->order->dir; ?>" />
	<?php echo JHTML::_('form.token'); ?>
</form>
