<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class subscriptionViewSubscription extends hikaserialView {

	const ctrl = 'subscription';
	const name = 'HIKA_SUBSCRIPTIONS';
	const icon = 'user-clock';

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$fct = $this->getLayout();
		if(method_exists($this, $fct)) {
			if($this->$fct($params) === false)
				return false;
		}
		parent::display($tpl);
	}

	public function listing($tpl = null) {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl);

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		hikaserial::loadJslib('tooltip');

		$this->loadRef(array(
			'searchType' => 'shop.type.search',
			'serialStatusType' => 'type.serial_status',
			'packType' => 'type.pack',
		));

		$page_filters = array(
			'pack' => 0,
			'status' => ''
		);

		$pageInfo = $this->getPageInfo('subscription.subscription_id', 'asc', $page_filters);

		$from = ' FROM '.hikaserial::table('subscription').' AS subscription ';
		$joins = ' LEFT JOIN '.hikaserial::table('pack') . ' AS hks_pack ON subscription.subscription_pack_id = hks_pack.pack_id'.
			' LEFT JOIN '.hikaserial::table('shop.user') . ' AS hk_user ON subscription.subscription_user_id = hk_user.user_id'.
			' LEFT JOIN '.hikaserial::table('users', false) . ' AS j_users ON hk_user.user_cms_id = j_users.id';

		$select = array(
			'subscription.*',
			'hks_pack.*',
			'hk_user.*',
			'j_users.*',
		);
		$filters = array();
		$order = '';
		$searchMap = array(
			'subscription.subscription_id',
			'subscription.subscription_data',
			'hk_user.user_email',
			'j_users.username',
			'j_users.name',
		);
		$orderingAccept = array(
			'subscription.'
		);

		if(!empty($this->pageInfo->filter->pack) && (int)$this->pageInfo->filter->pack > 0)
			$filters['pack'] = 'subscription.subscription_pack_id = '.(int)$this->pageInfo->filter->pack;
		if(!empty($this->pageInfo->filter->status) && $this->pageInfo->filter->status != 'all')
			$filters['status'] = 'subscription.subscription_status = '.$db->Quote($this->pageInfo->filter->status);

		$this->processFilters($filters, $order, $searchMap, $orderingAccept);
		$this->getPageInfoTotal($from . $joins . $filters . $order, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . $from . $joins . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);
		$subscriptions = $db->loadObjectList();

		$this->assignRef('subscriptions', $subscriptions);

		$this->getPagination();
		$this->getOrdering('subscription.subscription_id', true);

		JPluginHelper::importPlugin('hikaserial');
		$dispatcher = hikaserial::getDispatcher();
		$dispatcher->trigger('onDisplaySubscriptions', array(&$subscriptions, 'back-subscription-listing'));

		$manage = true; // TODO
		$this->assignRef('manage', $manage);
		$manage_shop_order = hikaserial::isAllowed($shopConfig->get('acl_order_manage', 'all'));
		$this->assignRef('manage_shop_order', $manage_shop_order);
		$manage_shop_user = hikaserial::isAllowed($shopConfig->get('acl_user_manage', 'all'));
		$this->assignRef('manage_shop_user', $manage_shop_user);

		$this->toolbar = array(
			array('name' => 'addNew', 'display' => $manage),
			array('name' => 'editList', 'display' => $manage),
			array('name' => '|', 'display' => $manage),
			array('name' => 'deleteList', 'display' => $manage),
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl),
			'dashboard'
		);
	}

	public function form() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$ctrl = '';
		$cid = '';

		$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('subscription')));
		$this->assignRef('cancelUrl', $cancelUrl);

		$config = hikaserial::config();
		$this->assignRef('config',$config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$this->loadRef(array(
			'packType' => 'type.pack',
			'serialStatusType' => 'type.serial_status',
			'delayType' => 'type.delay',
			'nameboxType' => 'shop.type.namebox',
		));

		$manage = true; // TODO
		$this->assignRef('manage', $manage);
		$manage_shop_order = hikaserial::isAllowed($shopConfig->get('acl_order_manage', 'all'));
		$this->assignRef('manage_shop_order', $manage_shop_order);
		$manage_shop_user = hikaserial::isAllowed($shopConfig->get('acl_user_manage', 'all'));
		$this->assignRef('manage_shop_user', $manage_shop_user);

		$subscription = null;
		$subscription_id = hikaserial::getCID();
		if(!empty($subscription_id)) {
			$subscriptionClass = hikaserial::get('class.subscription');
			$subscription = $subscriptionClass->get($subscription_id, true);
			$task = 'edit';
			$cid = '&cid='.$subscription_id;
			$cancelUrl = urlencode(base64_encode(hikaserial::completeLink('subscription&task=edit&cid='.(int)$subscription_id)));
		} else {
			$task = 'add';
		}
		$ctrl .= '&task='.$task.$cid;

		$this->assignRef('task', $task);
		$this->assignRef('subscription', $subscription);

		if(!empty($subscription)) {

			$subscription_order_product_ids = array();
			foreach($subscription->orders as $order) {
				if(!empty($order->order_product_id))
					$subscription_order_product_ids[(int)$order->order_product_id] = (int)$order->order_product_id;
			}
			$order_products = array();
			if(!empty($subscription_order_product_ids)) {
				$query = 'SELECT hk_op.order_product_id, hk_op.order_product_name, hk_op.product_id '.
					' FROM '.hikaserial::table('shop.order_product').' AS hk_op '.
					' WHERE hk_op.order_product_id IN ('.implode(',', $subscription_order_product_ids).')';
				$db->setQuery($query);
				$order_products = $db->loadObjectList('order_product_id');
			}
			$this->assignRef('order_products', $order_products);

			$history_user_ids = array();
			foreach($subscription->history as $history) {
				$history_user_ids[ (int)$history->history_user_id ] = (int)$history->history_user_id;
			}

			$history_users = array();
			if(!empty($history_user_ids)) {
				$query = 'SELECT hk_user.user_id, hk_user.user_email, j_user.username '.
					' FROM '.hikaserial::table('shop.user').' AS hk_user '.
					' LEFT JOIN '.hikaserial::table('joomla.users').' AS j_user ON hk_user.user_cms_id = j_user.id '.
					' WHERE hk_user.user_id IN ('.implode(',', $history_user_ids).')';
				$db->setQuery($query);
				$db_users = $db->loadObjectList('user_id');
				foreach($db_users as $k => $db_user) {
					$history_users[ (int)$k ] = !empty($db_user->username) ? $db_user->username : $db_user->user_email;
				}
				unset($db_users);
			}
			$this->assignRef('history_users', $history_users);
		}

		hikaserial::setTitle(JText::_(self::name), self::icon, self::ctrl.$ctrl);
		$this->toolbar = array(
			'|',
			'save',
			'apply',
			'hikacancel',
			'|',
			array('name' => 'pophelp', 'target' => self::ctrl.'-form')
		);
	}

	public function form_history() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$subscription_id = hikaserial::getCID();
		if(empty($subscription_id))
			return false;
		$subscriptionClass = hikaserial::get('class.subscription');
		$subscription = $subscriptionClass->get($subscription_id, true);
		if(empty($subscription))
			return false;
	}

	public function form_orders() {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$subscription_id = hikaserial::getCID();
		if(empty($subscription_id))
			return false;
		$subscriptionClass = hikaserial::get('class.subscription');
		$subscription = $subscriptionClass->get($subscription_id, true);
		if(empty($subscription))
			return false;
	}
}
