<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class SerialController extends hikaserialController {
	protected $rights = array(
		'display' => array(
			'listing',
			'download',
		),
		'add' => array(),
		'edit' => array(),
		'modify' => array(),
		'delete' => array()
	);

	public function __construct($config = array(), $skip = false) {
		$config['base_path'] = rtrim(JPATH_SITE,DS).DS.'components'.DS.'com_hikaserial'.DS;
		parent::__construct($config, $skip);

		$this->display = array('listing');
		$this->modify_views = array();
		$this->add = array();
		$this->modify = array();
		$this->delete = array();
	}

	private function requireJoomlaAccount() {
		$user = JFactory::getUser();
		if(!$user->guest)
			return true;

		$app = JFactory::getApplication();
		$app->enqueueMessage(JText::_('PLEASE_LOGIN_FIRST'));

		global $Itemid;
		$url = ('index.php?option=com_users&view=login') . (!empty($Itemid) ? '&Itemid=' . $Itemid : '');

		$app->redirect(JRoute::_($url . '&return='.urlencode(base64_encode(hikaserial::currentUrl())), false));
	}

	public function listing() {
		$this->requireJoomlaAccount();

		hikaInput::get()->set('layout', 'listing');
		return $this->display();
	}

	public function download() {
		$this->requireJoomlaAccount();

		$order_id = hikaserial::getCID('order_id');
		$orderClass = hikashop_get('class.order');
		$order = $orderClass->get($order_id);

		$fallback_url = hikashop_completeLink('user', false, true);

		if(empty($order)) {
			$app->redirect($fallback_url);
			return false;
		}

		$user_id = hikashop_loadUser(false);
		if((int)$order->order_user_id != $user_id) {
			$app->redirect($fallback_url);
			return false;
		}

		$config = hikaserial::config();
		$order_statuses = explode(',', $config->get('assignable_order_statuses', 'confirmed,shipped'));
		if(empty($order_statuses) || (count($order_statuses) == 1 && empty($order_statuses[0]))) {
			$shopConfig = hikaserial::config(false);
			$order_statuses = array($shopConfig->get('order_confirmed_status'));
		}
		if(!in_array($order->order_status, $order_statuses)) {
			$app->redirect($fallback_url);
			return false;
		}

		hikaInput::get()->set('layout', 'download');
		return $this->display();
	}
}
