<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class JFormFieldPluginoptions extends JFormField {

	protected $type = 'pluginoptions';

	protected function getInput() {
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		if(!class_exists('hikaserial') && !include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php'))
			return 'This menu options cannot be displayed without the HikaSerial Component';

		$id = hikaserial::getCID('extension_id');
		$plugins = hikaserial::get('class.plugins');
		$plugin = $plugins->get($id);
		$name = @$plugin->element;

		$shopConfig = hikaserial::config(false);
		if(!hikaserial::isAllowed($shopConfig->get('acl_plugins_manage', 'all')))
			return 'Access to the HikaSerial options of the menus is restricted';

		$text = '<a title="'.JText::_('HIKASERIAL_OPTIONS').'" href="'.JRoute::_('index.php?option=com_hikaserial&ctrl=plugins&plugin_type=plugin&task=edit&name='.$name).'">'.JText::_('HIKASERIAL_OPTIONS').'</a>';
		return $text;
	}
}
