<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

$jversion = preg_replace('#[^0-9\.]#i','',JVERSION);
if(version_compare($jversion,'4.0.0','>=')) {
	abstract class HksRouterBase extends Joomla\CMS\Component\Router\RouterBase {}
} else if(version_compare($jversion,'3.0.0','>=')) {
	abstract class HksRouterBase extends JComponentRouterBase {}
} else {
	abstract class HksRouterBase {}
}


class HikaserialRouter extends HksRouterBase
{
	protected $url_separator = '-';

	public function defineSeparator($sep) {
		$this->url_separator = $sep;
	}

	protected function initSerial() {
		if(defined('HIKASERIAL_COMPONENT'))
			return true;
		$filename = rtrim(JPATH_ADMINISTRATOR, DIRECTORY_SEPARATOR).'/components/com_hikaserial/helpers/helper.php';
		if(!file_exists($filename) || !include_once($filename))
			return false;
		return defined('HIKASERIAL_COMPONENT');
	}

	public function build(&$query) {
		$segments = array();
		$controller = null;
		$wasView = false;
		if(isset($query['ctrl'])) {
			if(substr($query['ctrl'], -6) == 'serial')
				$query['ctrl'] = substr($query['ctrl'], 0, -6);
			$segments[] = $query['ctrl'];
			$controller = $query['ctrl'];
			unset( $query['ctrl'] );
			if (isset($query['task']) && strpos($query['task'], $this->url_separator) === false) {
				$segments[] = $query['task'];
				unset($query['task']);
			}
		} elseif(isset($query['view'])) {
			$wasView = true;
			$controller = $query['view'];
			unset($query['view']);
			if(isset($query['layout'])) {
				unset($query['layout']);
			}
		}
		if(empty($query))
			return $segments;
		foreach($query as $name => $value) {
			if(!in_array($name, array('option', 'Itemid', 'start', 'format', 'limitstart', 'lang'))) {
				$segments[] = $name . $this->url_separator . $value;
				unset($query[$name]);
			}
		}
		return $segments;
	}

	public function parse(&$segments) {
		$vars = array();
		if(empty($segments))
			return $vars;

		$i = 0;
		foreach($segments as $name) {
			if(strpos($name, $this->url_separator)) {
				list($arg, $val) = explode($this->url_separator, $name);
				if(is_numeric($arg) && !is_numeric($val)) {
					$vars['cid'] = $arg;
					$vars['name'] = $val;
				} else if(is_numeric($arg))
					$vars['Itemid'] = $arg;
				else
					$vars[$arg] = $val;
			} else {
				$i++;
				if($i == 1)
					$vars['ctrl'] = $name;
				elseif($i == 2)
					$vars['task'] = $name;
			}
		}
		$segments = array();
		return $vars;
	}
}

function hikaserialBuildRoute(&$query) {
	$router = new HikaserialRouter();
	$router->defineSeparator(':');
	return $router->build($query);
}

function hikaserialParseRoute($segments) {
	$router = new HikaserialRouter();
	$router->defineSeparator(':');
	return $router->parse($segments);
}
