<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class orderserialViewOrderserial extends hikaserialView {

	public function display($tpl = null, $params = null) {
		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();
		$fct = $this->getLayout();
		if(method_exists($this, $fct))
			$this->$fct($params);
		parent::display($tpl);
	}

	public function show($params = null, $viewName = 'email-notification') {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();

		$config = hikaserial::config();
		$this->assignRef('config', $config);

		$data = null;
		$order_id = 0;

		if(!empty($params)) {
			$order_id = (int)$params->get('order_id');
			$order = $params->get('order_obj', null);
		} else {
			$order_id = hikaserial::getCID('order_id');
		}

		if(empty($order)) {
			$orderClass = hikaserial::get('shop.class.order');
			$order = $orderClass->loadFullOrder($order_id);
		}
		if($order->order_type == 'subsale') {
			if($config->get('no_serial_for_vendors', false))
				return;
			if(!empty($order->order_parent_id))
				$order_id = (int)$order->order_parent_id;
		}

		if(isset($order->hikaserial->serials_managed))
			return;

		if(empty($order->hikaserial->serials)) {
			$serialOrderClass = hikaserial::get('class.order');
			if(empty($order->hikaserial))
				$order->hikaserial = new stdClass();
			$order->hikaserial->serials = $serialOrderClass->loadSerialData($order_id, $viewName);

			if($order->order_type == 'subsale') {
				$order_product_ids = array();
				foreach($order->products as $p) {
					$order_product_ids[] = (int)$p->order_product_parent_id;
				}
				foreach($order->hikaserial->serials as $k => $s) {
					if(!in_array((int)$s->serial_order_product_id, $order_product_ids))
						unset($order->hikaserial->serials[$k]);
				}
			}

			$limit_serial_emails = (int)$config->get('limit_serial_per_email', -1);
			if($limit_serial_emails > 0) {
				$order->hikaserial->serial_limit = $limit_serial_emails;
				$order->hikaserial->serial_count = count($order->hikaserial->serials);
			}
		}

		if(!empty($order->hikaserial->serial_count) && isset($order->hikaserial->serial_limit)) {
			$this->serial_limit = (int)$order->hikaserial->serial_limit;
			$this->serial_count = (int)$order->hikaserial->serial_count;
		}

		$this->assignRef('data', $order->hikaserial->serials);
		$this->assignRef('order_id', $order_id);
	}

	public function show_order_front_show($params = null) {
		$this->show($params, 'front-order-show');
	}

	public function show_order_frontvendor_show($params = null) {
		$this->show($params, 'front-order-show');
	}

	public function show_order_frontmarket_show($params = null) {
		$this->show($params, 'front-order-show');
	}

	public function show_order_frontvendor_invoice($params = null) {
		$this->show($params, 'front-order-invoice');
	}

	public function show_email_notification_html($params = null) {
		$this->show($params, 'email-notification');
	}
}
