<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
if(empty($this->product) || empty($this->plans))
	return;
?>
<dl class="hikaserial_subscriptions">
<?php
foreach($this->plans as $plan) {
	$relation_type = $plan->relation_type;
	$plan_id = (int)$plan->pack_id;

	$label_name = $plan->pack_name;
	$values = array();
	$map = 'data[extra][sub]['.$plan_id.']';

	if($relation_type == 'upgrade') {
		$label_name = JText::_('HIKASERIAL_UPGRADE_YOUR_SUBSCRIPTION');
		$from_plan_id = (int)$plan->relation_upgrade;
		$map = 'data[extra][sub]['.$from_plan_id.']';

		foreach($this->upgrades as $u) {
			if($u->subscription_pack_id != $from_plan_id)
				continue;
			$values[(int)$u->subscription_id] = $u->subscription_data;
		}
	} else {
		$label_name = JText::_('HIKASERIAL_RENEW_YOUR_SUBSCRIPTION');
		if(in_array($relation_type, array('create_renew', 'renew_create')))
			$values[0] = JText::_('HIKASERIAL_NEW_SUBSCRIPTION');

		foreach($this->renewals as $r) {
			if($r->subscription_pack_id != $plan_id)
				continue;
			$values[(int)$r->subscription_id] = $r->subscription_data . ' (' .
				hikaserial::getDate($r->subscription_start_date, 'Y-m-d') . ')';
		}
	}
?>
	<dt><?php echo $label_name; ?></dt>
	<dd><?php
		if(!empty($values)) {
			echo JHTML::_('select.genericlist', $values, $map , '', 'value', 'text', 0);
		} else {
			echo '<em>'.JText::_('HIKASERIAL_NO_SUBSCRIPTION_AVAILABLE').'</em>';
		}
	?></dd>
<?php
}
?>
</dl>
