<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div id="hikaserial_serial_listing">
<form action="<?php echo hikaserial::completeLink($this->param_prefix.'serial&task=listing'); ?>" method="post" name="adminForm" id="adminForm">

<?php
if($this->param_option == HIKASHOP_COMPONENT)
	echo $this->toolbarHelper->process($this->toolbar, JText::_('HIKA_SERIALS'));
else
	echo $this->toolbarHelper->process(null, JText::_('HIKA_SERIALS'));
?>

<div style="clear:both"></div>

<table id="hikaserial_serials_listing_table" class="hikaserial_serials adminlist table table-bordered table-striped table-hover" style="width:100%" cellpadding="1">
	<thead>
		<tr>
			<th class="hikaserial_serials_num_title title titlenum"><?php
				echo JText::_('HIKA_NUM');
			?></th>
			<th class="hikaserial_serial_data_title title"><?php
				echo JText::_('SERIAL_DATA');
			?></th>
			<th class="hikaserial_serial_ordernumber_title title"><?php
				echo JText::_('ORDER_NUMBER');
			?></th>
			<th class="hikaserial_serial_orderproduct_title title"><?php
				echo JText::_('PRODUCT');
			?></th>
			<th class="hikaserial_serial_date_title title"><?php
				echo JText::_('DATE');
			?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="5">
				<?php echo $this->pagination->getListFooter(); ?>
				<?php echo $this->pagination->getResultsCounter(); ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
<?php
	$sizelimit = $this->config->get('serial_display_size', 30);

	$i = 0;
	$k = 0;
	foreach($this->serials as $serial) {
?>
		<tr class="row<?php echo $k; ?>">
			<td class="hikaserial_serials_num_value"><?php
				echo $this->pagination->getRowOffset($i);
			?></td>
			<td class="hikaserial_serial_data_value"><?php
				echo $this->escape($serial->serial_data);
			?></td>
			<td class="hikaserial_serial_ordernumber_value">
				<a href="<?php echo hikashop_completeLink('order&task=show&cid='.(int)$serial->serial_order_id); ?>"><?php
					echo $serial->order_number;
				?></a>
			</td>
			<td class="hikaserial_serial_orderproduct_value"><?php
				if(isset($serial->order_product_name))
					echo $this->escape( strip_tags($serial->order_product_name) );
				else
					echo JText::_('HIKASERIAL_NO_PRODUCT');
			?></td>
			<td class="hikaserial_serial_date_value"><?php
				echo hikaserial::getDate($serial->order_created, '%Y-%m-%d %H:%M');
			?></td>
		</tr>
<?php
		$k = 1-$k;
		$i++;
	}
?>
	</tbody>
</table>
	<input type="hidden" name="option" value="<?php echo $this->param_option; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="cancel_id" value="<?php echo hikaInput::get()->getInt('cancel_id', 0); ?>" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>
</div>
