<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div>
<form action="<?php echo hikamarket::completeLink('serials&task=packs'); ?>" method="post" id="adminForm" name="adminForm">
	<div class="hk-row-fluid">
		<div class="hkc-md-12"><?php
	echo $this->loadHkLayout('search', array(
		'id' => 'hikamarket_user_listing_search',
	));
		?></div>
	</div>
	<div class="hk-row-fluid">
		<div class="hkc-md-12">
			<div class="expand-filters" style="width:auto;">
<?php
					if(!empty($this->vendorType))
						echo $this->vendorType->display('filter_vendors', @$this->pageInfo->filter->vendors);
?>
			</div>
			<div style="clear:both"></div>
		</div>
	</div>
<?php
if(!empty($this->packs)) {
	$acls = array(
		'pack/edit' => hikamarket::acl('plugins/hikaserial/pack/edit'),
		'pack/publish' => hikamarket::acl('plugins/hikaserial/pack/edit/publish'),
		'product/edit' => hikamarket::acl('product/edit'),
		'serial/import' => hikamarket::acl('plugins/hikaserial/serial/import'),
	);

	$publish_content = '<i class="fas fa-check"></i> ' . JText::_('HIKA_PUBLISHED');
	$unpublish_content = '<i class="fas fa-times"></i> ' . JText::_('HIKA_UNPUBLISHED');

	foreach($this->packs as $pack) {
		$pack->edit = $acls['pack/edit'] && ($this->vendor->vendor_id <= 1 || (int)$pack->pack_vendor_id == $this->vendor->vendor_id);
		$url = ($pack->edit) ? hikamarket::completeLink('serials&task=pack&cid='.$pack->pack_id) : '#';
		$extra_classes = '';
?>
	<div class="hk-card hk-card-default hk-card-pack<?php echo $extra_classes; ?>" data-hkm-pack="<?php echo (int)$pack->pack_id; ?>">
		<div class="hk-card-header">
			<div class="hk-row-fluid">
				<a class="hkc-sm-6 hkm_pack_name" href="<?php echo $url; ?>"><i class="fas fa-box-open"></i> <?php
					if(!empty($pack->pack_name))
						echo $pack->pack_name;
					else
						echo '<em>'.JText::_('HIKASERIAL_NO_NAME').'</em>';
				?></a>
				<div class="hkc-sm-6 hkm_pack_">
<?php
		if($acls['serial/import'] && $pack->edit) {
?>
					<a class="hikabtn hikabtn-info hikabtn-mini" href="<?php echo hikamarket::completeLink('serials&task=import&pack_id='.(int)$pack->pack_id); ?>"><i class="fas fa-file-import"></i> <?php echo JText::_('IMPORT'); ?></a>
<?php
		}

		if($acls['pack/publish'] && $pack->edit) {
?>
					<a class="hikabtn hikabtn-mini hikabtn-<?php echo ($pack->pack_published) ? 'success' : 'danger'; ?> hkm_publish_button" data-toggle-state="<?php echo $pack->pack_published ? 1 : 0; ?>" data-toggle-id="<?php echo $pack->pack_id; ?>" onclick="return window.localPage.togglePack(this);"><?php
						echo ($pack->pack_published) ? $publish_content : $unpublish_content;
					?></a>
<?php
		} else {
?>
					<span class="hkm_publish_state hk-label hk-label-<?php echo ($pack->pack_published) ? 'green' : 'red'; ?>"><?php echo ($pack->pack_published) ? $publish_content : $unpublish_content; ?></span>
<?php
		}
?>
				</div>
			</div>
		</div>
		<div class="hk-card-body">
			<div class="hk-row-fluid">
<?php
		if(!empty($pack->pack_description)) {
?>
				<div class="hkc-md-12 hikaserial_pack_description"><?php
					echo JHTML::_('content.prepare',preg_replace('#<hr *id="system-readmore" */>#i', '', $pack->pack_description));
				?></div>
<?php
		}
?>
				<div class="hkc-md-6 hkm_pack_products">
<?php
		if(!empty($pack->products)) {
			$stats = hikamarket::acl('plugins/hikaserial/serials/listing');
			$export = hikamarket::acl('plugins/hikaserial/serials/export');
?>
	<table class="table table-bordered table-striped" style="margin:0;padding:0;width:100%">
		<thead>
			<tr>
				<th><?php echo JText::_('PRODUCT_NAME'); ?></th>
				<th><?php echo JText::_('PRODUCT_QUANTITY'); ?></th>
<?php if($stats || $export) { ?>
				<th></th>
<?php } ?>
			</tr>
		</thead>
		<tbody>
<?php
			foreach($pack->products as $product) {
?>
			<tr>
				<td><?php
					if($acls['product/edit'])
						echo '<a href="'.hikamarket::completeLink('product&task=edit&cid='.$product->product_id).'"><i class="fas fa-pencil-alt"></i> ';
					echo $this->escape($product->product_name);
					if($acls['product/edit'])
						echo '</a>';
				?></td>
				<td><?php echo (int)$product->quantity; ?></td>
<?php
				if($stats || $export) {
					$stats_link = hikamarket::completeLink('serials&task='.($stats ? 'stats':'export').'&pack_id='.(int)$pack->pack_id.'&product_id='.$product->product_id);
?>
				<td style="text-align:center">
					<a href="<?php echo $stats_link; ?>"><i class="fas fa-chart-bar"></i></a>
				</td>
<?php
				}
?>
			</tr>
<?php
			}
?>
		</tbody>
	</table>
<?php
		} else {
?>
	<div class="hikaserial_empty_msg"><?php
		echo JText::_('NOTICE_NO_PRODUCTS');
	?></div>
<?php
		}
?>
				</div>
				<div class="hkc-md-6 hkm_pack_stats">
<?php
		if(!empty($pack->serials)) {
?>
	<table class="table table-bordered table-striped" style="margin:0;padding:0;width:100%">
		<thead>
			<tr>
				<th><?php echo JText::_('SERIAL_STATUS'); ?></th>
				<th><?php echo JText::_('PRODUCT_QUANTITY'); ?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<td><?php echo JText::_('TOTAL_SERIALS'); ?></td>
				<td><?php echo (int)$pack->total_serials; ?></td>
			</tr>
		</tfoot>
		<tbody>
<?php
			foreach($pack->serials as $serial) {
?>
			<tr>
				<td><?php echo $this->serialStatusType->get($serial->serial_status); ?></td>
				<td><?php echo (int)$serial->count; ?></td>
			</tr>
<?php
			}
?>
		</tbody>
	</table>
<?php
		} else {
?>
	<div class="hikaserial_empty_msg"><?php
		echo JText::_('NOTICE_NO_SERIALS');
	?></div>
<?php
		}
?>
				</div>
			</div>
		</div>
	</div>
<?php
	}
?>
	<div class="hikamarket_pagination"><?php
		echo $this->pagination->getListFooter();
		echo $this->pagination->getResultsCounter();
	?></div>
<?php
} else {
?>
	<div class="hikaserial_empty_msg"><?php
		echo JText::_('NOTICE_NO_PACKS');
	?></div>
<?php
}
?>
	<input type="hidden" name="Itemid" value="<?php echo $this->Itemid; ?>" />
	<input type="hidden" name="option" value="<?php echo HIKAMARKET_COMPONENT; ?>" />
	<input type="hidden" name="task" value="packs" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<input type="hidden" name="boxchecked" value="0" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>
<?php if(!empty($acls['pack/publish'])) { ?>
<script type="text/javascript">
if(!window.localPage) window.localPage = {};
window.localPage.togglePack = function(el) {
	var w=window, d=document, o=w.Oby,
		state = el.getAttribute('data-toggle-state'),
		id = el.getAttribute('data-toggle-id');
	if(!id) return false;
	var url="<?php echo hikamarket::completeLink('serials&task=toggle','ajax',true);?>",
		v = (state == 0) ? 1 : 0,
		data=o.encodeFormData({"target":"pack_published-"+id,"value":v,"table":"pack","<?php echo hikamarket::getFormToken(); ?>":1});
	el.disabled = true;
	if(state == 1) el.innerHTML = "<i class=\"fas fa-spinner fa-pulse\"></i> <?php echo JText::_('HIKA_UNPUBLISHING', true); ?>";
	else el.innerHTML = "<i class=\"fas fa-spinner fa-pulse\"></i> <?php echo JText::_('HIKA_PUBLISHING', true); ?>";
	el.classList.remove("hikabtn-success", "hikabtn-danger");
	o.xRequest(url,{mode:"POST",data:data},function(x,p){
		if(x.responseText && x.responseText == '1')
			state = v;
		el.disabled = false;
		el.setAttribute('data-toggle-state', v);
		if(state == 1) el.innerHTML = "<i class=\"fas fa-check\"></i> <?php echo JText::_('HIKA_PUBLISHED', true); ?>";
		else el.innerHTML = "<i class=\"fas fa-times\"></i> <?php echo JText::_('HIKA_UNPUBLISHED', true); ?>";
		el.classList.add( state ? "hikabtn-success" : "hikabtn-danger" );
	});
};
</script>
<?php } ?>
</div>
