<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div id="hikaserial_subscription_listing">
<form action="<?php echo hikaserial::completeLink($this->param_prefix.'subscription&task=listing'); ?>" method="post" name="adminForm" id="adminForm">

<?php
if($this->param_option == HIKASHOP_COMPONENT)
	echo $this->toolbarHelper->process($this->toolbar, JText::_('HIKA_SUBSCRIPTIONS'));
else
	echo $this->toolbarHelper->process(null, JText::_('HIKA_SUBSCRIPTIONS'));
?>

<div style="clear:both"></div>

<div class="hk-row-fluid">
	<div class="hkc-md-12">
<?php
?>
		<div class="hikam_sort_zone"><?php
			if(!empty($this->ordering_values))
				echo JHTML::_('select.genericlist', $this->ordering_values, 'filter_fullorder', 'onchange="this.form.submit();"', 'value', 'text', $this->full_ordering);
		?></div>
	</div>
	<div class="hkc-md-12">
		<div class="expand-filters">
<?php

?>
		</div>
		<div style="clear:both"></div>
	</div>
</div>

<div class="hikaserial_subscriptions" id="hikaserial_subscription_main_listing">
<?php
$extra_classes = '';

foreach($this->subscriptions as $subscription) {
	$url = hikaserial::completeLink($this->param_prefix.'subscription&task=show&cid='.(int)$subscription->subscription_id.'&name='.$subscription->pack_name.$this->url_itemid);
?>
	<div class="hk-card hk-card-default hk-card-subscription<?php echo $extra_classes; ?>" data-hkq-subscription="<?php echo (int)$subscription->subscription_id; ?>">
		<div class="hk-card-header">
			<a class="hk-row-fluid" href="<?php echo $url; ?>">
				<div class="hkc-sm-6 hks_subscription_plan">
					<i class="far fa-address-card"></i>
					<?php echo $subscription->pack_name; ?>
				</div>
				<div class="hkc-sm-6 hks_subscription_end">
					<i class="fas fa-clock"></i>
					<?php
	if($subscription->remaing_days !== false) {
		$content = round($subscription->remaing_days) . ' '. JText::_('DAYS');
		$desc = hikaserial::getDate((int)$subscription->subscription_end_date);
		echo hikaserial::tooltip($desc, JText::_('SUBSCRIPTION_END'), '', $content);
	} elseif($subscription->subscription_status == 'active') {
		echo JText::_('HIKA_SUBSCRIPTION_NO_LIMIT');
	} else {
		echo JText::_('HIKA_SUBSCRIPTION_EMPTY_REMAIN');
	}

	if(!empty($subscription->subscription_auto_renew) && $subscription->subscription_status == 'active')
		echo ' <i data-toggle="hk-tooltip" data-title="'.JText::_('HIKA_SUBSCRIPTION_AUTO_RENEW', true).'" class="fas fa-sync-alt"></i>';
					?>
				</div>
			</a>
		</div>
		<div class="hk-card-body">
			<div class="hk-row-fluid">
				<div class="hkc-sm-6 hks_subscription_data">
					<span class="subscription_data"><?php echo $subscription->subscription_data; ?></span>
				</div>
				<div class="hkc-sm-2 hks_subscription_status"><?php
					echo $this->serialStatusType->getLabel($subscription->subscription_status, 'subscription');
				?></div>
				<div class="hkc-sm-4 hks_subscription_actions"><?php

	$data = array(
		'details' => array(
			'name' => '<i class="fas fa-search"></i> ' . JText::_('HIKA_DETAILS', true),
			'link' => $url
		)
	);

	$price_tax = (int)$this->shopConfig->get('price_with_tax', 1);
	if(!empty($subscription->cancel_renew)) {
		$data[] = '-';
		$data['cancel_renew'] = array(
			'name' => '<i class="fas fa-ban"></i> ' . JText::_('HIKA_CANCEL_AUTO_RENEW'),
			'link' => hikaserial::completeLink('shop.subscription&task=cancelrenew&subscription='.(int)$subscription->subscription_id.$this->url_itemid),
			'extra' => 'rel="nofollow"'
		);
	}
	if($subscription->renewals !== false) {
		$data[] = '-';
		foreach($subscription->renewals as $k => $renewal) {
			$classical_url = 'shop.subscription&task=renew&subscription='.(int)$subscription->subscription_id.'&product='.(int)$renewal['product']->product_id;
			$renewal_price = $price_tax ? $renewal['product']->prices[0]->price_value_with_tax : $renewal['product']->prices[0]->price_value;

			$data['renew.'.$k] = array(
				'name' => '<i class="fas fa-sync-alt"></i> ' . JText::sprintf('HIKA_RENEW_X_FOR_Y',
					$this->delayType->show($renewal['duration']),
					$this->currencyClass->format($renewal_price, $renewal['product']->prices[0]->price_currency_id)
				),
				'link' => hikaserial::completeLink($classical_url),
				'extra' => 'rel="nofollow"'
			);
		}
	}
	if($subscription->upgrades !== false) {
		$data[] = '-';
		foreach($subscription->upgrades as $k => $upgrade) {
			$classical_url = 'shop.subscription&task=upgrade&subscription='.(int)$subscription->subscription_id.'&product='.(int)$upgrade['product']->product_id.$this->url_itemid;
			$upgrade_price = $price_tax ? $upgrade['product']->prices[0]->price_value_with_tax : $upgrade['product']->prices[0]->price_value;

			$data['upgrade.'.$k] = array(
				'name' => '<i class="fas fa-level-up-alt"></i> '.JText::sprintf('HIKA_UPGRADE_TO_X_FOR_Y',
					$upgrade['pack']->pack_name,
					$this->currencyClass->format($upgrade_price, $upgrade['product']->prices[0]->price_currency_id),
					hikaserial::getDate($upgrade['end_time'])
				),
				'link' => hikaserial::completeLink($classical_url),
				'extra' => 'rel="nofollow"'
			);
		}
	}

	if(!empty($data)) {
		echo $this->dropdownHelper->display(
			JText::_('HIKASERIAL_ACTIONS'),
			$data,
			array('type' => '', 'class' => 'hikabtn-primary', 'right' => true, 'up' => false)
		);
	}
				?></div>
			</div>
		</div>
	</div>
<?php
}
?>
	<div class="hikaserial_subscription_footer">
		<div class="hikaserial_pagination">
			<?php $this->pagination->form = '_bottom'; echo $this->pagination->getListFooter(); ?>
			<?php echo $this->pagination->getResultsCounter(); ?>
		</div>
	</div>
</div>
<?php
?>
	<input type="hidden" name="option" value="<?php echo $this->param_option; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="ctrl" value="<?php echo hikaInput::get()->getCmd('ctrl'); ?>" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="cancel_id" value="<?php echo hikaInput::get()->getInt('cancel_id', 0); ?>" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>
</div>
