<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><div id="hikaserial_subscription_show">

<?php
echo $this->toolbarHelper->process($this->toolbar, $this->title);
?>
<div style="clear:both"></div>
<dl class="hika_options large">
	<dt class="hikaserial_subscription_plan"><?php echo JText::_('HIKA_SERIAL_PLAN'); ?></dt>
	<dd class="hikaserial_subscription_plan"><?php echo $this->escape($this->subscription->plan->pack_name); ?></dd>

	<dt class="hikaserial_subscription_data"><?php echo JText::_('SUBSCRIPTION_NAME'); ?></dt>
	<dd class="hikaserial_subscription_data"><span><?php echo $this->escape($this->subscription->subscription_data); ?></span></dd>

	<dt class="hikaserial_subscription_status"><?php echo JText::_('SUBSCRIPTION_STATUS'); ?></dt>
	<dd class="hikaserial_subscription_status"><?php echo $this->serialStatusType->getLabel($this->subscription->subscription_status, 'subscription'); ?></dd>

	<dt class="hikaserial_subscription_start"><?php echo JText::_('SUBSCRIPTION_START'); ?></dt>
	<dd class="hikaserial_subscription_start"><?php echo hikaserial::getDate((int)$this->subscription->subscription_start_date); ?></dd>

	<dt class="hikaserial_subscription_end"><?php echo JText::_('SUBSCRIPTION_END'); ?></dt>
	<dd class="hikaserial_subscription_end"><?php echo hikaserial::getDate((int)$this->subscription->subscription_end_date); ?></dd>
</dl>
<div class="clearfix"></div>

<?php
if(!empty($this->subscription->downloads)) {
?>
<h3><?php echo JText::_('SUBSCRIPTION_DOWNLOADS')?></h3>
<table class="adminlist table table-striped table-bordered" cellpadding="1">
	<thead>
	<tr>
		<th class="title"><?php
		?></th>
	</tr>
	</thead>
	<tbody>
	</tbody>
</table>
<?php
}
?>

<?php
if(!empty($this->subscription->renewals)) {
?>
<h3><?php echo JText::_('SUBSCRIPTION_RENEWALS')?></h3>
<div class="hikaserial_subscription_renewals">
<?php
	$css_button = $this->shopConfig->get('css_button', 'hikabtn');
	$css_button_cart = $this->shopConfig->get('css_button_cart', 'hikacart');

	foreach($this->subscription->renewals as $renewal) {
		$classical_url = 'shop.subscription&task=renew&subscription='.(int)$this->subscription->subscription_id.'&product='.(int)$renewal['product']->product_id.$this->url_itemid;
		$renewal_price = $this->shopConfig->get('price_with_tax', 1) ? $renewal['product']->prices[0]->price_value_with_tax : $renewal['product']->prices[0]->price_value;


?>
	<div>
		<a class="<?php echo $css_button . ' ' . $css_button_cart; ?>" rel="nofollow" href="<?php echo hikaserial::completeLink($classical_url); ?>"><span><?php
			echo JText::sprintf('HIKA_RENEW_X_FOR_Y',
				$this->delayType->show($renewal['duration']),
				$this->currencyClass->format($renewal_price, $renewal['product']->prices[0]->price_currency_id)
			);
		?></span></a>
	</div>
<?php
	}
?>
</div>
<?php
}
?>

<?php
if(!empty($this->subscription->orders)) {
?>
<h3><?php echo JText::_('SUBSCRIPTION_DETAILS')?></h3>
<table class="adminlist table table-striped table-bordered" cellpadding="1">
	<thead>
	<tr>
		<th class="title"><?php
			echo JText::_('ORDER_NUMBER');
		?></th>
		<th class="title"><?php
			echo JText::_('ORDER_STATUS');
		?></th>
		<th class="title"><?php
			echo JText::_('DATE');
		?></th>
		<th class="title"><?php
			echo JText::_('SUBSCRIPTION_DURATION');
		?></th>
	</tr>
	</thead>
	<tbody>
<?php
	$k = 0;
	foreach($this->subscription->orders as $order) {
?>
	<tr class="row<?php echo $k; ?>">
		<td><?php
			echo $this->escape($order->order_number);
		?></td>
		<td><span class="order-label order-label-<?php echo preg_replace('#[^a-z_0-9]#i', '_', str_replace(' ','_', $order->order_status)); ?>"><?php
			echo hikashop_orderStatus($order->order_status);
		?></span></td>
		<td><?php
			echo hikaserial::getDate( !empty($order->order_invoice_created) ? $order->order_invoice_created : $order->order_created );
		?></td>
		<td><?php
			echo $this->delayType->show( $order->subscription_duration );
		?></td>
	</tr>
<?php
		$k = 1 - $k;
	}
?>
	</tbody>
</table>
<?php
}
?>
</div>
