<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class subscriptionViewSubscription extends hikaserialView {
	protected $triggerView = true;

	public function display($tpl = null, $params = null) {
		$this->params =& $params;
		$app = JFactory::getApplication();
		$folder	= JPATH_BASE.DS.'templates'.DS.$app->getTemplate().DS.'html'.DS.HIKASERIAL_COMPONENT.DS.$this->getName();
		$this->addTemplatePath($folder);

		$fct = $this->getLayout();

		global $Itemid;
		$this->url_itemid = '';
		if(!empty($Itemid))
			$this->url_itemid = '&Itemid=' . $Itemid;

		$this->param_option = hikaInput::get()->getCmd('option', '');
		if(!in_array($this->param_option, array(HIKASHOP_COMPONENT, HIKASERIAL_COMPONENT)))
			$this->param_option = HIKASERIAL_COMPONENT;
		$this->param_prefix = ($this->param_option == HIKASHOP_COMPONENT) ? 'shop.' : '';

		if(method_exists($this, $fct))
			$this->$fct($params);
		parent::display($tpl);
	}

	public function listing($tpl = null) {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();

		$user = hikaserial::loadUser(true);

		$config = hikaserial::config();
		$this->assignRef('config', $config);

		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$cpanel_itemid = '';
		if(hikaInput::get()->getInt('cancel_id', 0) > 0)
			$cpanel_itemid = '&Itemid=' . hikaInput::get()->getInt('cancel_id', 0);
		$this->assignRef('cpanel_itemid', $cpanel_itemid);

		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();

		hikashop_loadJslib('tooltip');

		$this->loadRef(array(
			'subscriptionClass' => 'class.subscription',
			'serialStatusType' => 'type.serial_status',
			'delayType' => 'type.delay',
			'currencyClass' => 'shop.class.currency',
			'dropdownHelper' => 'shop.helper.dropdown',
		));

		$pageInfo = $this->getPageInfo('subscription.subscription_id');

		$filters = array(
			'subscription_user_id' => 'subscription.subscription_user_id = ' . (int)$user->user_id,
		);
		$order = ' ORDER BY subscription.subscription_end_date DESC, subscription.subscription_status ASC, subscription.subscription_id DESC';
		$searchMap = array();
		$select = array('subscription.*', 'pack.*');

		$from = ' FROM ' . hikaserial::table('subscription') . ' AS subscription ';
		$joins = ' INNER JOIN '.hikaserial::table('pack').' AS pack ON subscription.subscription_pack_id = pack.pack_id ';
		$this->processFilters($filters, $order, $searchMap, array(null));
		$this->getPageInfoTotal($from . $filters . $order, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . $from . $joins . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);
		$subscriptions = $db->loadObjectList();

		$now = time();
		foreach($subscriptions as &$subscription) {
			$subscription->subscription_end_date = (int)$subscription->subscription_end_date;

			$subscription->remaing_days = false;
			if($subscription->subscription_end_date > 0 && $subscription->subscription_status == 'active') {
				$subscription->remaing_days = ($subscription->subscription_end_date - $now) / 86400;
			}

			if(!empty($subscription->subscription_payment_renew)) {
				$subscription->subscription_payment_renew = hikaserial::unserialize($subscription->subscription_payment_renew);

				if(!empty($subscription->subscription_auto_renew) && !empty($subscription->subscription_payment_renew->method))
					$subscription->cancel_renew = true;
			}
		}
		unset($subscription);

		$this->subscriptionClass->getSubscriptionsRenewals($subscriptions);
		$this->subscriptionClass->getSubscriptionsUpgrades($subscriptions);
		$this->assignRef('subscriptions', $subscriptions);

		$have_actions = false;
		foreach($subscriptions as $subscription) {
			if(!empty($subscription->renewals)) {
				$have_actions = true;
				break;
			}
			if(!empty($subscription->upgrades)) {
				$have_actions = true;
				break;
			}
			if($subscription->subscription_status == 'active' && !empty($subscription->subscription_auto_renew) && !empty($subscription->subscription_payment_renew->method)) {
				$have_actions = true;
				break;
			}
		}
		$this->assignRef('have_actions', $have_actions);
		$this->assignRef('have_renewals', $have_actions);

		$this->getPagination();

		$this->title = JText::_('HIKA_SUBSCRIPTIONS');
		$this->toolbar = array(
			'back' => array(
				'icon' => 'back',
				'fa' => array('html' => '<i class="fas fa-arrow-circle-left"></i>'),
				'name' => JText::_('HIKA_BACK'),
				'url' => hikashop_completeLink('user&task=cpanel'.$this->cpanel_itemid)
			)
		);
	}

	public function show($tpl = null) {
		$subscription_id = hikaserial::getCID('subscription_id');
		$subscriptionClass = hikaserial::get('class.subscription');

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$this->loadRef(array(
			'serialStatusType' => 'type.serial_status',
			'delayType' => 'type.delay',
			'currencyClass' => 'shop.class.currency',
		));

		$subscription = $subscriptionClass->get($subscription_id, true);
		$subscriptionClass->getSubscriptionsRenewals($subscription);

		unset($subscription->user);

		$this->assignRef('subscription', $subscription);

		$this->title = JText::sprintf('HIKA_SUBSCRIPTION_X', strip_tags(@$this->subscription->plan->pack_name));
		$this->toolbar = array(
			'back' => array(
				'icon' => 'back',
				'fa' => array('html' => '<i class="fas fa-arrow-circle-left"></i>'),
				'name' => JText::_('HIKA_BACK'),
				'url' => hikaserial::completeLink($this->param_prefix.'subscription&task=listing'.$this->url_itemid)
			)
		);
	}

	public function cancelrenew($tpl = null) {
		$subscription_id = hikaserial::getCID('subscription');
		$subscriptionClass = hikaserial::get('class.subscription');

		$config = hikaserial::config();
		$this->assignRef('config', $config);
		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$this->loadRef(array(
			'serialStatusType' => 'type.serial_status',
			'delayType' => 'type.delay',
		));

		$subscription = $subscriptionClass->get($subscription_id, true);
		$this->assignRef('subscription', $subscription);

		$this->title = JText::sprintf('HIKA_SUBSCRIPTION_X', strip_tags(@$this->subscription->plan->pack_name));
		$this->toolbar = array(
			'back' => array(
				'icon' => 'back',
				'fa' => array('html' => '<i class="fas fa-arrow-circle-left"></i>'),
				'name' => JText::_('HIKA_BACK'),
				'url' => hikaserial::completeLink($this->param_prefix.'subscription&task=listing'.$this->url_itemid)
			),
			'confirm' => array(
				'icon' => 'save',
				'fa' => array('html' => '<i class="far fa-calendar-check"></i>'),
				'name' => JText::_('HIKA_CANCEL_AUTO_RENEW'),
				'url' => '#confirm',
				'linkattribs' => 'onclick="return window.hikashop.submitform(\'cancelrenew\',\'adminForm\');"',
			)
		);
	}

	public function downloads($tpl = null) {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();

		$user = hikaserial::loadUser(true);

		$config = hikaserial::config();
		$this->assignRef('config', $config);

		$shopConfig = hikaserial::config(false);
		$this->assignRef('shopConfig', $shopConfig);

		$cpanel_itemid = '';
		if(hikaInput::get()->getInt('cancel_id', 0) > 0)
			$cpanel_itemid = '&Itemid=' . hikaInput::get()->getInt('cancel_id', 0);
		$this->assignRef('cpanel_itemid', $cpanel_itemid);

		$this->paramBase = HIKASERIAL_COMPONENT.'.'.$this->getName();

		$active_status = 'active';
		$now = time();

		$pageInfo = $this->getPageInfo('hk_file.file_id');

		$filters = array(
			'subscription_user_id' => 'subscription.subscription_user_id = ' . (int)$user->user_id,
			'subscription_status' => 'subscription.subscription_status = ' . $db->Quote($active_status),
			'subscription_date' => 'subscription.subscription_end_date = 0 OR subscription.subscription_end_date > '.$now,
			'pack_published' => 'pack.pack_published = 1',
		);
		$order = ' ORDER BY subscription.subscription_end_date DESC, subscription.subscription_id DESC, hk_file.file_ordering ASC, hk_file.file_id ASC';
		$searchMap = array();
		$select = array('hk_file.*', 'subscription.*', 'pack.*');

		$from = array(
			'subscription' => 'FROM ' . hikaserial::table('subscription') . ' AS subscription',
			'file' => 'INNER JOIN '.hikaserial::table('shop.file').' AS hk_file ON (subscription.subscription_pack_id = hk_file.file_ref_id AND hk_file.file_type = ' . $db->Quote('plan') . ')',
			'pack' => 'INNER JOIN '.hikaserial::table('pack').' AS pack ON subscription.subscription_pack_id = pack.pack_id',
		);
		$this->processFilters($filters, $order, $searchMap, array(null));
		$this->getPageInfoTotal(implode(' ', $from) . ' ' . $filters . $order, '*');
		$db->setQuery('SELECT ' . implode(', ', $select) . ' ' . implode(' ', $from) . ' ' . $filters . $order, $pageInfo->limit->start, $pageInfo->limit->value);
		$subscription_files = $db->loadObjectList();
		$this->assignRef('files', $subscription_files);

		$upload_dir = $shopConfig->get('uploadsecurefolder');
		$upload_dir = rtrim(JPath::clean(html_entity_decode($upload_dir)), DS.' ').DS;
		if(!preg_match('#^([A-Z]:)?/.*#',$upload_dir) && (substr($upload_dir, 0, 1) != '/' || !is_dir($upload_dir))) {
			$upload_dir = JPath::clean(HIKASHOP_ROOT.DS.trim($upload_dir, DS.' ').DS);
		}

		foreach($subscription_files as &$file) {
			$file->file_size = 0;
			if(JFile::exists($upload_dir . $file->file_path))
				$file->file_size = @filesize($upload_dir . $file->file_path);
		}

		$this->getPagination();

		$this->title = JText::_('HIKA_SUBSCRIPTIONS');
		$this->toolbar = array(
			'back' => array(
				'icon' => 'back',
				'fa' => array('html' => '<i class="fas fa-arrow-circle-left"></i>'),
				'name' => JText::_('HIKA_BACK'),
				'url' => hikashop_completeLink('user&task=cpanel'.$this->cpanel_itemid)
			)
		);
	}
}
