<?php
/**
 * @package    HikaSerial for Joomla!
 * @version    4.0.2
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2023 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
if(version_compare(JVERSION, '2.5.0', '<')) {
	echo '<html><body><h1>This extension works with Joomla 2.5 or newer.</h1>'.
		'<h2>Please install the latest version of Joomla.</h2>'.
		'installation abort...</body></html>';
	exit;
}

$version = explode('.',PHP_VERSION);
if($version[0] < 5) {
	echo '<html><body><h1>This extension works with PHP 5 or newer.</h1>'.
		'<h2>Please contact your web hosting provider to update your PHP version</h2>'.
		'installation abort...</body></html>';
	exit;
}

if(!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR);

class hikaserialInstall {
	private $level = 'Subscription';
	private $version = '4.0.2';
	private $update = false;
	private $fromLevel = '';
	private $fromVersion = '';
	private $freshinstall = 1;
	private $db;

	public function __construct() {
		$this->db = JFactory::getDBO();
	}

	public function addPref() {
		$conf = JFactory::getConfig();
		$this->level = ucfirst($this->level);
		$allPref = array(
			'level' => $this->level
			,'version' => $this->version
			,'show_footer' => '1'
			,'installcomplete' => '0'
			,'Standard' => '0'
			,'Subscription' => '1'
		);
		$sep = '';
		$query = 'INSERT IGNORE INTO `'.HIKASERIAL_DBPREFIX.'config` (`config_namekey`,`config_value`,`config_default`) VALUES ';
		foreach($allPref as $n => $v) {
			$query .= $sep.'('.$this->db->Quote($n).','.$this->db->Quote($v).','.$this->db->Quote($v).')';
			$sep = ',';
		}
		$this->db->setQuery($query);
		$this->db->execute();
	}

	public function updatePref() {
		$this->db->setQuery('SELECT `config_namekey`, `config_value` FROM `'.HIKASERIAL_DBPREFIX.'config` WHERE `config_namekey` IN (\'version\',\'level\')', 0 , 2);
		$res = $this->db->loadObjectList('config_namekey');
		if($res['version']->config_value == $this->version && $res['level']->config_value == $this->level)
			return true;

		$this->update = true;
		$this->fromLevel = $res['level']->config_value;
		$this->fromVersion = $res['version']->config_value;
		$query = 'REPLACE INTO `'.HIKASERIAL_DBPREFIX.'config` (`config_namekey`,`config_value`) VALUES (\'level\','.$this->db->Quote($this->level).'),(\'version\','.$this->db->Quote($this->version).'),(\'installcomplete\',\'0\')';
		$this->db->setQuery($query);
		$this->db->execute();
	}

	public function updateSQL() {
		$structs = array(
			'order' => array(
				'order_serial_params' => 'TEXT NOT NULL DEFAULT \'\'',
				'order_parent_id' => 'INT(10) NOT NULL DEFAULT 0',
			),
		);

		foreach($structs as $table => &$v) {
			$sql = array();
			$current = array();

			$current = $this->db->getTableColumns(hikaserial::table('shop.'.$table));

			foreach($v as $col => $colSql) {
				if(!isset($current[$col])) {
					$sql[] = 'ADD COLUMN `' . $col . '` ' . $colSql;
				}
			}
			if(!empty($sql)) {
				$query = 'ALTER TABLE `'.hikaserial::table('shop.'.$table).'` '.implode(',', $sql);
				$this->db->setQuery($query);
				try {
					$this->db->execute();
				}catch(Exception $e) { }
				unset($query);
			}
			unset($sql);
		}

		if(!$this->update)
			return true;


		if(version_compare($this->fromVersion, '1.2.0', '<')) {
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_consumer` (".
				"	`consumer_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`consumer_type` VARCHAR(255) NOT NULL,".
				"	`consumer_published` INT(4) NOT NULL DEFAULT 0,".
				"	`consumer_name` VARCHAR(255) NOT NULL,".
				"	`consumer_ordering` INT(10) NOT NULL DEFAULT 0,".
				"	`consumer_description` TEXT NOT NULL DEFAULT '',".
				"	`consumer_params` TEXT NOT NULL DEFAULT '',".
				"	`consumer_access` VARCHAR(255) NOT NULL DEFAULT 'all',".
				"	PRIMARY KEY (`consumer_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
		}

		if(version_compare($this->fromVersion, '1.3.0', '<')) {
			$this->addColumns('serial', array("`serial_extradata` TEXT NULL DEFAULT NULL"));
		}

		if(version_compare($this->fromVersion, '1.4.0', '<')) {
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_history` (".
				"	`history_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`history_serial_id` INT(10) unsigned NOT NULL DEFAULT '0',".
				"	`history_created` INT(10) unsigned NOT NULL DEFAULT '0',".
				"	`history_ip` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_new_status` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_type` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_data` TEXT NOT NULL DEFAULT '',".
				"	`history_user_id` INT(10) unsigned DEFAULT '0',".
				"	PRIMARY KEY (`history_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
		}

		if(version_compare($this->fromVersion, '1.5.0', '<')) {
			$file = HIKASERIAL_BACK.'admin.hikaserial.php';
			if(file_exists($file)) JFile::delete($file);
		}

		if(version_compare($this->fromVersion, '1.5.1', '<')) {
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_plugin` (".
				"	`plugin_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`plugin_type` VARCHAR(255) NOT NULL,".
				"	`plugin_published` INT(4) NOT NULL DEFAULT 0,".
				"	`plugin_name` VARCHAR(255) NOT NULL,".
				"	`plugin_ordering` INT(10) NOT NULL DEFAULT 0,".
				"	`plugin_description` TEXT NOT NULL DEFAULT '',".
				"	`plugin_params` TEXT NOT NULL DEFAULT '',".
				"	`plugin_access` VARCHAR(255) NOT NULL DEFAULT 'all',".
				"	PRIMARY KEY (`plugin_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
		}

		if(version_compare($this->fromVersion, '1.10.0', '<')) {
			$this->addColumns('pack', array(
				"`pack_vendor_id` INT(10) NOT NULL DEFAULT 0",
				"`pack_manage_access` VARCHAR(255) NOT NULL DEFAULT 'all'",
			));
		}

		if(version_compare($this->fromVersion, '1.10.5', '<')) {
			$this->addColumns('serial', "INDEX (`serial_pack_id`)");
		}

		if(version_compare($this->fromVersion, '2.0.0', '<')) {
			$this->addColumns('pack', array(
				"`pack_type` VARCHAR(20) NOT NULL DEFAULT 'serial'",
				"`pack_duration` VARCHAR(25) NOT NULL DEFAULT 0",
			));
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_subscription` (".
				"	`subscription_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`subscription_pack_id` INT(10) NOT NULL,".
				"	`subscription_data` TEXT NOT NULL,".
				"	`subscription_extradata` TEXT NOT NULL,".
				"	`subscription_status` VARCHAR(255) NOT NULL,".
				"	`subscription_created` INT(10) NOT NULL DEFAULT 0,".
				"	`subscription_modified` INT(10) NOT NULL DEFAULT 0,".
				"	`subscription_start_date` INT(10) NOT NULL DEFAULT 0,".
				"	`subscription_end_date` INT(10) NOT NULL DEFAULT 0,".
				"	`subscription_user_id` INT(10) NULL,".
				"	PRIMARY KEY (`subscription_id`),".
				"	KEY `subscription_pack_id` (`subscription_pack_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_order_subscription` (".
				"	`order_subscription_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`subscription_id` INT(10) NOT NULL,".
				"	`order_id` INT(10) NOT NULL,".
				"	`order_product_id` INT(10) NULL,".
				"	`subscription_validated` INT(10) NULL,".
				"	`subscription_duration` VARCHAR(25) NULL,".
				"	PRIMARY KEY (`order_subscription_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_subscription_history` (".
				"	`history_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`history_subscription_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',".
				"	`history_created` INT(10) UNSIGNED NOT NULL DEFAULT '0',".
				"	`history_ip` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_new_status` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_type` VARCHAR(255) NOT NULL DEFAULT '',".
				"	`history_data` TEXT NOT NULL DEFAULT '',".
				"	`history_user_id` INT(10) UNSIGNED DEFAULT '0',".
				"	PRIMARY KEY (`history_id`)".
				") ENGINE=MyISAM;";
			$this->db->setQuery($query);
			$this->db->execute();
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_subscriber` (".
				"	`subscriber_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`subscriber_type` VARCHAR(255) NOT NULL,".
				"	`subscriber_published` INT(4) NOT NULL DEFAULT 0,".
				"	`subscriber_name` VARCHAR(255) NOT NULL,".
				"	`subscriber_ordering` INT(10) NOT NULL DEFAULT 0,".
				"	`subscriber_description` TEXT NOT NULL DEFAULT '',".
				"	`subscriber_params` TEXT NOT NULL DEFAULT '',".
				"	`subscriber_access` VARCHAR(255) NOT NULL DEFAULT 'all',".
				"	PRIMARY KEY (`subscriber_id`)".
				") ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->setQuery($query);
			$this->db->execute();
		}
		if(version_compare($this->fromVersion, '2.0.1', '<')) {
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_queue` (".
				"	`queue_id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,".
				"	`queue_created` INT(11) NOT NULL DEFAULT 0,".
				"	`queue_lock` INT(11) NOT NULL DEFAULT 0,".
				"	`queue_subscription_id` INT(10) UNSIGNED NOT NULL,".
				"	`queue_type` varchar(255) NOT NULL DEFAULT '',".
				"	`queue_data` varchar(1024) NOT NULL DEFAULT '',".
				" 	PRIMARY KEY (`queue_id`)".
				") ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->setQuery($query);
			$this->db->execute();
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_pack_email` (".
				"	`pack_email_id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,".
				"	`pack_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',".
				"	`pack_email_type` varchar(255) NOT NULL DEFAULT 'renewal',".
				"	`pack_email_days` INT(10) UNSIGNED NOT NULL DEFAULT '0',".
				"	`pack_email_template` varchar(255) NOT NULL DEFAULT '',".
				"	`pack_email_params` TEXT NOT NULL DEFAULT '',".
				" 	PRIMARY KEY (`pack_email_id`)".
				") ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->setQuery($query);
			$this->db->execute();
			$this->addColumns('pack', array(
				"`pack_email_inherit` INT(4) NOT NULL DEFAULT 1",
			));
			$this->addColumns('serial', array(
				"`serial_consume_date` INT(10) NULL",
			));
			$this->addColumns('product_pack', array(
				"`relation_type` VARCHAR(20) NULL",
				"`relation_duration` VARCHAR(25) NOT NULL DEFAULT 0",
				"`relation_upgrade` INT(10) NULL",
			));
		}
		if(version_compare($this->fromVersion, '2.0.2', '<')) {
			$this->addColumns('order_subscription', array(
				"`order_product_quantity` INT(10) NULL",
			));
		}
		if(version_compare($this->fromVersion, '2.2.0', '<')) {
			$this->addColumns('order_subscription', array(
				"`plan_id` INT(10) NULL",
				"`upgrade_id` INT(10) NULL",
				"`upgrade_duration` INT(11) NULL",
			));

			$query = 'UPDATE `#__hikaserial_order_subscription` AS `os` '.
				' JOIN `#__hikaserial_subscription` AS `s` ON s.subscription_id = os.subscription_id '.
				' SET os.plan_id = s.subscription_pack_id ';
			$this->db->setQuery($query);
			try {
				$this->db->execute();
			} catch(Exception $e) { }
		}
		if(version_compare($this->fromVersion, '3.0.0', '<')) {
			$this->addColumns('subscription', array(
				"`subscription_auto_renew` INT(4) NOT NULL DEFAULT 0",
				"`subscription_payment_renew` TEXT NULL",
			));
			$this->addColumns('pack', array(
				"`pack_group_id` INT(10) NOT NULL DEFAULT 0"
			));
			$query = "CREATE TABLE IF NOT EXISTS `#__hikaserial_pack_group` (".
				"	`pack_group_id` INT(10) NOT NULL AUTO_INCREMENT,".
				"	`pack_group_name` VARCHAR(255) NOT NULL,".
				"	`pack_group_published` INT(4) NOT NULL DEFAULT 1,".
				"	`pack_group_vendor_id` INT(10) NOT NULL DEFAULT 0,".
				"	`pack_group_manage_access` VARCHAR(255) NOT NULL DEFAULT 'all',".
				"	`pack_group_exclusive` INT(4) NOT NULL DEFAULT 0,".
				"	`pack_group_description` TEXT NULL,".
				"	`pack_group_access` VARCHAR(255) NOT NULL DEFAULT 'all',".
				"	PRIMARY KEY (`pack_group_id`)".
				") ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$this->db->setQuery($query);
			$this->db->execute();
		}
	}

	protected function addColumns($table, $columns) {
		if(!is_array($columns))
			$columns = array($columns);
		$query = 'ALTER TABLE `'.hikaserial::table($table).'` ADD '.implode(', ADD', $columns).';';
		$this->db->setQuery($query);
		$err = false;
		try {
			$this->db->execute();
		} catch(Exception $e) {
			$err = true;
		}
		if(!$err)
			return true;
		if($err && count($columns) > 1) {
			foreach($columns as $col) {
				$query = 'ALTER TABLE `'.hikaserial::table($table).'` ADD '.$col.';';
				$this->db->setQuery($query);
				$err = 0;
				try {
					$this->db->execute();
				} catch(Exception $e) {
					$err++;
				}
			}
			if($err < count($columns))
				return true;
		}
		return false;
	}

	public function displayInfo() {
		$url = 'index.php?option='.HIKASERIAL_COMPONENT.'&ctrl=update&task=install&fromversion='.$this->fromVersion.'&update='.(int)$this->update.'&freshinstall='.(int)$this->freshinstall;
		echo '
<div style="background:#f6f6f6;border:2px solid #f6a833;max-width:100%;text-align:left;border-radius:6px;padding:20px 30px;margin:5px 0px 10px;">
	<h2><img src="'.HIKASERIAL_IMAGES.'icon-48/hikaserial.png" alt=""/> '.HIKASERIAL_NAME.' 4.0.2 <small>'.JText::_('HIKASERIAL_INSTALL_FOR').' HikaShop</small></h2>
<p style="font-size:14px;">
	'.JText::_('HIKASERIAL_INSTALL_MSG1').'<br/>
	'.JText::_('HIKASERIAL_INSTALL_MSG2').'
</p>
<a href="'.$url.'" style="color:#fff; background-color:#f6a833;border:1px solid #e39828;padding:10px 18px;font-size:18px;line-height:1.42;border-radius:4px;text-align:center;display:inline-block;text-decoration:none !important;">
	'.JText::_('HIKASERIAL_INSTALL_CONTINUE').' &raquo;
	</a>
</div>';
	}
}

class hikaserialUninstall {
	private $db;

	public function __construct() {
		$this->db = JFactory::getDBO();
		$this->db->setQuery('DELETE FROM `#__hikaserial_config` WHERE `config_namekey` = \'li\'');
		$this->db->execute();

		$this->db->setQuery('DELETE FROM `#__menu` WHERE link LIKE \'%com_hikaserial%\'');
		$this->db->execute();
	}

	public function unpublishModules() {
		$this->db->setQuery('UPDATE `#__modules` SET `published` = 0 WHERE `module` LIKE \'%hikaserial%\'');
		$this->db->execute();
	}

	public function unpublishPlugins() {
		$this->db->setQuery('UPDATE `#__extensions` SET `enabled` = 0 WHERE `type` = \'plugin\' AND `element` LIKE \'%hikaserial%\' AND `folder` NOT LIKE \'%hikaserial%\'');
		$this->db->execute();
	}
}

function com_install() {
	if(!defined('DS'))
		define('DS', DIRECTORY_SEPARATOR);
	include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php');
	$lang = JFactory::getLanguage();
	$lang->load(HIKASERIAL_COMPONENT,JPATH_SITE);

	$installClass = new hikaserialInstall();
	$installClass->addPref();
	$installClass->updatePref();
	$installClass->updateSQL();
	$installClass->displayInfo();
}

function com_uninstall(){
	$uninstallClass = new hikaserialUninstall();
	$uninstallClass->unpublishModules();
	$uninstallClass->unpublishPlugins();
}

class com_hikaserialInstallerScript {
	public function install($parent) {
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php');
		$lang = JFactory::getLanguage();
		$lang->load(HIKASERIAL_COMPONENT,JPATH_SITE);

		$installClass = new hikaserialInstall();
		$installClass->addPref();
		$installClass->updatePref();
		$installClass->updateSQL();
		$installClass->displayInfo();
	}

	public function update($parent) {
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikaserial'.DS.'helpers'.DS.'helper.php');
		$lang = JFactory::getLanguage();
		$lang->load(HIKASERIAL_COMPONENT,JPATH_SITE);

		$installClass = new hikaserialInstall();
		$installClass->addPref();
		$installClass->updatePref();
		$installClass->updateSQL();
		$installClass->displayInfo();
	}

	public function uninstall($parent)	{
		$uninstallClass = new hikaserialUninstall();
		$uninstallClass->unpublishModules();
		$uninstallClass->unpublishPlugins();
	}

	public function preflight($type, $parent) {
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		$hikashopFile = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php';
		if(!file_exists($hikashopFile)) {
			echo '<h1>This extension works with HikaShop.</h1>'.
				'<h2>Please install HikaShop (starter, essential or business) before installing HikaSerial.</h2>'.
				'installation abort.';
			JFactory::getApplication()->enqueueMessage('Cannot install HikaSerial without HikaShop', 'warning');
			return false;
		}

		include_once($hikashopFile);
		$hikashopConfig = hikashop_config();

		if(version_compare($hikashopConfig->get('version', '1.0'), '4.4.0', '<')) {
			echo '<h1>This extension works with HikaShop 4.4.0 or newer.</h1>'.
				'<h2>Please install the latest version of HikaShop before.</h2>'.
				'installation abort.';
			if($type == 'update')
				JFactory::getApplication()->enqueueMessage('Cannot update HikaSerial 4.0.2 without HikaShop 4.4.0 or newer', 'warning');
			else
				JFactory::getApplication()->enqueueMessage('Cannot install HikaSerial 4.0.2 without HikaShop 4.4.0 or newer', 'warning');

			$joomConf = JFactory::getConfig();
			$debug = $joomConf->get('debug');
			if($debug) {
				throw new Exception('Cannot install HikaSerial 4.0.2 without HikaShop 4.4.0 or newer', 500);
			}
			return false;
		}
		return true;
	}

	public function postflight($type, $parent) {
		return true;
	}
}
